/* compiler.c generated by valac, the Vala compiler
 * generated from compiler.vala, do not modify */

/* compiler.vala
 *
 * Copyright (C) 2008-2010 Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>


#define VALIDE_TYPE_EXECUTABLE (valide_executable_get_type ())
#define VALIDE_EXECUTABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_EXECUTABLE, ValideExecutable))
#define VALIDE_EXECUTABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_EXECUTABLE, ValideExecutableClass))
#define VALIDE_IS_EXECUTABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_EXECUTABLE))
#define VALIDE_IS_EXECUTABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_EXECUTABLE))
#define VALIDE_EXECUTABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_EXECUTABLE, ValideExecutableClass))

typedef struct _ValideExecutable ValideExecutable;
typedef struct _ValideExecutableClass ValideExecutableClass;
typedef struct _ValideExecutablePrivate ValideExecutablePrivate;

#define VALIDE_TYPE_COMPILER (valide_compiler_get_type ())
#define VALIDE_COMPILER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_COMPILER, ValideCompiler))
#define VALIDE_COMPILER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_COMPILER, ValideCompilerClass))
#define VALIDE_IS_COMPILER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_COMPILER))
#define VALIDE_IS_COMPILER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_COMPILER))
#define VALIDE_COMPILER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_COMPILER, ValideCompilerClass))

typedef struct _ValideCompiler ValideCompiler;
typedef struct _ValideCompilerClass ValideCompilerClass;
typedef struct _ValideCompilerPrivate ValideCompilerPrivate;

#define VALIDE_TYPE_POSITION (valide_position_get_type ())
typedef struct _ValidePosition ValidePosition;

#define VALIDE_TYPE_PROJECT (valide_project_get_type ())
#define VALIDE_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PROJECT, ValideProject))
#define VALIDE_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PROJECT, ValideProjectClass))
#define VALIDE_IS_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PROJECT))
#define VALIDE_IS_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PROJECT))
#define VALIDE_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PROJECT, ValideProjectClass))

typedef struct _ValideProject ValideProject;
typedef struct _ValideProjectClass ValideProjectClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_match_info_free0(var) ((var == NULL) ? NULL : (var = (g_match_info_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define VALIDE_TYPE_DOCUMENT (valide_document_get_type ())
#define VALIDE_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_DOCUMENT, ValideDocument))
#define VALIDE_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_DOCUMENT, ValideDocumentClass))
#define VALIDE_IS_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_DOCUMENT))
#define VALIDE_IS_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_DOCUMENT))
#define VALIDE_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_DOCUMENT, ValideDocumentClass))

typedef struct _ValideDocument ValideDocument;
typedef struct _ValideDocumentClass ValideDocumentClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	VALIDE_ERROR_PARSING_FILE,
	VALIDE_ERROR_PARSING_LINE
} ValideErrorParsing;
#define VALIDE_ERROR_PARSING valide_error_parsing_quark ()
struct _ValideExecutable {
	GObject parent_instance;
	ValideExecutablePrivate * priv;
};

struct _ValideExecutableClass {
	GObjectClass parent_class;
	char* (*get_start_msg) (ValideExecutable* self);
	char* (*get_end_msg) (ValideExecutable* self);
	void (*get_color_line) (ValideExecutable* self, char** line, GdkColor* color);
	void (*line_activated) (ValideExecutable* self, const char* line);
	const char* (*get_executable) (ValideExecutable* self);
	void (*set_executable) (ValideExecutable* self, const char* value);
};

struct _ValidePosition {
	gint start_line;
	gint end_line;
	gint start_row;
	gint end_row;
};

struct _ValideCompiler {
	ValideExecutable parent_instance;
	ValideCompilerPrivate * priv;
};

struct _ValideCompilerClass {
	ValideExecutableClass parent_class;
	char* (*get_file) (ValideCompiler* self, const char* line, GError** error);
	void (*get_line) (ValideCompiler* self, const char* line, ValidePosition* pos, GError** error);
};

struct _ValideCompilerPrivate {
	ValideProject* _project;
};


static gpointer valide_compiler_parent_class = NULL;

GQuark valide_error_parsing_quark (void);
GType valide_executable_get_type (void);
GType valide_compiler_get_type (void);
GType valide_position_get_type (void);
ValidePosition* valide_position_dup (const ValidePosition* self);
void valide_position_free (ValidePosition* self);
GType valide_project_get_type (void);
#define VALIDE_COMPILER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALIDE_TYPE_COMPILER, ValideCompilerPrivate))
enum  {
	VALIDE_COMPILER_DUMMY_PROPERTY,
	VALIDE_COMPILER_PROJECT,
	VALIDE_COMPILER_EXECUTABLE
};
#define VALIDE_COMPILER_EXECUTABLE_PATH "valac -q"
char* valide_compiler_get_file (ValideCompiler* self, const char* line, GError** error);
static char* valide_compiler_real_get_file (ValideCompiler* self, const char* line, GError** error);
void valide_compiler_get_line (ValideCompiler* self, const char* line, ValidePosition* pos, GError** error);
static void valide_compiler_real_get_line (ValideCompiler* self, const char* line, ValidePosition* pos, GError** error);
#define VALIDE_UTILS_COLOR_ERROR "#FF0000"
#define VALIDE_UTILS_COLOR_SUCCESS "#19A630"
#define VALIDE_UTILS_COLOR_WARNING "#ED7F10"
void valide_executable_get_color_line (ValideExecutable* self, char** line, GdkColor* color);
static void valide_compiler_real_get_color_line (ValideExecutable* base, char** line, GdkColor* color);
char* valide_executable_get_start_msg (ValideExecutable* self);
char* valide_executable_get_end_msg (ValideExecutable* self);
ValideProject* valide_compiler_get_project (ValideCompiler* self);
GType valide_document_get_type (void);
ValideDocument* valide_project_open_file (ValideProject* self, const char* filename, GError** error);
void valide_document_select_range (ValideDocument* self, ValidePosition* pos);
static void valide_compiler_real_line_activated (ValideExecutable* base, const char* line);
ValideCompiler* valide_compiler_new (ValideProject* project);
ValideCompiler* valide_compiler_construct (GType object_type, ValideProject* project);
static void valide_compiler_set_project (ValideCompiler* self, ValideProject* value);
static void valide_compiler_finalize (GObject* obj);
const char* valide_executable_get_executable (ValideExecutable* self);
static void valide_compiler_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
void valide_executable_set_executable (ValideExecutable* self, const char* value);
static void valide_compiler_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);



GQuark valide_error_parsing_quark (void) {
	return g_quark_from_static_string ("valide_error_parsing-quark");
}


#line 59 "compiler.vala"
static char* valide_compiler_real_get_file (ValideCompiler* self, const char* line, GError** error) {
#line 181 "compiler.c"
	char* result = NULL;
	GError * _inner_error_;
	gint _fields_size_;
	gint fields_length1;
	char** fields;
	char** _tmp1_;
	char** _tmp0_;
#line 59 "compiler.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 59 "compiler.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 193 "compiler.c"
	_inner_error_ = NULL;
	fields = (fields_length1 = 0, NULL);
#line 63 "compiler.vala"
	fields = (_tmp1_ = _tmp0_ = g_strsplit (line, ":", -1), fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL), fields_length1 = _vala_array_length (_tmp0_), _fields_size_ = fields_length1, _tmp1_);
#line 64 "compiler.vala"
	if (g_strv_length (fields) < 2) {
#line 200 "compiler.c"
		_inner_error_ = g_error_new_literal (VALIDE_ERROR_PARSING, VALIDE_ERROR_PARSING_FILE, line);
		{
			g_propagate_error (error, _inner_error_);
			fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
			return NULL;
		}
	}
	result = g_strdup (fields[0]);
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 68 "compiler.vala"
	return result;
#line 212 "compiler.c"
}


#line 59 "compiler.vala"
char* valide_compiler_get_file (ValideCompiler* self, const char* line, GError** error) {
#line 59 "compiler.vala"
	return VALIDE_COMPILER_GET_CLASS (self)->get_file (self, line, error);
#line 220 "compiler.c"
}


#line 77 "compiler.vala"
static void valide_compiler_real_get_line (ValideCompiler* self, const char* line, ValidePosition* pos, GError** error) {
#line 226 "compiler.c"
	GError * _inner_error_;
	GRegex* regex;
	GMatchInfo* match_info;
	ValidePosition _tmp0_ = {0};
	GRegex* _tmp1_;
	GRegex* _tmp2_;
	GMatchInfo* _tmp4_;
	GMatchInfo* _tmp3_ = NULL;
	gint i;
#line 77 "compiler.vala"
	g_return_if_fail (self != NULL);
#line 77 "compiler.vala"
	g_return_if_fail (line != NULL);
#line 240 "compiler.c"
	_inner_error_ = NULL;
	regex = NULL;
	match_info = NULL;
#line 82 "compiler.vala"
	*pos = (memset (&_tmp0_, 0, sizeof (ValidePosition)), _tmp0_);
#line 83 "compiler.vala"
	_tmp1_ = g_regex_new ("([\\d]+)", G_REGEX_OPTIMIZE, G_REGEX_MATCH_NOTEMPTY, &_inner_error_);
#line 248 "compiler.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_regex_unref0 (regex);
		_g_match_info_free0 (match_info);
		return;
	}
#line 83 "compiler.vala"
	regex = (_tmp2_ = _tmp1_, _g_regex_unref0 (regex), _tmp2_);
#line 87 "compiler.vala"
	g_regex_match (regex, line, 0, &_tmp3_);
#line 87 "compiler.vala"
	match_info = (_tmp4_ = _tmp3_, _g_match_info_free0 (match_info), _tmp4_);
#line 89 "compiler.vala"
	i = 0;
#line 90 "compiler.vala"
	while (TRUE) {
#line 90 "compiler.vala"
		if (!g_match_info_matches (match_info)) {
#line 90 "compiler.vala"
			break;
#line 269 "compiler.c"
		}
#line 92 "compiler.vala"
		switch (i) {
#line 273 "compiler.c"
			case 0:
			{
				char* _tmp5_;
#line 95 "compiler.vala"
				(*pos).start_line = atoi (_tmp5_ = g_match_info_fetch (match_info, 0)) - 1;
#line 279 "compiler.c"
				_g_free0 (_tmp5_);
#line 96 "compiler.vala"
				break;
#line 283 "compiler.c"
			}
			case 1:
			{
				char* _tmp6_;
#line 98 "compiler.vala"
				(*pos).start_row = atoi (_tmp6_ = g_match_info_fetch (match_info, 0)) - 1;
#line 290 "compiler.c"
				_g_free0 (_tmp6_);
#line 99 "compiler.vala"
				break;
#line 294 "compiler.c"
			}
			case 2:
			{
				char* _tmp7_;
#line 101 "compiler.vala"
				(*pos).end_line = atoi (_tmp7_ = g_match_info_fetch (match_info, 0)) - 1;
#line 301 "compiler.c"
				_g_free0 (_tmp7_);
#line 102 "compiler.vala"
				break;
#line 305 "compiler.c"
			}
			case 3:
			{
				char* _tmp8_;
#line 104 "compiler.vala"
				(*pos).end_row = atoi (_tmp8_ = g_match_info_fetch (match_info, 0));
#line 312 "compiler.c"
				_g_free0 (_tmp8_);
#line 105 "compiler.vala"
				break;
#line 316 "compiler.c"
			}
		}
#line 107 "compiler.vala"
		i++;
#line 108 "compiler.vala"
		g_match_info_next (match_info, &_inner_error_);
#line 323 "compiler.c"
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_regex_unref0 (regex);
			_g_match_info_free0 (match_info);
			return;
		}
	}
#line 110 "compiler.vala"
	if (i < 4) {
#line 112 "compiler.vala"
		(*pos).end_line = (*pos).start_line;
#line 113 "compiler.vala"
		(*pos).start_row = (*pos).end_row = 0;
#line 337 "compiler.c"
	}
	_g_regex_unref0 (regex);
	_g_match_info_free0 (match_info);
}


#line 77 "compiler.vala"
void valide_compiler_get_line (ValideCompiler* self, const char* line, ValidePosition* pos, GError** error) {
#line 77 "compiler.vala"
	VALIDE_COMPILER_GET_CLASS (self)->get_line (self, line, pos, error);
#line 348 "compiler.c"
}


#line 120 "compiler.vala"
static void valide_compiler_real_get_color_line (ValideExecutable* base, char** line, GdkColor* color) {
#line 354 "compiler.c"
	ValideCompiler * self;
	self = (ValideCompiler*) base;
#line 120 "compiler.vala"
	g_return_if_fail (line != NULL);
#line 122 "compiler.vala"
	if (g_str_has_prefix (*line, "Compilation failed")) {
#line 124 "compiler.vala"
		gdk_color_parse (VALIDE_UTILS_COLOR_ERROR, color);
#line 363 "compiler.c"
	} else {
#line 126 "compiler.vala"
		if (strstr (*line, "error:") != NULL) {
#line 128 "compiler.vala"
			gdk_color_parse (VALIDE_UTILS_COLOR_ERROR, color);
#line 369 "compiler.c"
		} else {
#line 130 "compiler.vala"
			if (g_str_has_prefix (*line, "Compilation succeeded")) {
#line 132 "compiler.vala"
				gdk_color_parse (VALIDE_UTILS_COLOR_SUCCESS, color);
#line 375 "compiler.c"
			} else {
#line 134 "compiler.vala"
				if (strstr (*line, "warning:") != NULL) {
#line 136 "compiler.vala"
					gdk_color_parse (VALIDE_UTILS_COLOR_WARNING, color);
#line 381 "compiler.c"
				} else {
#line 140 "compiler.vala"
					VALIDE_EXECUTABLE_CLASS (valide_compiler_parent_class)->get_color_line (VALIDE_EXECUTABLE (self), line, color);
#line 385 "compiler.c"
				}
			}
		}
	}
}


#line 147 "compiler.vala"
static void valide_compiler_real_line_activated (ValideExecutable* base, const char* line) {
#line 395 "compiler.c"
	ValideCompiler * self;
	GError * _inner_error_;
	gboolean _tmp0_ = FALSE;
	char* _tmp1_;
	gboolean _tmp2_;
	self = (ValideCompiler*) base;
#line 147 "compiler.vala"
	g_return_if_fail (line != NULL);
#line 404 "compiler.c"
	_inner_error_ = NULL;
#line 149 "compiler.vala"
	if ((_tmp2_ = _vala_strcmp0 (line, _tmp1_ = valide_executable_get_start_msg ((ValideExecutable*) self)) != 0, _g_free0 (_tmp1_), _tmp2_)) {
#line 408 "compiler.c"
		char* _tmp3_;
#line 149 "compiler.vala"
		_tmp0_ = _vala_strcmp0 (line, _tmp3_ = valide_executable_get_end_msg ((ValideExecutable*) self)) != 0;
#line 412 "compiler.c"
		_g_free0 (_tmp3_);
	} else {
#line 149 "compiler.vala"
		_tmp0_ = FALSE;
#line 417 "compiler.c"
	}
#line 149 "compiler.vala"
	if (_tmp0_) {
#line 421 "compiler.c"
		{
#line 153 "compiler.vala"
			if (self->priv->_project != NULL) {
#line 425 "compiler.c"
				char* file;
				ValideDocument* document;
				char* _tmp4_;
				char* _tmp5_;
				ValideDocument* _tmp6_;
				ValideDocument* _tmp7_;
				file = NULL;
				document = NULL;
#line 158 "compiler.vala"
				_tmp4_ = valide_compiler_get_file (self, line, &_inner_error_);
#line 436 "compiler.c"
				if (_inner_error_ != NULL) {
					_g_free0 (file);
					_g_object_unref0 (document);
					goto __catch3_g_error;
				}
#line 158 "compiler.vala"
				file = (_tmp5_ = _tmp4_, _g_free0 (file), _tmp5_);
#line 159 "compiler.vala"
				_tmp6_ = valide_project_open_file (self->priv->_project, file, &_inner_error_);
#line 446 "compiler.c"
				if (_inner_error_ != NULL) {
					_g_free0 (file);
					_g_object_unref0 (document);
					goto __catch3_g_error;
				}
#line 159 "compiler.vala"
				document = (_tmp7_ = _tmp6_, _g_object_unref0 (document), _tmp7_);
#line 454 "compiler.c"
				{
					ValidePosition pos = {0};
#line 164 "compiler.vala"
					valide_compiler_get_line (self, line, &pos, &_inner_error_);
#line 459 "compiler.c"
					if (_inner_error_ != NULL) {
						goto __catch4_g_error;
					}
#line 165 "compiler.vala"
					valide_document_select_range (document, &pos);
#line 166 "compiler.vala"
					gtk_widget_grab_focus ((GtkWidget*) document);
#line 467 "compiler.c"
				}
				goto __finally4;
				__catch4_g_error:
				{
					GError * e;
					e = _inner_error_;
					_inner_error_ = NULL;
					{
#line 170 "compiler.vala"
						g_debug ("compiler.vala:170: %s", e->message);
#line 478 "compiler.c"
						_g_error_free0 (e);
					}
				}
				__finally4:
				if (_inner_error_ != NULL) {
					_g_free0 (file);
					_g_object_unref0 (document);
					goto __catch3_g_error;
				}
				_g_free0 (file);
				_g_object_unref0 (document);
			}
		}
		goto __finally3;
		__catch3_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
#line 176 "compiler.vala"
				g_warning ("compiler.vala:176: %s", e->message);
#line 501 "compiler.c"
				_g_error_free0 (e);
			}
		}
		__finally3:
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


#line 186 "compiler.vala"
ValideCompiler* valide_compiler_construct (GType object_type, ValideProject* project) {
#line 517 "compiler.c"
	ValideCompiler * self;
#line 186 "compiler.vala"
	g_return_val_if_fail (project != NULL, NULL);
#line 188 "compiler.vala"
	self = (ValideCompiler*) g_object_new (object_type, "project", project, NULL);
#line 523 "compiler.c"
	return self;
}


#line 186 "compiler.vala"
ValideCompiler* valide_compiler_new (ValideProject* project) {
#line 186 "compiler.vala"
	return valide_compiler_construct (VALIDE_TYPE_COMPILER, project);
#line 532 "compiler.c"
}


ValideProject* valide_compiler_get_project (ValideCompiler* self) {
	ValideProject* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_project;
#line 38 "compiler.vala"
	return result;
#line 542 "compiler.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void valide_compiler_set_project (ValideCompiler* self, ValideProject* value) {
	ValideProject* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_project = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_project), _tmp0_);
	g_object_notify ((GObject *) self, "project");
}


static const char* valide_compiler_real_get_executable (ValideExecutable* base) {
	const char* result;
	ValideCompiler* self;
	self = (ValideCompiler*) base;
	result = VALIDE_COMPILER_EXECUTABLE_PATH;
#line 48 "compiler.vala"
	return result;
#line 566 "compiler.c"
}


static void valide_compiler_real_set_executable (ValideExecutable* base, const char* value) {
	ValideCompiler* self;
	self = (ValideCompiler*) base;
	g_object_notify ((GObject *) self, "executable");
}


static void valide_compiler_class_init (ValideCompilerClass * klass) {
	valide_compiler_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValideCompilerPrivate));
	VALIDE_COMPILER_CLASS (klass)->get_file = valide_compiler_real_get_file;
	VALIDE_COMPILER_CLASS (klass)->get_line = valide_compiler_real_get_line;
	VALIDE_EXECUTABLE_CLASS (klass)->get_color_line = valide_compiler_real_get_color_line;
	VALIDE_EXECUTABLE_CLASS (klass)->line_activated = valide_compiler_real_line_activated;
	VALIDE_EXECUTABLE_CLASS (klass)->get_executable = valide_compiler_real_get_executable;
	VALIDE_EXECUTABLE_CLASS (klass)->set_executable = valide_compiler_real_set_executable;
	G_OBJECT_CLASS (klass)->get_property = valide_compiler_get_property;
	G_OBJECT_CLASS (klass)->set_property = valide_compiler_set_property;
	G_OBJECT_CLASS (klass)->finalize = valide_compiler_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_COMPILER_PROJECT, g_param_spec_object ("project", "project", "project", VALIDE_TYPE_PROJECT, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_override_property (G_OBJECT_CLASS (klass), VALIDE_COMPILER_EXECUTABLE, "executable");
}


static void valide_compiler_instance_init (ValideCompiler * self) {
	self->priv = VALIDE_COMPILER_GET_PRIVATE (self);
}


static void valide_compiler_finalize (GObject* obj) {
	ValideCompiler * self;
	self = VALIDE_COMPILER (obj);
	_g_object_unref0 (self->priv->_project);
	G_OBJECT_CLASS (valide_compiler_parent_class)->finalize (obj);
}


GType valide_compiler_get_type (void) {
	static volatile gsize valide_compiler_type_id__volatile = 0;
	if (g_once_init_enter (&valide_compiler_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideCompilerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_compiler_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideCompiler), 0, (GInstanceInitFunc) valide_compiler_instance_init, NULL };
		GType valide_compiler_type_id;
		valide_compiler_type_id = g_type_register_static (VALIDE_TYPE_EXECUTABLE, "ValideCompiler", &g_define_type_info, 0);
		g_once_init_leave (&valide_compiler_type_id__volatile, valide_compiler_type_id);
	}
	return valide_compiler_type_id__volatile;
}


static void valide_compiler_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValideCompiler * self;
	self = VALIDE_COMPILER (object);
	switch (property_id) {
		case VALIDE_COMPILER_PROJECT:
		g_value_set_object (value, valide_compiler_get_project (self));
		break;
		case VALIDE_COMPILER_EXECUTABLE:
		g_value_set_string (value, valide_executable_get_executable ((ValideExecutable*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void valide_compiler_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValideCompiler * self;
	self = VALIDE_COMPILER (object);
	switch (property_id) {
		case VALIDE_COMPILER_PROJECT:
		valide_compiler_set_project (self, g_value_get_object (value));
		break;
		case VALIDE_COMPILER_EXECUTABLE:
		valide_executable_set_executable ((ValideExecutable*) self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




