/* document-message.c generated by valac, the Vala compiler
 * generated from document-message.vala, do not modify */

/* document-message.vala
 *
 * Copyright (C) 2008-2010 Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>


#define VALIDE_TYPE_DOCUMENT_MESSAGE (valide_document_message_get_type ())
#define VALIDE_DOCUMENT_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_DOCUMENT_MESSAGE, ValideDocumentMessage))
#define VALIDE_DOCUMENT_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_DOCUMENT_MESSAGE, ValideDocumentMessageClass))
#define VALIDE_IS_DOCUMENT_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_DOCUMENT_MESSAGE))
#define VALIDE_IS_DOCUMENT_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_DOCUMENT_MESSAGE))
#define VALIDE_DOCUMENT_MESSAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_DOCUMENT_MESSAGE, ValideDocumentMessageClass))

typedef struct _ValideDocumentMessage ValideDocumentMessage;
typedef struct _ValideDocumentMessageClass ValideDocumentMessageClass;
typedef struct _ValideDocumentMessagePrivate ValideDocumentMessagePrivate;

#define VALIDE_TYPE_DOCUMENT (valide_document_get_type ())
#define VALIDE_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_DOCUMENT, ValideDocument))
#define VALIDE_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_DOCUMENT, ValideDocumentClass))
#define VALIDE_IS_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_DOCUMENT))
#define VALIDE_IS_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_DOCUMENT))
#define VALIDE_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_DOCUMENT, ValideDocumentClass))

typedef struct _ValideDocument ValideDocument;
typedef struct _ValideDocumentClass ValideDocumentClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define VALIDE_TYPE_DOCUMENT_STATE (valide_document_state_get_type ())

struct _ValideDocumentMessage {
	GtkInfoBar parent_instance;
	ValideDocumentMessagePrivate * priv;
};

struct _ValideDocumentMessageClass {
	GtkInfoBarClass parent_class;
};

struct _ValideDocumentMessagePrivate {
	GtkImage* image;
	GtkLabel* primary_label;
	GtkLabel* secondary_label;
	ValideDocument* _document;
};

typedef enum  {
	VALIDE_DOCUMENT_STATE_NORMAL,
	VALIDE_DOCUMENT_STATE_EXTERNALLY_MODIFIED,
	VALIDE_DOCUMENT_STATE_BAD_ENCODING,
	VALIDE_DOCUMENT_STATE_INFO
} ValideDocumentState;


static gpointer valide_document_message_parent_class = NULL;

GType valide_document_message_get_type (void);
GType valide_document_get_type (void);
#define VALIDE_DOCUMENT_MESSAGE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALIDE_TYPE_DOCUMENT_MESSAGE, ValideDocumentMessagePrivate))
enum  {
	VALIDE_DOCUMENT_MESSAGE_DUMMY_PROPERTY,
	VALIDE_DOCUMENT_MESSAGE_DOCUMENT
};
ValideDocumentMessage* valide_document_message_new (ValideDocument* document);
ValideDocumentMessage* valide_document_message_construct (GType object_type, ValideDocument* document);
ValideDocument* valide_document_message_get_document (ValideDocumentMessage* self);
static void valide_document_message_set_document (ValideDocumentMessage* self, ValideDocument* value);
static void _lambda5_ (ValideDocumentMessage* self);
static void __lambda5__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
GType valide_document_state_get_type (void);
void valide_document_set_state (ValideDocument* self, ValideDocumentState value);
void valide_document_reload (ValideDocument* self);
void valide_document_set_is_save (ValideDocument* self, gboolean value);
static void _lambda6_ (gint rid, ValideDocumentMessage* self);
static void __lambda6__gtk_info_bar_response (GtkInfoBar* _sender, gint response_id, gpointer self);
ValideDocumentState valide_document_get_state (ValideDocument* self);
const char* valide_document_get_path (ValideDocument* self);
gboolean valide_document_get_is_save (ValideDocument* self);
static GObject * valide_document_message_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void valide_document_message_finalize (GObject* obj);
static void valide_document_message_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void valide_document_message_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



#line 45 "document-message.vala"
ValideDocumentMessage* valide_document_message_construct (GType object_type, ValideDocument* document) {
#line 118 "document-message.c"
	ValideDocumentMessage * self;
#line 45 "document-message.vala"
	g_return_val_if_fail (document != NULL, NULL);
#line 47 "document-message.vala"
	self = (ValideDocumentMessage*) g_object_new (object_type, "document", document, NULL);
#line 124 "document-message.c"
	return self;
}


#line 45 "document-message.vala"
ValideDocumentMessage* valide_document_message_new (ValideDocument* document) {
#line 45 "document-message.vala"
	return valide_document_message_construct (VALIDE_TYPE_DOCUMENT_MESSAGE, document);
#line 133 "document-message.c"
}


ValideDocument* valide_document_message_get_document (ValideDocumentMessage* self) {
	ValideDocument* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_document;
#line 37 "document-message.vala"
	return result;
#line 143 "document-message.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void valide_document_message_set_document (ValideDocumentMessage* self, ValideDocument* value) {
	ValideDocument* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_document = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_document), _tmp0_);
	g_object_notify ((GObject *) self, "document");
}


#line 62 "document-message.vala"
static void _lambda5_ (ValideDocumentMessage* self) {
#line 162 "document-message.c"
	char* stock_id;
	stock_id = NULL;
#line 65 "document-message.vala"
	switch (gtk_info_bar_get_message_type ((GtkInfoBar*) self)) {
#line 167 "document-message.c"
		case GTK_MESSAGE_INFO:
		{
			char* _tmp0_;
#line 68 "document-message.vala"
			stock_id = (_tmp0_ = g_strdup (GTK_STOCK_DIALOG_INFO), _g_free0 (stock_id), _tmp0_);
#line 69 "document-message.vala"
			break;
#line 175 "document-message.c"
		}
		case GTK_MESSAGE_WARNING:
		{
			char* _tmp1_;
#line 71 "document-message.vala"
			stock_id = (_tmp1_ = g_strdup (GTK_STOCK_DIALOG_WARNING), _g_free0 (stock_id), _tmp1_);
#line 72 "document-message.vala"
			break;
#line 184 "document-message.c"
		}
		case GTK_MESSAGE_QUESTION:
		{
			char* _tmp2_;
#line 74 "document-message.vala"
			stock_id = (_tmp2_ = g_strdup (GTK_STOCK_DIALOG_QUESTION), _g_free0 (stock_id), _tmp2_);
#line 75 "document-message.vala"
			break;
#line 193 "document-message.c"
		}
		case GTK_MESSAGE_ERROR:
		{
			char* _tmp3_;
#line 77 "document-message.vala"
			stock_id = (_tmp3_ = g_strdup (GTK_STOCK_DIALOG_ERROR), _g_free0 (stock_id), _tmp3_);
#line 78 "document-message.vala"
			break;
#line 202 "document-message.c"
		}
		default:
		{
			char* _tmp4_;
#line 81 "document-message.vala"
			stock_id = (_tmp4_ = g_strdup (GTK_STOCK_DISCARD), _g_free0 (stock_id), _tmp4_);
#line 82 "document-message.vala"
			break;
#line 211 "document-message.c"
		}
	}
#line 84 "document-message.vala"
	gtk_image_set_from_stock (self->priv->image, stock_id, GTK_ICON_SIZE_DIALOG);
#line 216 "document-message.c"
	_g_free0 (stock_id);
}


#line 62 "document-message.vala"
static void __lambda5__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
#line 223 "document-message.c"
	_lambda5_ (self);
}


#line 105 "document-message.vala"
static void _lambda6_ (gint rid, ValideDocumentMessage* self) {
#line 106 "document-message.vala"
	gtk_widget_grab_focus ((GtkWidget*) self->priv->_document);
#line 107 "document-message.vala"
	valide_document_set_state (self->priv->_document, VALIDE_DOCUMENT_STATE_NORMAL);
#line 108 "document-message.vala"
	if (rid == GTK_RESPONSE_ACCEPT) {
#line 110 "document-message.vala"
		valide_document_reload (self->priv->_document);
#line 238 "document-message.c"
	} else {
#line 114 "document-message.vala"
		valide_document_set_is_save (self->priv->_document, FALSE);
#line 242 "document-message.c"
	}
#line 116 "document-message.vala"
	gtk_object_destroy ((GtkObject*) self);
#line 246 "document-message.c"
}


#line 105 "document-message.vala"
static void __lambda6__gtk_info_bar_response (GtkInfoBar* _sender, gint response_id, gpointer self) {
#line 252 "document-message.c"
	_lambda6_ (response_id, self);
}


static GObject * valide_document_message_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	ValideDocumentMessage * self;
	parent_class = G_OBJECT_CLASS (valide_document_message_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = VALIDE_DOCUMENT_MESSAGE (obj);
	{
		char* text;
		GtkHBox* hbox;
		GtkVBox* vbox;
		GtkContainer* content_area;
		GtkContainer* _tmp1_;
		GtkWidget* _tmp0_;
		GtkHBox* _tmp2_;
		GtkImage* _tmp3_;
		GtkVBox* _tmp4_;
		GtkLabel* _tmp5_;
		GtkLabel* _tmp6_;
		text = NULL;
		hbox = NULL;
		vbox = NULL;
		content_area = NULL;
#line 57 "document-message.vala"
		content_area = (_tmp1_ = _g_object_ref0 ((_tmp0_ = gtk_info_bar_get_content_area ((GtkInfoBar*) self), GTK_IS_CONTAINER (_tmp0_) ? ((GtkContainer*) _tmp0_) : NULL)), _g_object_unref0 (content_area), _tmp1_);
#line 58 "document-message.vala"
		hbox = (_tmp2_ = g_object_ref_sink ((GtkHBox*) gtk_hbox_new (FALSE, 5)), _g_object_unref0 (hbox), _tmp2_);
#line 59 "document-message.vala"
		gtk_container_add (content_area, (GtkWidget*) hbox);
#line 61 "document-message.vala"
		self->priv->image = (_tmp3_ = g_object_ref_sink ((GtkImage*) gtk_image_new ()), _g_object_unref0 (self->priv->image), _tmp3_);
#line 62 "document-message.vala"
		g_signal_connect_object ((GObject*) self, "notify::message-type", (GCallback) __lambda5__g_object_notify, self, 0);
#line 86 "document-message.vala"
		gtk_box_pack_start ((GtkBox*) hbox, (GtkWidget*) self->priv->image, FALSE, TRUE, (guint) 0);
#line 88 "document-message.vala"
		vbox = (_tmp4_ = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 0)), _g_object_unref0 (vbox), _tmp4_);
#line 89 "document-message.vala"
		gtk_box_pack_start ((GtkBox*) hbox, (GtkWidget*) vbox, TRUE, TRUE, (guint) 0);
#line 91 "document-message.vala"
		self->priv->primary_label = (_tmp5_ = g_object_ref_sink ((GtkLabel*) gtk_label_new ("")), _g_object_unref0 (self->priv->primary_label), _tmp5_);
#line 92 "document-message.vala"
		gtk_misc_set_alignment ((GtkMisc*) self->priv->primary_label, (float) 0, 0.5f);
#line 93 "document-message.vala"
		gtk_label_set_justify (self->priv->primary_label, GTK_JUSTIFY_LEFT);
#line 94 "document-message.vala"
		gtk_label_set_line_wrap (self->priv->primary_label, TRUE);
#line 95 "document-message.vala"
		gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) self->priv->primary_label, TRUE, TRUE, (guint) 0);
#line 97 "document-message.vala"
		self->priv->secondary_label = (_tmp6_ = g_object_ref_sink ((GtkLabel*) gtk_label_new ("")), _g_object_unref0 (self->priv->secondary_label), _tmp6_);
#line 98 "document-message.vala"
		gtk_misc_set_alignment ((GtkMisc*) self->priv->secondary_label, (float) 0, 0.5f);
#line 99 "document-message.vala"
		gtk_label_set_justify (self->priv->secondary_label, GTK_JUSTIFY_LEFT);
#line 100 "document-message.vala"
		gtk_label_set_line_wrap (self->priv->secondary_label, TRUE);
#line 101 "document-message.vala"
		gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) self->priv->secondary_label, FALSE, TRUE, (guint) 0);
#line 103 "document-message.vala"
		gtk_info_bar_add_button ((GtkInfoBar*) self, GTK_STOCK_REFRESH, (gint) GTK_RESPONSE_ACCEPT);
#line 104 "document-message.vala"
		gtk_info_bar_add_button ((GtkInfoBar*) self, GTK_STOCK_CANCEL, (gint) GTK_RESPONSE_CANCEL);
#line 105 "document-message.vala"
		g_signal_connect_object ((GtkInfoBar*) self, "response", (GCallback) __lambda6__gtk_info_bar_response, self, 0);
#line 119 "document-message.vala"
		switch (valide_document_get_state (self->priv->_document)) {
#line 324 "document-message.c"
			case VALIDE_DOCUMENT_STATE_EXTERNALLY_MODIFIED:
			{
				char* _tmp7_;
#line 122 "document-message.vala"
				text = (_tmp7_ = g_strdup_printf (_ ("The file %s changed on disk."), valide_document_get_path (self->priv->_document)), _g_free0 (text), _tmp7_);
#line 123 "document-message.vala"
				gtk_label_set_text (self->priv->primary_label, text);
#line 125 "document-message.vala"
				if (!valide_document_get_is_save (self->priv->_document)) {
#line 334 "document-message.c"
					char* _tmp8_;
#line 127 "document-message.vala"
					text = (_tmp8_ = g_strdup (_ ("Do you want to drop your changes and reload the file?")), _g_free0 (text), _tmp8_);
#line 338 "document-message.c"
				} else {
					char* _tmp9_;
#line 131 "document-message.vala"
					text = (_tmp9_ = g_strdup (_ ("Do you want to reload the file?")), _g_free0 (text), _tmp9_);
#line 343 "document-message.c"
				}
#line 133 "document-message.vala"
				gtk_label_set_text (self->priv->secondary_label, text);
#line 134 "document-message.vala"
				gtk_info_bar_set_message_type ((GtkInfoBar*) self, GTK_MESSAGE_WARNING);
#line 135 "document-message.vala"
				break;
#line 351 "document-message.c"
			}
			case VALIDE_DOCUMENT_STATE_BAD_ENCODING:
			{
				char* _tmp10_;
				char* _tmp11_;
#line 137 "document-message.vala"
				text = (_tmp10_ = g_strdup_printf (_ ("Couldn't open the file %s."), valide_document_get_path (self->priv->_document)), _g_free0 (text), _tmp10_);
#line 138 "document-message.vala"
				gtk_label_set_text (self->priv->primary_label, text);
#line 140 "document-message.vala"
				text = (_tmp11_ = g_strdup (_ ("Val(a)IDE has not been able to detect the character coding.\n" \
"Please check that you are not trying to open a binary file.")), _g_free0 (text), _tmp11_);
#line 141 "document-message.vala"
				gtk_label_set_text (self->priv->secondary_label, text);
#line 142 "document-message.vala"
				gtk_info_bar_set_message_type ((GtkInfoBar*) self, GTK_MESSAGE_ERROR);
#line 143 "document-message.vala"
				break;
#line 369 "document-message.c"
			}
		}
		_g_free0 (text);
		_g_object_unref0 (hbox);
		_g_object_unref0 (vbox);
		_g_object_unref0 (content_area);
	}
	return obj;
}


static void valide_document_message_class_init (ValideDocumentMessageClass * klass) {
	valide_document_message_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValideDocumentMessagePrivate));
	G_OBJECT_CLASS (klass)->get_property = valide_document_message_get_property;
	G_OBJECT_CLASS (klass)->set_property = valide_document_message_set_property;
	G_OBJECT_CLASS (klass)->constructor = valide_document_message_constructor;
	G_OBJECT_CLASS (klass)->finalize = valide_document_message_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_DOCUMENT_MESSAGE_DOCUMENT, g_param_spec_object ("document", "document", "document", VALIDE_TYPE_DOCUMENT, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void valide_document_message_instance_init (ValideDocumentMessage * self) {
	self->priv = VALIDE_DOCUMENT_MESSAGE_GET_PRIVATE (self);
}


static void valide_document_message_finalize (GObject* obj) {
	ValideDocumentMessage * self;
	self = VALIDE_DOCUMENT_MESSAGE (obj);
	_g_object_unref0 (self->priv->image);
	_g_object_unref0 (self->priv->primary_label);
	_g_object_unref0 (self->priv->secondary_label);
	_g_object_unref0 (self->priv->_document);
	G_OBJECT_CLASS (valide_document_message_parent_class)->finalize (obj);
}


GType valide_document_message_get_type (void) {
	static volatile gsize valide_document_message_type_id__volatile = 0;
	if (g_once_init_enter (&valide_document_message_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideDocumentMessageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_document_message_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideDocumentMessage), 0, (GInstanceInitFunc) valide_document_message_instance_init, NULL };
		GType valide_document_message_type_id;
		valide_document_message_type_id = g_type_register_static (GTK_TYPE_INFO_BAR, "ValideDocumentMessage", &g_define_type_info, 0);
		g_once_init_leave (&valide_document_message_type_id__volatile, valide_document_message_type_id);
	}
	return valide_document_message_type_id__volatile;
}


static void valide_document_message_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValideDocumentMessage * self;
	self = VALIDE_DOCUMENT_MESSAGE (object);
	switch (property_id) {
		case VALIDE_DOCUMENT_MESSAGE_DOCUMENT:
		g_value_set_object (value, valide_document_message_get_document (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void valide_document_message_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValideDocumentMessage * self;
	self = VALIDE_DOCUMENT_MESSAGE (object);
	switch (property_id) {
		case VALIDE_DOCUMENT_MESSAGE_DOCUMENT:
		valide_document_message_set_document (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




