/* buildable.c generated by valac, the Vala compiler
 * generated from buildable.vala, do not modify */

/* ************
 *
 * Copyright (C) 2009  Yu Feng
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to 
 *
 * the Free Software Foundation, Inc., 
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Yu Feng <rainwoodman@gmail.com>
 * 
 * This work is sponsed by C.Y Liu at Indiana University Cyclotron Facility.
 *
 ***/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define G_YAML_TYPE_BUILDABLE (g_yaml_buildable_get_type ())
#define G_YAML_BUILDABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_BUILDABLE, GYAMLBuildable))
#define G_YAML_IS_BUILDABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_BUILDABLE))
#define G_YAML_BUILDABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), G_YAML_TYPE_BUILDABLE, GYAMLBuildableIface))

typedef struct _GYAMLBuildable GYAMLBuildable;
typedef struct _GYAMLBuildableIface GYAMLBuildableIface;

#define G_YAML_TYPE_BUILDER (g_yaml_builder_get_type ())
#define G_YAML_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_BUILDER, GYAMLBuilder))
#define G_YAML_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_YAML_TYPE_BUILDER, GYAMLBuilderClass))
#define G_YAML_IS_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_BUILDER))
#define G_YAML_IS_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_YAML_TYPE_BUILDER))
#define G_YAML_BUILDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_YAML_TYPE_BUILDER, GYAMLBuilderClass))

typedef struct _GYAMLBuilder GYAMLBuilder;
typedef struct _GYAMLBuilderClass GYAMLBuilderClass;

#define G_YAML_TYPE_NODE (g_yaml_node_get_type ())
#define G_YAML_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_NODE, GYAMLNode))
#define G_YAML_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_YAML_TYPE_NODE, GYAMLNodeClass))
#define G_YAML_IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_NODE))
#define G_YAML_IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_YAML_TYPE_NODE))
#define G_YAML_NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_YAML_TYPE_NODE, GYAMLNodeClass))

typedef struct _GYAMLNode GYAMLNode;
typedef struct _GYAMLNodeClass GYAMLNodeClass;

#define G_YAML_BUILDABLE_TYPE_PROPERTY_HINT (g_yaml_buildable_property_hint_get_type ())
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GYAMLBuildableIface {
	GTypeInterface parent_iface;
	const char* (*get_name) (GYAMLBuildable* self);
	void (*set_name) (GYAMLBuildable* self, const char* name);
	void (*add_child) (GYAMLBuildable* self, GYAMLBuilder* builder, GObject* child, const char* type, GError** error);
	GList* (*get_children) (GYAMLBuildable* self, const char* type);
	GObject* (*get_internal_child) (GYAMLBuildable* self, GYAMLBuilder* builder, const char* child_name);
	void (*custom_node) (GYAMLBuildable* self, GYAMLBuilder* builder, const char* tag, GYAMLNode* node, GError** error);
};

typedef enum  {
	G_YAML_BUILDABLE_PROPERTY_HINT_NONE,
	G_YAML_BUILDABLE_PROPERTY_HINT_SKIP
} GYAMLBuildablePropertyHint;

typedef enum  {
	G_YAML_EXCEPTION_INTERNAL,
	G_YAML_EXCEPTION_WRITER,
	G_YAML_EXCEPTION_LOADER,
	G_YAML_EXCEPTION_BUILDER,
	G_YAML_EXCEPTION_DEMANGLER,
	G_YAML_EXCEPTION_UNIMPLEMENTED
} GYAMLException;
#define G_YAML_EXCEPTION g_yaml_exception_quark ()


GType g_yaml_builder_get_type (void);
gpointer g_yaml_node_ref (gpointer instance);
void g_yaml_node_unref (gpointer instance);
GParamSpec* g_yaml_param_spec_node (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void g_yaml_value_set_node (GValue* value, gpointer v_object);
void g_yaml_value_take_node (GValue* value, gpointer v_object);
gpointer g_yaml_value_get_node (const GValue* value);
GType g_yaml_node_get_type (void);
GType g_yaml_buildable_get_type (void);
GType g_yaml_buildable_property_hint_get_type (void);
const char* g_yaml_buildable_get_name (GYAMLBuildable* self);
static const char* g_yaml_buildable_real_get_name (GYAMLBuildable* self);
void g_yaml_buildable_set_name (GYAMLBuildable* self, const char* name);
static void g_yaml_buildable_real_set_name (GYAMLBuildable* self, const char* name);
void g_yaml_buildable_add_child (GYAMLBuildable* self, GYAMLBuilder* builder, GObject* child, const char* type, GError** error);
static void g_yaml_buildable_real_add_child (GYAMLBuildable* self, GYAMLBuilder* builder, GObject* child, const char* type, GError** error);
void g_yaml_buildable_register_type (GType type, char** child_tags, int child_tags_length1, GType* types, int types_length1);
void g_yaml_buildable_set_property_hint_pspec (GParamSpec* pspec, GYAMLBuildablePropertyHint hint);
void g_yaml_buildable_set_property_hint (GType type, const char* property, GYAMLBuildablePropertyHint hint);
GYAMLBuildablePropertyHint g_yaml_buildable_get_property_hint_pspec (GParamSpec* pspec);
GYAMLBuildablePropertyHint g_yaml_buildable_get_property_hint (GType type, const char* property);
char** g_yaml_buildable_get_child_tags (GYAMLBuildable* self, int* result_length1);
GType* g_yaml_buildable_get_child_types (GYAMLBuildable* self, int* result_length1);
GList* g_yaml_buildable_get_children (GYAMLBuildable* self, const char* type);
static GList* g_yaml_buildable_real_get_children (GYAMLBuildable* self, const char* type);
GObject* g_yaml_buildable_get_internal_child (GYAMLBuildable* self, GYAMLBuilder* builder, const char* child_name);
static GObject* g_yaml_buildable_real_get_internal_child (GYAMLBuildable* self, GYAMLBuilder* builder, const char* child_name);
GType g_yaml_buildable_get_child_type (GYAMLBuildable* self, GYAMLBuilder* builder, const char* tag);
char* g_yaml_node_get_location (GYAMLNode* self);
GQuark g_yaml_exception_quark (void);
void g_yaml_buildable_custom_node (GYAMLBuildable* self, GYAMLBuilder* builder, const char* tag, GYAMLNode* node, GError** error);
static void g_yaml_buildable_real_custom_node (GYAMLBuildable* self, GYAMLBuilder* builder, const char* tag, GYAMLNode* node, GError** error);
static int _vala_strcmp0 (const char * str1, const char * str2);



GType g_yaml_buildable_property_hint_get_type (void) {
	static volatile gsize g_yaml_buildable_property_hint_type_id__volatile = 0;
	if (g_once_init_enter (&g_yaml_buildable_property_hint_type_id__volatile)) {
		static const GFlagsValue values[] = {{G_YAML_BUILDABLE_PROPERTY_HINT_NONE, "G_YAML_BUILDABLE_PROPERTY_HINT_NONE", "none"}, {G_YAML_BUILDABLE_PROPERTY_HINT_SKIP, "G_YAML_BUILDABLE_PROPERTY_HINT_SKIP", "skip"}, {0, NULL, NULL}};
		GType g_yaml_buildable_property_hint_type_id;
		g_yaml_buildable_property_hint_type_id = g_flags_register_static ("GYAMLBuildablePropertyHint", values);
		g_once_init_leave (&g_yaml_buildable_property_hint_type_id__volatile, g_yaml_buildable_property_hint_type_id);
	}
	return g_yaml_buildable_property_hint_type_id__volatile;
}


#line 52 "buildable.vala"
static const char* g_yaml_buildable_real_get_name (GYAMLBuildable* self) {
#line 146 "buildable.c"
	const char* result = NULL;
	result = (const char*) g_object_get_data ((GObject*) self, "buildable-name");
#line 53 "buildable.vala"
	return result;
#line 151 "buildable.c"
}


#line 52 "buildable.vala"
const char* g_yaml_buildable_get_name (GYAMLBuildable* self) {
#line 52 "buildable.vala"
	return G_YAML_BUILDABLE_GET_INTERFACE (self)->get_name (self);
#line 159 "buildable.c"
}


#line 60 "buildable.vala"
static void g_yaml_buildable_real_set_name (GYAMLBuildable* self, const char* name) {
#line 61 "buildable.vala"
	if (name != NULL) {
#line 62 "buildable.vala"
		g_object_set_data_full ((GObject*) self, "buildable-name", g_strdup (name), g_free);
#line 169 "buildable.c"
	} else {
#line 64 "buildable.vala"
		g_object_set_data_full ((GObject*) self, "buildable-name", NULL, NULL);
#line 173 "buildable.c"
	}
}


#line 60 "buildable.vala"
void g_yaml_buildable_set_name (GYAMLBuildable* self, const char* name) {
#line 60 "buildable.vala"
	G_YAML_BUILDABLE_GET_INTERFACE (self)->set_name (self, name);
#line 182 "buildable.c"
}


#line 75 "buildable.vala"
static void g_yaml_buildable_real_add_child (GYAMLBuildable* self, GYAMLBuilder* builder, GObject* child, const char* type, GError** error) {
#line 188 "buildable.c"
	GObject* _tmp0_;
#line 75 "buildable.vala"
	g_return_if_fail (builder != NULL);
#line 75 "buildable.vala"
	g_return_if_fail (child != NULL);
#line 76 "buildable.vala"
	g_debug ("buildable.vala:76: Adding %s to %s", g_yaml_buildable_get_name ((_tmp0_ = child, G_YAML_IS_BUILDABLE (_tmp0_) ? ((GYAMLBuildable*) _tmp0_) : NULL)), g_yaml_buildable_get_name (self));
#line 196 "buildable.c"
}


#line 75 "buildable.vala"
void g_yaml_buildable_add_child (GYAMLBuildable* self, GYAMLBuilder* builder, GObject* child, const char* type, GError** error) {
#line 75 "buildable.vala"
	G_YAML_BUILDABLE_GET_INTERFACE (self)->add_child (self, builder, child, type, error);
#line 204 "buildable.c"
}


#line 83 "buildable.vala"
void g_yaml_buildable_register_type (GType type, char** child_tags, int child_tags_length1, GType* types, int types_length1) {
#line 86 "buildable.vala"
	g_type_set_qdata (type, g_quark_from_string ("buildable-child-tags"), child_tags);
#line 87 "buildable.vala"
	g_type_set_qdata (type, g_quark_from_string ("buildable-child-tags-len"), (void*) child_tags_length1);
#line 88 "buildable.vala"
	g_type_set_qdata (type, g_quark_from_string ("buildable-child-types"), types);
#line 89 "buildable.vala"
	g_type_set_qdata (type, g_quark_from_string ("buildable-child-types-len"), (void*) types_length1);
#line 218 "buildable.c"
}


#line 96 "buildable.vala"
void g_yaml_buildable_set_property_hint (GType type, const char* property, GYAMLBuildablePropertyHint hint) {
#line 224 "buildable.c"
	GObjectClass* klass;
	GParamSpec* pspec;
#line 96 "buildable.vala"
	g_return_if_fail (property != NULL);
#line 97 "buildable.vala"
	klass = (GObjectClass*) g_type_class_ref (type);
#line 98 "buildable.vala"
	pspec = g_object_class_find_property (klass, property);
#line 99 "buildable.vala"
	g_yaml_buildable_set_property_hint_pspec (pspec, hint);
#line 235 "buildable.c"
	_g_type_class_unref0 (klass);
}


#line 108 "buildable.vala"
void g_yaml_buildable_set_property_hint_pspec (GParamSpec* pspec, GYAMLBuildablePropertyHint hint) {
#line 108 "buildable.vala"
	g_return_if_fail (pspec != NULL);
#line 109 "buildable.vala"
	g_param_spec_set_qdata (pspec, g_quark_from_string ("buildable-property-hint"), (void*) hint);
#line 246 "buildable.c"
}


#line 113 "buildable.vala"
GYAMLBuildablePropertyHint g_yaml_buildable_get_property_hint (GType type, const char* property) {
#line 252 "buildable.c"
	GYAMLBuildablePropertyHint result = 0;
	GObjectClass* klass;
	GParamSpec* pspec;
#line 113 "buildable.vala"
	g_return_val_if_fail (property != NULL, 0);
#line 114 "buildable.vala"
	klass = (GObjectClass*) g_type_class_ref (type);
#line 115 "buildable.vala"
	pspec = g_object_class_find_property (klass, property);
#line 262 "buildable.c"
	result = g_yaml_buildable_get_property_hint_pspec (pspec);
	_g_type_class_unref0 (klass);
#line 116 "buildable.vala"
	return result;
#line 267 "buildable.c"
}


#line 119 "buildable.vala"
GYAMLBuildablePropertyHint g_yaml_buildable_get_property_hint_pspec (GParamSpec* pspec) {
#line 273 "buildable.c"
	GYAMLBuildablePropertyHint result = 0;
#line 119 "buildable.vala"
	g_return_val_if_fail (pspec != NULL, 0);
#line 277 "buildable.c"
	result = (GYAMLBuildablePropertyHint) g_param_spec_get_qdata (pspec, g_quark_from_string ("buildable-property-hint"));
#line 120 "buildable.vala"
	return result;
#line 281 "buildable.c"
}


#line 127 "buildable.vala"
char** g_yaml_buildable_get_child_tags (GYAMLBuildable* self, int* result_length1) {
#line 287 "buildable.c"
	char** result = NULL;
	void* pointer;
	char** _tmp0_;
	gint _tags_size_;
	gint tags_length1;
	char** tags;
	char** _tmp1_;
#line 128 "buildable.vala"
	pointer = g_type_get_qdata (G_TYPE_FROM_INSTANCE ((GObject*) self), g_quark_from_string ("buildable-child-tags"));
#line 297 "buildable.c"
	tags = (_tmp0_ = (char**) pointer, tags_length1 = -1, _tags_size_ = tags_length1, _tmp0_);
#line 131 "buildable.vala"
	tags_length1 = (gint) g_type_get_qdata (G_TYPE_FROM_INSTANCE ((GObject*) self), g_quark_from_string ("buildable-child-tags-len"));
#line 301 "buildable.c"
	result = (_tmp1_ = tags, *result_length1 = tags_length1, _tmp1_);
#line 133 "buildable.vala"
	return result;
#line 305 "buildable.c"
}


#line 136 "buildable.vala"
GType* g_yaml_buildable_get_child_types (GYAMLBuildable* self, int* result_length1) {
#line 311 "buildable.c"
	GType* result = NULL;
	void* pointer;
	GType* _tmp0_;
	gint _types_size_;
	gint types_length1;
	GType* types;
	GType* _tmp1_;
#line 137 "buildable.vala"
	pointer = g_type_get_qdata (G_TYPE_FROM_INSTANCE ((GObject*) self), g_quark_from_string ("buildable-child-types"));
#line 321 "buildable.c"
	types = (_tmp0_ = (GType*) pointer, types_length1 = -1, _types_size_ = types_length1, _tmp0_);
#line 140 "buildable.vala"
	types_length1 = (gint) g_type_get_qdata (G_TYPE_FROM_INSTANCE ((GObject*) self), g_quark_from_string ("buildable-child-types-len"));
#line 325 "buildable.c"
	result = (_tmp1_ = types, *result_length1 = types_length1, _tmp1_);
#line 142 "buildable.vala"
	return result;
#line 329 "buildable.c"
}


#line 152 "buildable.vala"
static GList* g_yaml_buildable_real_get_children (GYAMLBuildable* self, const char* type) {
#line 335 "buildable.c"
	GList* result = NULL;
	result = NULL;
#line 153 "buildable.vala"
	return result;
#line 340 "buildable.c"
}


#line 152 "buildable.vala"
GList* g_yaml_buildable_get_children (GYAMLBuildable* self, const char* type) {
#line 152 "buildable.vala"
	return G_YAML_BUILDABLE_GET_INTERFACE (self)->get_children (self, type);
#line 348 "buildable.c"
}


#line 162 "buildable.vala"
static GObject* g_yaml_buildable_real_get_internal_child (GYAMLBuildable* self, GYAMLBuilder* builder, const char* child_name) {
#line 354 "buildable.c"
	GObject* result = NULL;
#line 162 "buildable.vala"
	g_return_val_if_fail (builder != NULL, NULL);
#line 162 "buildable.vala"
	g_return_val_if_fail (child_name != NULL, NULL);
#line 360 "buildable.c"
	result = NULL;
#line 163 "buildable.vala"
	return result;
#line 364 "buildable.c"
}


#line 162 "buildable.vala"
GObject* g_yaml_buildable_get_internal_child (GYAMLBuildable* self, GYAMLBuilder* builder, const char* child_name) {
#line 162 "buildable.vala"
	return G_YAML_BUILDABLE_GET_INTERFACE (self)->get_internal_child (self, builder, child_name);
#line 372 "buildable.c"
}


#line 175 "buildable.vala"
GType g_yaml_buildable_get_child_type (GYAMLBuildable* self, GYAMLBuilder* builder, const char* tag) {
#line 378 "buildable.c"
	GType result = 0UL;
	char** _tmp1_;
	gint _tags_size_;
	gint tags_length1;
	gint _tmp0_;
	char** tags;
	GType* _tmp3_;
	gint _types_size_;
	gint types_length1;
	gint _tmp2_;
	GType* types;
#line 175 "buildable.vala"
	g_return_val_if_fail (builder != NULL, 0UL);
#line 175 "buildable.vala"
	g_return_val_if_fail (tag != NULL, 0UL);
#line 394 "buildable.c"
	tags = (_tmp1_ = g_yaml_buildable_get_child_tags (self, &_tmp0_), tags_length1 = _tmp0_, _tags_size_ = tags_length1, _tmp1_);
	types = (_tmp3_ = g_yaml_buildable_get_child_types (self, &_tmp2_), types_length1 = _tmp2_, _types_size_ = types_length1, _tmp3_);
#line 179 "buildable.vala"
	g_assert (types_length1 == tags_length1);
#line 180 "buildable.vala"
	if (tags == NULL) {
#line 401 "buildable.c"
		result = G_TYPE_INVALID;
#line 180 "buildable.vala"
		return result;
#line 405 "buildable.c"
	}
	{
		gint i;
#line 181 "buildable.vala"
		i = 0;
#line 411 "buildable.c"
		{
			gboolean _tmp4_;
#line 181 "buildable.vala"
			_tmp4_ = TRUE;
#line 181 "buildable.vala"
			while (TRUE) {
#line 181 "buildable.vala"
				if (!_tmp4_) {
#line 181 "buildable.vala"
					i++;
#line 422 "buildable.c"
				}
#line 181 "buildable.vala"
				_tmp4_ = FALSE;
#line 181 "buildable.vala"
				if (!(i < tags_length1)) {
#line 181 "buildable.vala"
					break;
#line 430 "buildable.c"
				}
#line 182 "buildable.vala"
				if (_vala_strcmp0 (tags[i], tag) == 0) {
#line 434 "buildable.c"
					result = types[i];
#line 183 "buildable.vala"
					return result;
#line 438 "buildable.c"
				}
			}
		}
	}
	result = G_TYPE_INVALID;
#line 186 "buildable.vala"
	return result;
#line 446 "buildable.c"
}


#line 195 "buildable.vala"
static void g_yaml_buildable_real_custom_node (GYAMLBuildable* self, GYAMLBuilder* builder, const char* tag, GYAMLNode* node, GError** error) {
#line 452 "buildable.c"
	GError * _inner_error_;
	char* _tmp0_;
	GError* _tmp1_;
#line 195 "buildable.vala"
	g_return_if_fail (builder != NULL);
#line 195 "buildable.vala"
	g_return_if_fail (tag != NULL);
#line 195 "buildable.vala"
	g_return_if_fail (node != NULL);
#line 462 "buildable.c"
	_inner_error_ = NULL;
	_inner_error_ = (_tmp1_ = g_error_new (G_YAML_EXCEPTION, G_YAML_EXCEPTION_BUILDER, "%s: Property %s.%s is not defined", _tmp0_ = g_yaml_node_get_location (node), g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) self)), tag), _g_free0 (_tmp0_), _tmp1_);
	{
		g_propagate_error (error, _inner_error_);
		return;
	}
}


#line 195 "buildable.vala"
void g_yaml_buildable_custom_node (GYAMLBuildable* self, GYAMLBuilder* builder, const char* tag, GYAMLNode* node, GError** error) {
#line 195 "buildable.vala"
	G_YAML_BUILDABLE_GET_INTERFACE (self)->custom_node (self, builder, tag, node, error);
#line 476 "buildable.c"
}


static void g_yaml_buildable_base_init (GYAMLBuildableIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
	iface->get_name = g_yaml_buildable_real_get_name;
	iface->set_name = g_yaml_buildable_real_set_name;
	iface->add_child = g_yaml_buildable_real_add_child;
	iface->get_children = g_yaml_buildable_real_get_children;
	iface->get_internal_child = g_yaml_buildable_real_get_internal_child;
	iface->custom_node = g_yaml_buildable_real_custom_node;
}


GType g_yaml_buildable_get_type (void) {
	static volatile gsize g_yaml_buildable_type_id__volatile = 0;
	if (g_once_init_enter (&g_yaml_buildable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GYAMLBuildableIface), (GBaseInitFunc) g_yaml_buildable_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType g_yaml_buildable_type_id;
		g_yaml_buildable_type_id = g_type_register_static (G_TYPE_INTERFACE, "GYAMLBuildable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (g_yaml_buildable_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&g_yaml_buildable_type_id__volatile, g_yaml_buildable_type_id);
	}
	return g_yaml_buildable_type_id__volatile;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




