/* advanced-search-dialog.c generated by valac, the Vala compiler
 * generated from advanced-search-dialog.vala, do not modify */

/* advanced-search-dialog.vala
 *
 * Copyright (C) 2010  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <valide-0.0.h>
#include <glib/gi18n-lib.h>


#define TYPE_ADVANCED_SEARCH_DIALOG (advanced_search_dialog_get_type ())
#define ADVANCED_SEARCH_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADVANCED_SEARCH_DIALOG, AdvancedSearchDialog))
#define ADVANCED_SEARCH_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ADVANCED_SEARCH_DIALOG, AdvancedSearchDialogClass))
#define IS_ADVANCED_SEARCH_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADVANCED_SEARCH_DIALOG))
#define IS_ADVANCED_SEARCH_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ADVANCED_SEARCH_DIALOG))
#define ADVANCED_SEARCH_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ADVANCED_SEARCH_DIALOG, AdvancedSearchDialogClass))

typedef struct _AdvancedSearchDialog AdvancedSearchDialog;
typedef struct _AdvancedSearchDialogClass AdvancedSearchDialogClass;
typedef struct _AdvancedSearchDialogPrivate AdvancedSearchDialogPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _AdvancedSearchDialog {
	GtkDialog parent_instance;
	AdvancedSearchDialogPrivate * priv;
};

struct _AdvancedSearchDialogClass {
	GtkDialogClass parent_class;
};

struct _AdvancedSearchDialogPrivate {
	GtkEntry* entry;
	GtkCheckButton* check_case;
	GtkCheckButton* check_entire;
	GtkCheckButton* check_regex;
	GtkRadioButton* radio_current;
	GtkRadioButton* radio_opened;
	GtkRadioButton* radio_project;
};


static gpointer advanced_search_dialog_parent_class = NULL;

GType advanced_search_dialog_get_type (void);
#define ADVANCED_SEARCH_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ADVANCED_SEARCH_DIALOG, AdvancedSearchDialogPrivate))
enum  {
	ADVANCED_SEARCH_DIALOG_DUMMY_PROPERTY,
	ADVANCED_SEARCH_DIALOG_CASE_SENSITIVE,
	ADVANCED_SEARCH_DIALOG_ENTIRE_WORD,
	ADVANCED_SEARCH_DIALOG_USE_REGEX,
	ADVANCED_SEARCH_DIALOG_PATTERN,
	ADVANCED_SEARCH_DIALOG_CURRENT_SCOPE,
	ADVANCED_SEARCH_DIALOG_OPENED_SCOPE,
	ADVANCED_SEARCH_DIALOG_PROJECT_SCOPE,
	ADVANCED_SEARCH_DIALOG_ACTIVE_CURRENT_SCOPE,
	ADVANCED_SEARCH_DIALOG_ACTIVE_OPENED_SCOPE,
	ADVANCED_SEARCH_DIALOG_ACTIVE_PROJECT_SCOPE
};
AdvancedSearchDialog* advanced_search_dialog_new (void);
AdvancedSearchDialog* advanced_search_dialog_construct (GType object_type);
gboolean advanced_search_dialog_get_case_sensitive (AdvancedSearchDialog* self);
gboolean advanced_search_dialog_get_entire_word (AdvancedSearchDialog* self);
gboolean advanced_search_dialog_get_use_regex (AdvancedSearchDialog* self);
const char* advanced_search_dialog_get_pattern (AdvancedSearchDialog* self);
gboolean advanced_search_dialog_get_current_scope (AdvancedSearchDialog* self);
gboolean advanced_search_dialog_get_opened_scope (AdvancedSearchDialog* self);
gboolean advanced_search_dialog_get_project_scope (AdvancedSearchDialog* self);
gboolean advanced_search_dialog_get_active_current_scope (AdvancedSearchDialog* self);
void advanced_search_dialog_set_active_current_scope (AdvancedSearchDialog* self, gboolean value);
gboolean advanced_search_dialog_get_active_opened_scope (AdvancedSearchDialog* self);
void advanced_search_dialog_set_active_opened_scope (AdvancedSearchDialog* self, gboolean value);
gboolean advanced_search_dialog_get_active_project_scope (AdvancedSearchDialog* self);
void advanced_search_dialog_set_active_project_scope (AdvancedSearchDialog* self, gboolean value);
static GObject * advanced_search_dialog_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void advanced_search_dialog_finalize (GObject* obj);
static void advanced_search_dialog_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void advanced_search_dialog_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



#line 24 "advanced-search-dialog.vala"
AdvancedSearchDialog* advanced_search_dialog_construct (GType object_type) {
#line 108 "advanced-search-dialog.c"
	AdvancedSearchDialog * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


#line 24 "advanced-search-dialog.vala"
AdvancedSearchDialog* advanced_search_dialog_new (void) {
#line 24 "advanced-search-dialog.vala"
	return advanced_search_dialog_construct (TYPE_ADVANCED_SEARCH_DIALOG);
#line 119 "advanced-search-dialog.c"
}


gboolean advanced_search_dialog_get_case_sensitive (AdvancedSearchDialog* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->check_case);
#line 36 "advanced-search-dialog.vala"
	return result;
#line 129 "advanced-search-dialog.c"
}


gboolean advanced_search_dialog_get_entire_word (AdvancedSearchDialog* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->check_entire);
#line 41 "advanced-search-dialog.vala"
	return result;
#line 139 "advanced-search-dialog.c"
}


gboolean advanced_search_dialog_get_use_regex (AdvancedSearchDialog* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->check_regex);
#line 46 "advanced-search-dialog.vala"
	return result;
#line 149 "advanced-search-dialog.c"
}


const char* advanced_search_dialog_get_pattern (AdvancedSearchDialog* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = gtk_entry_get_text (self->priv->entry);
#line 51 "advanced-search-dialog.vala"
	return result;
#line 159 "advanced-search-dialog.c"
}


gboolean advanced_search_dialog_get_current_scope (AdvancedSearchDialog* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->radio_current);
#line 56 "advanced-search-dialog.vala"
	return result;
#line 169 "advanced-search-dialog.c"
}


gboolean advanced_search_dialog_get_opened_scope (AdvancedSearchDialog* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->radio_opened);
#line 61 "advanced-search-dialog.vala"
	return result;
#line 179 "advanced-search-dialog.c"
}


gboolean advanced_search_dialog_get_project_scope (AdvancedSearchDialog* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->radio_project);
#line 66 "advanced-search-dialog.vala"
	return result;
#line 189 "advanced-search-dialog.c"
}


gboolean advanced_search_dialog_get_active_current_scope (AdvancedSearchDialog* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = gtk_widget_get_sensitive ((GtkWidget*) self->priv->radio_current);
#line 71 "advanced-search-dialog.vala"
	return result;
#line 199 "advanced-search-dialog.c"
}


void advanced_search_dialog_set_active_current_scope (AdvancedSearchDialog* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
#line 74 "advanced-search-dialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self->priv->radio_current, value);
#line 75 "advanced-search-dialog.vala"
	if (!value) {
#line 75 "advanced-search-dialog.vala"
		_tmp0_ = gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->radio_current);
#line 212 "advanced-search-dialog.c"
	} else {
#line 75 "advanced-search-dialog.vala"
		_tmp0_ = FALSE;
#line 216 "advanced-search-dialog.c"
	}
#line 75 "advanced-search-dialog.vala"
	if (_tmp0_) {
#line 77 "advanced-search-dialog.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) self->priv->radio_project, TRUE);
#line 222 "advanced-search-dialog.c"
	}
	g_object_notify ((GObject *) self, "active-current-scope");
}


gboolean advanced_search_dialog_get_active_opened_scope (AdvancedSearchDialog* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = gtk_widget_get_sensitive ((GtkWidget*) self->priv->radio_opened);
#line 84 "advanced-search-dialog.vala"
	return result;
#line 234 "advanced-search-dialog.c"
}


void advanced_search_dialog_set_active_opened_scope (AdvancedSearchDialog* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
#line 87 "advanced-search-dialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self->priv->radio_opened, value);
#line 88 "advanced-search-dialog.vala"
	if (!value) {
#line 88 "advanced-search-dialog.vala"
		_tmp0_ = gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->radio_opened);
#line 247 "advanced-search-dialog.c"
	} else {
#line 88 "advanced-search-dialog.vala"
		_tmp0_ = FALSE;
#line 251 "advanced-search-dialog.c"
	}
#line 88 "advanced-search-dialog.vala"
	if (_tmp0_) {
#line 90 "advanced-search-dialog.vala"
		if (advanced_search_dialog_get_active_current_scope (self)) {
#line 92 "advanced-search-dialog.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) self->priv->radio_current, FALSE);
#line 259 "advanced-search-dialog.c"
		} else {
#line 96 "advanced-search-dialog.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) self->priv->radio_project, FALSE);
#line 263 "advanced-search-dialog.c"
		}
	}
	g_object_notify ((GObject *) self, "active-opened-scope");
}


gboolean advanced_search_dialog_get_active_project_scope (AdvancedSearchDialog* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = gtk_widget_get_sensitive ((GtkWidget*) self->priv->radio_project);
#line 104 "advanced-search-dialog.vala"
	return result;
#line 276 "advanced-search-dialog.c"
}


void advanced_search_dialog_set_active_project_scope (AdvancedSearchDialog* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
#line 107 "advanced-search-dialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self->priv->radio_project, value);
#line 108 "advanced-search-dialog.vala"
	if (!value) {
#line 108 "advanced-search-dialog.vala"
		_tmp0_ = gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->radio_project);
#line 289 "advanced-search-dialog.c"
	} else {
#line 108 "advanced-search-dialog.vala"
		_tmp0_ = FALSE;
#line 293 "advanced-search-dialog.c"
	}
#line 108 "advanced-search-dialog.vala"
	if (_tmp0_) {
#line 110 "advanced-search-dialog.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) self->priv->radio_current, TRUE);
#line 299 "advanced-search-dialog.c"
	}
	g_object_notify ((GObject *) self, "active-project-scope");
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static GObject * advanced_search_dialog_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	AdvancedSearchDialog * self;
	parent_class = G_OBJECT_CLASS (advanced_search_dialog_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = ADVANCED_SEARCH_DIALOG (obj);
	{
		ValideFrame* frame;
		GtkVBox* vbox;
		GtkHBox* hbox;
		GtkLabel* label;
		GtkWidget* widget;
		GtkWidget* _tmp0_;
		GtkHBox* _tmp1_;
		GtkLabel* _tmp2_;
		GtkEntry* _tmp3_;
		GtkHBox* _tmp4_;
		ValideFrame* _tmp5_;
		GtkVBox* _tmp6_;
		GtkCheckButton* _tmp7_;
		GtkCheckButton* _tmp8_;
		GtkCheckButton* _tmp9_;
		ValideFrame* _tmp10_;
		GtkVBox* _tmp11_;
		GtkRadioButton* _tmp12_;
		GtkRadioButton* _tmp13_;
		GtkRadioButton* _tmp14_;
		frame = NULL;
		vbox = NULL;
		hbox = NULL;
		label = NULL;
		widget = NULL;
#line 123 "advanced-search-dialog.vala"
		gtk_container_set_border_width ((GtkContainer*) self, (guint) 5);
#line 124 "advanced-search-dialog.vala"
		gtk_box_set_spacing ((GtkBox*) ((GtkDialog*) self)->vbox, 10);
#line 125 "advanced-search-dialog.vala"
		gtk_dialog_set_default_response ((GtkDialog*) self, (gint) GTK_RESPONSE_ACCEPT);
#line 127 "advanced-search-dialog.vala"
		gtk_window_set_title ((GtkWindow*) self, _ ("Advanced search"));
#line 128 "advanced-search-dialog.vala"
		gtk_dialog_add_button ((GtkDialog*) self, GTK_STOCK_CANCEL, (gint) GTK_RESPONSE_CANCEL);
#line 129 "advanced-search-dialog.vala"
		widget = (_tmp0_ = _g_object_ref0 (gtk_dialog_add_button ((GtkDialog*) self, GTK_STOCK_FIND, (gint) GTK_RESPONSE_ACCEPT)), _g_object_unref0 (widget), _tmp0_);
#line 130 "advanced-search-dialog.vala"
		gtk_widget_grab_default (widget);
#line 132 "advanced-search-dialog.vala"
		hbox = (_tmp1_ = g_object_ref_sink ((GtkHBox*) gtk_hbox_new (FALSE, 5)), _g_object_unref0 (hbox), _tmp1_);
#line 133 "advanced-search-dialog.vala"
		gtk_box_pack_start ((GtkBox*) ((GtkDialog*) self)->vbox, (GtkWidget*) hbox, FALSE, TRUE, (guint) 0);
#line 135 "advanced-search-dialog.vala"
		label = (_tmp2_ = g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("Search:"))), _g_object_unref0 (label), _tmp2_);
#line 136 "advanced-search-dialog.vala"
		gtk_box_pack_start ((GtkBox*) hbox, (GtkWidget*) label, FALSE, FALSE, (guint) 0);
#line 138 "advanced-search-dialog.vala"
		self->priv->entry = (_tmp3_ = g_object_ref_sink ((GtkEntry*) gtk_entry_new ()), _g_object_unref0 (self->priv->entry), _tmp3_);
#line 139 "advanced-search-dialog.vala"
		gtk_entry_set_activates_default (self->priv->entry, TRUE);
#line 140 "advanced-search-dialog.vala"
		gtk_box_pack_start ((GtkBox*) hbox, (GtkWidget*) self->priv->entry, TRUE, TRUE, (guint) 0);
#line 142 "advanced-search-dialog.vala"
		hbox = (_tmp4_ = g_object_ref_sink ((GtkHBox*) gtk_hbox_new (FALSE, 5)), _g_object_unref0 (hbox), _tmp4_);
#line 143 "advanced-search-dialog.vala"
		gtk_box_pack_start ((GtkBox*) ((GtkDialog*) self)->vbox, (GtkWidget*) hbox, FALSE, TRUE, (guint) 0);
#line 145 "advanced-search-dialog.vala"
		frame = (_tmp5_ = g_object_ref_sink (valide_frame_new (_ ("Options"))), _g_object_unref0 (frame), _tmp5_);
#line 146 "advanced-search-dialog.vala"
		gtk_box_pack_start ((GtkBox*) hbox, (GtkWidget*) frame, FALSE, TRUE, (guint) 0);
#line 148 "advanced-search-dialog.vala"
		vbox = (_tmp6_ = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (TRUE, 0)), _g_object_unref0 (vbox), _tmp6_);
#line 149 "advanced-search-dialog.vala"
		gtk_container_add ((GtkContainer*) frame, (GtkWidget*) vbox);
#line 151 "advanced-search-dialog.vala"
		self->priv->check_case = (_tmp7_ = g_object_ref_sink ((GtkCheckButton*) gtk_check_button_new_with_label (_ ("Match case"))), _g_object_unref0 (self->priv->check_case), _tmp7_);
#line 152 "advanced-search-dialog.vala"
		gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) self->priv->check_case, FALSE, TRUE, (guint) 0);
#line 154 "advanced-search-dialog.vala"
		self->priv->check_entire = (_tmp8_ = g_object_ref_sink ((GtkCheckButton*) gtk_check_button_new_with_label (_ ("Match entire word only"))), _g_object_unref0 (self->priv->check_entire), _tmp8_);
#line 155 "advanced-search-dialog.vala"
		gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) self->priv->check_entire, FALSE, TRUE, (guint) 0);
#line 157 "advanced-search-dialog.vala"
		self->priv->check_regex = (_tmp9_ = g_object_ref_sink ((GtkCheckButton*) gtk_check_button_new_with_label (_ ("Use regular expression"))), _g_object_unref0 (self->priv->check_regex), _tmp9_);
#line 158 "advanced-search-dialog.vala"
		gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) self->priv->check_regex, FALSE, TRUE, (guint) 0);
#line 160 "advanced-search-dialog.vala"
		frame = (_tmp10_ = g_object_ref_sink (valide_frame_new (_ ("Scope"))), _g_object_unref0 (frame), _tmp10_);
#line 161 "advanced-search-dialog.vala"
		gtk_box_pack_start ((GtkBox*) hbox, (GtkWidget*) frame, FALSE, TRUE, (guint) 0);
#line 163 "advanced-search-dialog.vala"
		vbox = (_tmp11_ = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (TRUE, 0)), _g_object_unref0 (vbox), _tmp11_);
#line 164 "advanced-search-dialog.vala"
		gtk_container_add ((GtkContainer*) frame, (GtkWidget*) vbox);
#line 166 "advanced-search-dialog.vala"
		self->priv->radio_current = (_tmp12_ = g_object_ref_sink ((GtkRadioButton*) gtk_radio_button_new_with_label (NULL, _ ("Current file"))), _g_object_unref0 (self->priv->radio_current), _tmp12_);
#line 167 "advanced-search-dialog.vala"
		gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) self->priv->radio_current, FALSE, TRUE, (guint) 0);
#line 169 "advanced-search-dialog.vala"
		self->priv->radio_opened = (_tmp13_ = g_object_ref_sink ((GtkRadioButton*) gtk_radio_button_new_with_label_from_widget (self->priv->radio_current, _ ("All opened files"))), _g_object_unref0 (self->priv->radio_opened), _tmp13_);
#line 170 "advanced-search-dialog.vala"
		gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) self->priv->radio_opened, FALSE, TRUE, (guint) 0);
#line 172 "advanced-search-dialog.vala"
		self->priv->radio_project = (_tmp14_ = g_object_ref_sink ((GtkRadioButton*) gtk_radio_button_new_with_label_from_widget (self->priv->radio_current, _ ("All project files"))), _g_object_unref0 (self->priv->radio_project), _tmp14_);
#line 173 "advanced-search-dialog.vala"
		gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) self->priv->radio_project, FALSE, TRUE, (guint) 0);
#line 415 "advanced-search-dialog.c"
		_g_object_unref0 (frame);
		_g_object_unref0 (vbox);
		_g_object_unref0 (hbox);
		_g_object_unref0 (label);
		_g_object_unref0 (widget);
	}
	return obj;
}


static void advanced_search_dialog_class_init (AdvancedSearchDialogClass * klass) {
	advanced_search_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (AdvancedSearchDialogPrivate));
	G_OBJECT_CLASS (klass)->get_property = advanced_search_dialog_get_property;
	G_OBJECT_CLASS (klass)->set_property = advanced_search_dialog_set_property;
	G_OBJECT_CLASS (klass)->constructor = advanced_search_dialog_constructor;
	G_OBJECT_CLASS (klass)->finalize = advanced_search_dialog_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADVANCED_SEARCH_DIALOG_CASE_SENSITIVE, g_param_spec_boolean ("case-sensitive", "case-sensitive", "case-sensitive", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADVANCED_SEARCH_DIALOG_ENTIRE_WORD, g_param_spec_boolean ("entire-word", "entire-word", "entire-word", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADVANCED_SEARCH_DIALOG_USE_REGEX, g_param_spec_boolean ("use-regex", "use-regex", "use-regex", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADVANCED_SEARCH_DIALOG_PATTERN, g_param_spec_string ("pattern", "pattern", "pattern", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADVANCED_SEARCH_DIALOG_CURRENT_SCOPE, g_param_spec_boolean ("current-scope", "current-scope", "current-scope", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADVANCED_SEARCH_DIALOG_OPENED_SCOPE, g_param_spec_boolean ("opened-scope", "opened-scope", "opened-scope", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADVANCED_SEARCH_DIALOG_PROJECT_SCOPE, g_param_spec_boolean ("project-scope", "project-scope", "project-scope", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADVANCED_SEARCH_DIALOG_ACTIVE_CURRENT_SCOPE, g_param_spec_boolean ("active-current-scope", "active-current-scope", "active-current-scope", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADVANCED_SEARCH_DIALOG_ACTIVE_OPENED_SCOPE, g_param_spec_boolean ("active-opened-scope", "active-opened-scope", "active-opened-scope", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADVANCED_SEARCH_DIALOG_ACTIVE_PROJECT_SCOPE, g_param_spec_boolean ("active-project-scope", "active-project-scope", "active-project-scope", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void advanced_search_dialog_instance_init (AdvancedSearchDialog * self) {
	self->priv = ADVANCED_SEARCH_DIALOG_GET_PRIVATE (self);
}


static void advanced_search_dialog_finalize (GObject* obj) {
	AdvancedSearchDialog * self;
	self = ADVANCED_SEARCH_DIALOG (obj);
	_g_object_unref0 (self->priv->entry);
	_g_object_unref0 (self->priv->check_case);
	_g_object_unref0 (self->priv->check_entire);
	_g_object_unref0 (self->priv->check_regex);
	_g_object_unref0 (self->priv->radio_current);
	_g_object_unref0 (self->priv->radio_opened);
	_g_object_unref0 (self->priv->radio_project);
	G_OBJECT_CLASS (advanced_search_dialog_parent_class)->finalize (obj);
}


GType advanced_search_dialog_get_type (void) {
	static volatile gsize advanced_search_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&advanced_search_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AdvancedSearchDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) advanced_search_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AdvancedSearchDialog), 0, (GInstanceInitFunc) advanced_search_dialog_instance_init, NULL };
		GType advanced_search_dialog_type_id;
		advanced_search_dialog_type_id = g_type_register_static (GTK_TYPE_DIALOG, "AdvancedSearchDialog", &g_define_type_info, 0);
		g_once_init_leave (&advanced_search_dialog_type_id__volatile, advanced_search_dialog_type_id);
	}
	return advanced_search_dialog_type_id__volatile;
}


static void advanced_search_dialog_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	AdvancedSearchDialog * self;
	self = ADVANCED_SEARCH_DIALOG (object);
	switch (property_id) {
		case ADVANCED_SEARCH_DIALOG_CASE_SENSITIVE:
		g_value_set_boolean (value, advanced_search_dialog_get_case_sensitive (self));
		break;
		case ADVANCED_SEARCH_DIALOG_ENTIRE_WORD:
		g_value_set_boolean (value, advanced_search_dialog_get_entire_word (self));
		break;
		case ADVANCED_SEARCH_DIALOG_USE_REGEX:
		g_value_set_boolean (value, advanced_search_dialog_get_use_regex (self));
		break;
		case ADVANCED_SEARCH_DIALOG_PATTERN:
		g_value_set_string (value, advanced_search_dialog_get_pattern (self));
		break;
		case ADVANCED_SEARCH_DIALOG_CURRENT_SCOPE:
		g_value_set_boolean (value, advanced_search_dialog_get_current_scope (self));
		break;
		case ADVANCED_SEARCH_DIALOG_OPENED_SCOPE:
		g_value_set_boolean (value, advanced_search_dialog_get_opened_scope (self));
		break;
		case ADVANCED_SEARCH_DIALOG_PROJECT_SCOPE:
		g_value_set_boolean (value, advanced_search_dialog_get_project_scope (self));
		break;
		case ADVANCED_SEARCH_DIALOG_ACTIVE_CURRENT_SCOPE:
		g_value_set_boolean (value, advanced_search_dialog_get_active_current_scope (self));
		break;
		case ADVANCED_SEARCH_DIALOG_ACTIVE_OPENED_SCOPE:
		g_value_set_boolean (value, advanced_search_dialog_get_active_opened_scope (self));
		break;
		case ADVANCED_SEARCH_DIALOG_ACTIVE_PROJECT_SCOPE:
		g_value_set_boolean (value, advanced_search_dialog_get_active_project_scope (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void advanced_search_dialog_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	AdvancedSearchDialog * self;
	self = ADVANCED_SEARCH_DIALOG (object);
	switch (property_id) {
		case ADVANCED_SEARCH_DIALOG_ACTIVE_CURRENT_SCOPE:
		advanced_search_dialog_set_active_current_scope (self, g_value_get_boolean (value));
		break;
		case ADVANCED_SEARCH_DIALOG_ACTIVE_OPENED_SCOPE:
		advanced_search_dialog_set_active_opened_scope (self, g_value_get_boolean (value));
		break;
		case ADVANCED_SEARCH_DIALOG_ACTIVE_PROJECT_SCOPE:
		advanced_search_dialog_set_active_project_scope (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




