/* opened-documents.c generated by valac, the Vala compiler
 * generated from opened-documents.vala, do not modify */

/* opened-documents.vala
 *
 * Copyright (C) 2009-2010 Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <valide-0.0.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <gdl/gdl.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <glib/gi18n-lib.h>


#define TYPE_OPENED_DOCUMENTS (opened_documents_get_type ())
#define OPENED_DOCUMENTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_OPENED_DOCUMENTS, OpenedDocuments))
#define OPENED_DOCUMENTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_OPENED_DOCUMENTS, OpenedDocumentsClass))
#define IS_OPENED_DOCUMENTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_OPENED_DOCUMENTS))
#define IS_OPENED_DOCUMENTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_OPENED_DOCUMENTS))
#define OPENED_DOCUMENTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_OPENED_DOCUMENTS, OpenedDocumentsClass))

typedef struct _OpenedDocuments OpenedDocuments;
typedef struct _OpenedDocumentsClass OpenedDocumentsClass;
typedef struct _OpenedDocumentsPrivate OpenedDocumentsPrivate;

#define OPENED_DOCUMENTS_TYPE_COL (opened_documents_col_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _OpenedDocuments {
	GObject parent_instance;
	OpenedDocumentsPrivate * priv;
};

struct _OpenedDocumentsClass {
	GObjectClass parent_class;
};

struct _OpenedDocumentsPrivate {
	GtkVBox* box;
	guint ui_id;
	gboolean on_idle;
	GtkTreeView* tree_view;
	ValideDocumentManager* documents;
	GtkActionGroup* action_group;
	char* _path;
	ValideWindow* _window;
};

typedef enum  {
	OPENED_DOCUMENTS_COL_ICON,
	OPENED_DOCUMENTS_COL_NAME,
	OPENED_DOCUMENTS_COL_DOCUMENT,
	OPENED_DOCUMENTS_COL_STYLE,
	OPENED_DOCUMENTS_COL_TOOLTIP,
	OPENED_DOCUMENTS_COL_NB
} OpenedDocumentsCol;


static gpointer opened_documents_parent_class = NULL;
static ValidePluginIface* opened_documents_valide_plugin_parent_iface = NULL;

GType opened_documents_get_type (void);
#define OPENED_DOCUMENTS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_OPENED_DOCUMENTS, OpenedDocumentsPrivate))
enum  {
	OPENED_DOCUMENTS_DUMMY_PROPERTY,
	OPENED_DOCUMENTS_PATH,
	OPENED_DOCUMENTS_WINDOW
};
static GType opened_documents_col_get_type (void) G_GNUC_UNUSED;
static void opened_documents_on_action_activate (OpenedDocuments* self, GtkAction* action);
static void _opened_documents_on_action_activate_gtk_radio_action_changed (GtkRadioAction* _sender, GtkRadioAction* current, gpointer self);
static void opened_documents_populate_menu (OpenedDocuments* self);
static void opened_documents_populate_treeview (OpenedDocuments* self);
static gboolean opened_documents_populate_asc (OpenedDocuments* self);
static gboolean _opened_documents_populate_asc_gsource_func (gpointer self);
static void opened_documents_populate (OpenedDocuments* self);
static void opened_documents_on_cursor_change (OpenedDocuments* self, GtkTreeView* sender);
OpenedDocuments* opened_documents_new (void);
OpenedDocuments* opened_documents_construct (GType object_type);
static void _opened_documents_on_cursor_change_gtk_tree_view_cursor_changed (GtkTreeView* _sender, gpointer self);
static void _opened_documents_populate_valide_document_manager_tab_removed (ValideDocumentManager* _sender, ValideDocument* document, gpointer self);
static void _opened_documents_populate_valide_document_manager_tab_added (ValideDocumentManager* _sender, ValideDocument* document, gpointer self);
static void _opened_documents_populate_valide_document_manager_tab_state_changed (ValideDocumentManager* _sender, ValideDocument* document, gpointer self);
static void _opened_documents_populate_valide_document_manager_tab_changed (ValideDocumentManager* _sender, ValideDocument* document, gpointer self);
static void _opened_documents_populate_gtk_notebook_page_reordered (GtkNotebook* _sender, GtkWidget* p0, guint p1, gpointer self);
static GObject * opened_documents_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void opened_documents_finalize (GObject* obj);
static void opened_documents_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void opened_documents_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType register_plugin (void* user_data, GError** error);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);



static GType opened_documents_col_get_type (void) {
	static volatile gsize opened_documents_col_type_id__volatile = 0;
	if (g_once_init_enter (&opened_documents_col_type_id__volatile)) {
		static const GEnumValue values[] = {{OPENED_DOCUMENTS_COL_ICON, "OPENED_DOCUMENTS_COL_ICON", "icon"}, {OPENED_DOCUMENTS_COL_NAME, "OPENED_DOCUMENTS_COL_NAME", "name"}, {OPENED_DOCUMENTS_COL_DOCUMENT, "OPENED_DOCUMENTS_COL_DOCUMENT", "document"}, {OPENED_DOCUMENTS_COL_STYLE, "OPENED_DOCUMENTS_COL_STYLE", "style"}, {OPENED_DOCUMENTS_COL_TOOLTIP, "OPENED_DOCUMENTS_COL_TOOLTIP", "tooltip"}, {OPENED_DOCUMENTS_COL_NB, "OPENED_DOCUMENTS_COL_NB", "nb"}, {0, NULL, NULL}};
		GType opened_documents_col_type_id;
		opened_documents_col_type_id = g_enum_register_static ("OpenedDocumentsCol", values);
		g_once_init_leave (&opened_documents_col_type_id__volatile, opened_documents_col_type_id);
	}
	return opened_documents_col_type_id__volatile;
}


#line 54 "opened-documents.vala"
static void opened_documents_on_action_activate (OpenedDocuments* self, GtkAction* action) {
#line 135 "opened-documents.c"
	gint _tokens_size_;
	gint tokens_length1;
	char** tokens;
	char** _tmp1_;
	char** _tmp0_;
#line 54 "opened-documents.vala"
	g_return_if_fail (self != NULL);
#line 54 "opened-documents.vala"
	g_return_if_fail (action != NULL);
#line 145 "opened-documents.c"
	tokens = (tokens_length1 = 0, NULL);
#line 58 "opened-documents.vala"
	tokens = (_tmp1_ = _tmp0_ = g_strsplit (gtk_action_get_name (action), "-", 0), tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL), tokens_length1 = _vala_array_length (_tmp0_), _tokens_size_ = tokens_length1, _tmp1_);
#line 59 "opened-documents.vala"
	if (tokens != NULL) {
#line 151 "opened-documents.c"
		gint page_num = 0;
#line 63 "opened-documents.vala"
		page_num = atoi (tokens[2]);
#line 64 "opened-documents.vala"
		gtk_notebook_set_current_page ((GtkNotebook*) valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), page_num - 1);
#line 157 "opened-documents.c"
	} else {
#line 68 "opened-documents.vala"
		g_debug ("opened-documents.vala:68: invalid action name: %s", gtk_action_get_name (action));
#line 161 "opened-documents.c"
	}
	tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 54 "opened-documents.vala"
static void _opened_documents_on_action_activate_gtk_radio_action_changed (GtkRadioAction* _sender, GtkRadioAction* current, gpointer self) {
#line 174 "opened-documents.c"
	opened_documents_on_action_activate (self, current);
}


#line 72 "opened-documents.vala"
static void opened_documents_populate_menu (OpenedDocuments* self) {
#line 181 "opened-documents.c"
	gint i;
	gint active = 0;
	ValideUIManager* ui_manager;
	GSList* group;
	ValideUIManager* _tmp0_;
	GtkActionGroup* _tmp1_;
#line 72 "opened-documents.vala"
	g_return_if_fail (self != NULL);
#line 74 "opened-documents.vala"
	i = 0;
#line 192 "opened-documents.c"
	ui_manager = NULL;
#line 77 "opened-documents.vala"
	group = NULL;
#line 79 "opened-documents.vala"
	ui_manager = (_tmp0_ = _g_object_ref0 (valide_window_get_ui_manager (valide_plugin_get_window ((ValidePlugin*) self))), _g_object_unref0 (ui_manager), _tmp0_);
#line 80 "opened-documents.vala"
	if (self->priv->ui_id != (-1)) {
#line 82 "opened-documents.vala"
		gtk_ui_manager_remove_ui ((GtkUIManager*) ui_manager, self->priv->ui_id);
#line 202 "opened-documents.c"
	}
#line 84 "opened-documents.vala"
	self->priv->ui_id = gtk_ui_manager_new_merge_id ((GtkUIManager*) ui_manager);
#line 86 "opened-documents.vala"
	self->priv->action_group = (_tmp1_ = gtk_action_group_new ("document-opened"), _g_object_unref0 (self->priv->action_group), _tmp1_);
#line 87 "opened-documents.vala"
	gtk_ui_manager_insert_action_group ((GtkUIManager*) ui_manager, self->priv->action_group, 0);
#line 89 "opened-documents.vala"
	active = gtk_notebook_get_current_page ((GtkNotebook*) self->priv->documents) + 1;
#line 212 "opened-documents.c"
	{
		GList* document_collection;
		GList* document_it;
#line 90 "opened-documents.vala"
		document_collection = valide_document_manager_get_documents (self->priv->documents);
#line 218 "opened-documents.c"
		for (document_it = document_collection; document_it != NULL; document_it = document_it->next) {
			ValideDocument* document;
#line 90 "opened-documents.vala"
			document = _g_object_ref0 ((ValideDocument*) document_it->data);
#line 223 "opened-documents.c"
			{
				char* accel;
				char* action_name;
				GtkRadioAction* action;
				char* _tmp2_;
				char* _tmp5_;
				char* _tmp6_;
				GtkRadioAction* _tmp8_;
				char* _tmp7_;
				accel = NULL;
				action_name = NULL;
				action = NULL;
#line 96 "opened-documents.vala"
				i++;
#line 238 "opened-documents.c"
				_tmp2_ = NULL;
#line 99 "opened-documents.vala"
				if (i < 11) {
#line 242 "opened-documents.c"
					char* _tmp3_;
#line 99 "opened-documents.vala"
					_tmp2_ = (_tmp3_ = g_strdup_printf ("<alt>%d", i % 10), _g_free0 (_tmp2_), _tmp3_);
#line 246 "opened-documents.c"
				} else {
					char* _tmp4_;
#line 99 "opened-documents.vala"
					_tmp2_ = (_tmp4_ = NULL, _g_free0 (_tmp2_), _tmp4_);
#line 251 "opened-documents.c"
				}
#line 99 "opened-documents.vala"
				accel = (_tmp5_ = g_strdup (_tmp2_), _g_free0 (accel), _tmp5_);
#line 101 "opened-documents.vala"
				action_name = (_tmp6_ = g_strdup_printf ("document-opened-%d", i), _g_free0 (action_name), _tmp6_);
#line 102 "opened-documents.vala"
				action = (_tmp8_ = gtk_radio_action_new (action_name, valide_document_get_filename (document), _tmp7_ = g_strdup_printf ("Activate %s", valide_document_get_path (document)), NULL, i), _g_object_unref0 (action), _tmp8_);
#line 259 "opened-documents.c"
				_g_free0 (_tmp7_);
#line 105 "opened-documents.vala"
				if (i == active) {
#line 107 "opened-documents.vala"
					gtk_toggle_action_set_active ((GtkToggleAction*) action, TRUE);
#line 265 "opened-documents.c"
				}
#line 109 "opened-documents.vala"
				if (group != NULL) {
#line 111 "opened-documents.vala"
					gtk_radio_action_set_group (action, group);
#line 271 "opened-documents.c"
				}
#line 114 "opened-documents.vala"
				group = gtk_radio_action_get_group (action);
#line 116 "opened-documents.vala"
				gtk_action_group_add_action_with_accel (self->priv->action_group, (GtkAction*) action, accel);
#line 118 "opened-documents.vala"
				g_signal_connect_object (action, "changed", (GCallback) _opened_documents_on_action_activate_gtk_radio_action_changed, self, 0);
#line 120 "opened-documents.vala"
				gtk_ui_manager_add_ui ((GtkUIManager*) ui_manager, self->priv->ui_id, "/menubar/document/document-ops-1", action_name, action_name, GTK_UI_MANAGER_MENUITEM, FALSE);
#line 281 "opened-documents.c"
				_g_object_unref0 (document);
				_g_free0 (accel);
				_g_free0 (action_name);
				_g_object_unref0 (action);
				_g_free0 (_tmp2_);
			}
		}
	}
	_g_object_unref0 (ui_manager);
}


#line 126 "opened-documents.vala"
static void opened_documents_populate_treeview (OpenedDocuments* self) {
#line 296 "opened-documents.c"
	GtkTreeIter iter = {0};
	GtkListStore* model;
	GtkListStore* _tmp1_;
	GtkTreeModel* _tmp0_;
#line 126 "opened-documents.vala"
	g_return_if_fail (self != NULL);
#line 303 "opened-documents.c"
	model = NULL;
#line 131 "opened-documents.vala"
	model = (_tmp1_ = _g_object_ref0 ((_tmp0_ = gtk_tree_view_get_model (self->priv->tree_view), GTK_IS_LIST_STORE (_tmp0_) ? ((GtkListStore*) _tmp0_) : NULL)), _g_object_unref0 (model), _tmp1_);
#line 132 "opened-documents.vala"
	gtk_list_store_clear (model);
#line 309 "opened-documents.c"
	{
		GList* document_collection;
		GList* document_it;
#line 134 "opened-documents.vala"
		document_collection = valide_document_manager_get_documents (self->priv->documents);
#line 315 "opened-documents.c"
		for (document_it = document_collection; document_it != NULL; document_it = document_it->next) {
			ValideDocument* document;
#line 134 "opened-documents.vala"
			document = _g_object_ref0 ((ValideDocument*) document_it->data);
#line 320 "opened-documents.c"
			{
				char* tooltip;
				PangoStyle style = 0;
				char* _tmp2_;
				GdkPixbuf* _tmp3_;
				tooltip = NULL;
#line 139 "opened-documents.vala"
				if (valide_document_get_is_save (document)) {
#line 141 "opened-documents.vala"
					style = PANGO_STYLE_NORMAL;
#line 331 "opened-documents.c"
				} else {
#line 145 "opened-documents.vala"
					style = PANGO_STYLE_ITALIC;
#line 335 "opened-documents.c"
				}
#line 147 "opened-documents.vala"
				tooltip = (_tmp2_ = valide_document_get_tooltips (document), _g_free0 (tooltip), _tmp2_);
#line 148 "opened-documents.vala"
				gtk_list_store_append (model, &iter);
#line 149 "opened-documents.vala"
				gtk_list_store_set (model, &iter, OPENED_DOCUMENTS_COL_ICON, _tmp3_ = valide_document_get_icon (document), OPENED_DOCUMENTS_COL_NAME, valide_document_get_filename (document), OPENED_DOCUMENTS_COL_DOCUMENT, document, OPENED_DOCUMENTS_COL_STYLE, style, OPENED_DOCUMENTS_COL_TOOLTIP, tooltip, -1);
#line 343 "opened-documents.c"
				_g_object_unref0 (_tmp3_);
#line 154 "opened-documents.vala"
				if (document == valide_document_manager_get_current (self->priv->documents)) {
#line 156 "opened-documents.vala"
					gtk_tree_selection_select_iter (gtk_tree_view_get_selection (self->priv->tree_view), &iter);
#line 349 "opened-documents.c"
				}
				_g_object_unref0 (document);
				_g_free0 (tooltip);
			}
		}
	}
	_g_object_unref0 (model);
}


#line 161 "opened-documents.vala"
static gboolean opened_documents_populate_asc (OpenedDocuments* self) {
#line 362 "opened-documents.c"
	gboolean result = FALSE;
#line 161 "opened-documents.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 163 "opened-documents.vala"
	if (!self->priv->on_idle) {
#line 165 "opened-documents.vala"
		self->priv->on_idle = TRUE;
#line 166 "opened-documents.vala"
		opened_documents_populate_menu (self);
#line 167 "opened-documents.vala"
		opened_documents_populate_treeview (self);
#line 168 "opened-documents.vala"
		self->priv->on_idle = FALSE;
#line 376 "opened-documents.c"
	}
	result = FALSE;
#line 170 "opened-documents.vala"
	return result;
#line 381 "opened-documents.c"
}


#line 161 "opened-documents.vala"
static gboolean _opened_documents_populate_asc_gsource_func (gpointer self) {
#line 387 "opened-documents.c"
	return opened_documents_populate_asc (self);
}


#line 173 "opened-documents.vala"
static void opened_documents_populate (OpenedDocuments* self) {
#line 173 "opened-documents.vala"
	g_return_if_fail (self != NULL);
#line 175 "opened-documents.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _opened_documents_populate_asc_gsource_func, g_object_ref (self), g_object_unref);
#line 398 "opened-documents.c"
}


#line 178 "opened-documents.vala"
static void opened_documents_on_cursor_change (OpenedDocuments* self, GtkTreeView* sender) {
#line 404 "opened-documents.c"
	ValideDocument* document;
	GtkTreeIter iter = {0};
	GtkTreeModel* model;
	GtkTreeSelection* selection;
	GtkTreeSelection* _tmp0_;
	GtkTreeModel* _tmp3_;
	gboolean _tmp2_;
	GtkTreeModel* _tmp1_ = NULL;
#line 178 "opened-documents.vala"
	g_return_if_fail (self != NULL);
#line 178 "opened-documents.vala"
	g_return_if_fail (sender != NULL);
#line 417 "opened-documents.c"
	document = NULL;
	model = NULL;
	selection = NULL;
#line 185 "opened-documents.vala"
	selection = (_tmp0_ = _g_object_ref0 (gtk_tree_view_get_selection (self->priv->tree_view)), _g_object_unref0 (selection), _tmp0_);
#line 187 "opened-documents.vala"
	if ((_tmp2_ = gtk_tree_selection_get_selected (selection, &_tmp1_, &iter), model = (_tmp3_ = _g_object_ref0 (_tmp1_), _g_object_unref0 (model), _tmp3_), _tmp2_)) {
#line 189 "opened-documents.vala"
		gtk_tree_model_get (model, &iter, OPENED_DOCUMENTS_COL_DOCUMENT, &document, -1);
#line 190 "opened-documents.vala"
		valide_document_manager_set_current (self->priv->documents, document);
#line 429 "opened-documents.c"
	}
	_g_object_unref0 (document);
	_g_object_unref0 (model);
	_g_object_unref0 (selection);
}


#line 24 "opened-documents.vala"
OpenedDocuments* opened_documents_construct (GType object_type) {
#line 439 "opened-documents.c"
	OpenedDocuments * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


#line 24 "opened-documents.vala"
OpenedDocuments* opened_documents_new (void) {
#line 24 "opened-documents.vala"
	return opened_documents_construct (TYPE_OPENED_DOCUMENTS);
#line 450 "opened-documents.c"
}


static const char* opened_documents_real_get_path (ValidePlugin* base) {
	const char* result;
	OpenedDocuments* self;
	self = (OpenedDocuments*) base;
	result = self->priv->_path;
#line 47 "opened-documents.vala"
	return result;
#line 461 "opened-documents.c"
}


static void opened_documents_real_set_path (ValidePlugin* base, const char* value) {
	OpenedDocuments* self;
	char* _tmp0_;
	self = (OpenedDocuments*) base;
	self->priv->_path = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_path), _tmp0_);
	g_object_notify ((GObject *) self, "path");
}


static ValideWindow* opened_documents_real_get_window (ValidePlugin* base) {
	ValideWindow* result;
	OpenedDocuments* self;
	self = (OpenedDocuments*) base;
	result = self->priv->_window;
#line 52 "opened-documents.vala"
	return result;
#line 481 "opened-documents.c"
}


static void opened_documents_real_set_window (ValidePlugin* base, ValideWindow* value) {
	OpenedDocuments* self;
	ValideWindow* _tmp0_;
	self = (OpenedDocuments*) base;
	self->priv->_window = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_window), _tmp0_);
	g_object_notify ((GObject *) self, "window");
}


#line 178 "opened-documents.vala"
static void _opened_documents_on_cursor_change_gtk_tree_view_cursor_changed (GtkTreeView* _sender, gpointer self) {
#line 496 "opened-documents.c"
	opened_documents_on_cursor_change (self, _sender);
}


#line 173 "opened-documents.vala"
static void _opened_documents_populate_valide_document_manager_tab_removed (ValideDocumentManager* _sender, ValideDocument* document, gpointer self) {
#line 503 "opened-documents.c"
	opened_documents_populate (self);
}


#line 173 "opened-documents.vala"
static void _opened_documents_populate_valide_document_manager_tab_added (ValideDocumentManager* _sender, ValideDocument* document, gpointer self) {
#line 510 "opened-documents.c"
	opened_documents_populate (self);
}


#line 173 "opened-documents.vala"
static void _opened_documents_populate_valide_document_manager_tab_state_changed (ValideDocumentManager* _sender, ValideDocument* document, gpointer self) {
#line 517 "opened-documents.c"
	opened_documents_populate (self);
}


#line 173 "opened-documents.vala"
static void _opened_documents_populate_valide_document_manager_tab_changed (ValideDocumentManager* _sender, ValideDocument* document, gpointer self) {
#line 524 "opened-documents.c"
	opened_documents_populate (self);
}


#line 173 "opened-documents.vala"
static void _opened_documents_populate_gtk_notebook_page_reordered (GtkNotebook* _sender, GtkWidget* p0, guint p1, gpointer self) {
#line 531 "opened-documents.c"
	opened_documents_populate (self);
}


static GObject * opened_documents_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	OpenedDocuments * self;
	parent_class = G_OBJECT_CLASS (opened_documents_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = OPENED_DOCUMENTS (obj);
	{
		GtkListStore* store;
		GdlDockItem* parent;
		GtkTreeViewColumn* col;
		GtkCellRenderer* renderer;
		GtkScrolledWindow* scrolled;
		GtkVBox* _tmp0_;
		GtkScrolledWindow* _tmp1_;
		GtkTreeView* _tmp2_;
		GtkListStore* _tmp3_;
		GtkTreeViewColumn* _tmp4_;
		GtkCellRenderer* _tmp5_;
		GtkCellRenderer* _tmp6_;
		ValideDocumentManager* _tmp7_;
		store = NULL;
		parent = NULL;
		col = NULL;
		renderer = NULL;
		scrolled = NULL;
#line 202 "opened-documents.vala"
		self->priv->box = (_tmp0_ = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 0)), _g_object_unref0 (self->priv->box), _tmp0_);
#line 205 "opened-documents.vala"
		gtk_box_set_spacing ((GtkBox*) self->priv->box, 2);
#line 206 "opened-documents.vala"
		gtk_container_set_border_width ((GtkContainer*) self->priv->box, (guint) 2);
#line 209 "opened-documents.vala"
		scrolled = (_tmp1_ = g_object_ref_sink ((GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL)), _g_object_unref0 (scrolled), _tmp1_);
#line 210 "opened-documents.vala"
		gtk_scrolled_window_set_policy (scrolled, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
#line 211 "opened-documents.vala"
		gtk_scrolled_window_set_shadow_type (scrolled, GTK_SHADOW_IN);
#line 212 "opened-documents.vala"
		gtk_box_pack_start ((GtkBox*) self->priv->box, (GtkWidget*) scrolled, TRUE, TRUE, (guint) 0);
#line 214 "opened-documents.vala"
		self->priv->tree_view = (_tmp2_ = g_object_ref_sink ((GtkTreeView*) gtk_tree_view_new ()), _g_object_unref0 (self->priv->tree_view), _tmp2_);
#line 215 "opened-documents.vala"
		gtk_tree_view_set_rules_hint (self->priv->tree_view, FALSE);
#line 216 "opened-documents.vala"
		gtk_tree_view_set_headers_visible (self->priv->tree_view, FALSE);
#line 217 "opened-documents.vala"
		gtk_container_add ((GtkContainer*) scrolled, (GtkWidget*) self->priv->tree_view);
#line 220 "opened-documents.vala"
		store = (_tmp3_ = gtk_list_store_new ((gint) OPENED_DOCUMENTS_COL_NB, GDK_TYPE_PIXBUF, G_TYPE_STRING, VALIDE_TYPE_DOCUMENT, PANGO_TYPE_STYLE, G_TYPE_STRING, NULL), _g_object_unref0 (store), _tmp3_);
#line 223 "opened-documents.vala"
		gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) store, (gint) OPENED_DOCUMENTS_COL_NAME, GTK_SORT_ASCENDING);
#line 226 "opened-documents.vala"
		col = (_tmp4_ = g_object_ref_sink (gtk_tree_view_column_new ()), _g_object_unref0 (col), _tmp4_);
#line 227 "opened-documents.vala"
		gtk_tree_view_column_set_title (col, _ ("File"));
#line 229 "opened-documents.vala"
		renderer = (_tmp5_ = (GtkCellRenderer*) g_object_ref_sink ((GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ()), _g_object_unref0 (renderer), _tmp5_);
#line 230 "opened-documents.vala"
		gtk_cell_layout_pack_start ((GtkCellLayout*) col, renderer, FALSE);
#line 231 "opened-documents.vala"
		gtk_tree_view_column_set_attributes (col, renderer, "pixbuf", OPENED_DOCUMENTS_COL_ICON, NULL);
#line 233 "opened-documents.vala"
		renderer = (_tmp6_ = (GtkCellRenderer*) g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ()), _g_object_unref0 (renderer), _tmp6_);
#line 234 "opened-documents.vala"
		gtk_cell_layout_pack_start ((GtkCellLayout*) col, renderer, FALSE);
#line 235 "opened-documents.vala"
		gtk_tree_view_column_set_attributes (col, renderer, "markup", OPENED_DOCUMENTS_COL_NAME, "style", OPENED_DOCUMENTS_COL_STYLE, NULL);
#line 237 "opened-documents.vala"
		gtk_tree_view_append_column (self->priv->tree_view, col);
#line 238 "opened-documents.vala"
		gtk_tree_view_set_model (self->priv->tree_view, (GtkTreeModel*) store);
#line 240 "opened-documents.vala"
		gtk_tree_view_set_tooltip_column (self->priv->tree_view, (gint) OPENED_DOCUMENTS_COL_TOOLTIP);
#line 243 "opened-documents.vala"
		g_signal_connect_object (self->priv->tree_view, "cursor-changed", (GCallback) _opened_documents_on_cursor_change_gtk_tree_view_cursor_changed, self, 0);
#line 245 "opened-documents.vala"
		self->priv->documents = (_tmp7_ = _g_object_ref0 (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self))), _g_object_unref0 (self->priv->documents), _tmp7_);
#line 248 "opened-documents.vala"
		opened_documents_populate_asc (self);
#line 250 "opened-documents.vala"
		g_signal_connect_object (self->priv->documents, "tab-removed", (GCallback) _opened_documents_populate_valide_document_manager_tab_removed, self, 0);
#line 251 "opened-documents.vala"
		g_signal_connect_object (self->priv->documents, "tab-added", (GCallback) _opened_documents_populate_valide_document_manager_tab_added, self, 0);
#line 252 "opened-documents.vala"
		g_signal_connect_object (self->priv->documents, "tab-state-changed", (GCallback) _opened_documents_populate_valide_document_manager_tab_state_changed, self, 0);
#line 253 "opened-documents.vala"
		g_signal_connect_object (self->priv->documents, "tab-changed", (GCallback) _opened_documents_populate_valide_document_manager_tab_changed, self, 0);
#line 254 "opened-documents.vala"
		g_signal_connect_object ((GtkNotebook*) self->priv->documents, "page-reordered", (GCallback) _opened_documents_populate_gtk_notebook_page_reordered, self, 0);
#line 256 "opened-documents.vala"
		valide_window_add_widget (valide_plugin_get_window ((ValidePlugin*) self), (GtkWidget*) self->priv->box, "opened-documents-plugin", _ ("Documents"), VALIDE_WINDOW_PLACEMENT_LEFT, GTK_STOCK_FILE);
#line 628 "opened-documents.c"
		_g_object_unref0 (store);
		_g_object_unref0 (parent);
		_g_object_unref0 (col);
		_g_object_unref0 (renderer);
		_g_object_unref0 (scrolled);
	}
	return obj;
}


static void opened_documents_class_init (OpenedDocumentsClass * klass) {
	opened_documents_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (OpenedDocumentsPrivate));
	G_OBJECT_CLASS (klass)->get_property = opened_documents_get_property;
	G_OBJECT_CLASS (klass)->set_property = opened_documents_set_property;
	G_OBJECT_CLASS (klass)->constructor = opened_documents_constructor;
	G_OBJECT_CLASS (klass)->finalize = opened_documents_finalize;
	g_object_class_override_property (G_OBJECT_CLASS (klass), OPENED_DOCUMENTS_PATH, "path");
	g_object_class_override_property (G_OBJECT_CLASS (klass), OPENED_DOCUMENTS_WINDOW, "window");
}


static void opened_documents_valide_plugin_interface_init (ValidePluginIface * iface) {
	opened_documents_valide_plugin_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_path = opened_documents_real_get_path;
	iface->set_path = opened_documents_real_set_path;
	iface->get_window = opened_documents_real_get_window;
	iface->set_window = opened_documents_real_set_window;
}


static void opened_documents_instance_init (OpenedDocuments * self) {
	self->priv = OPENED_DOCUMENTS_GET_PRIVATE (self);
	self->priv->ui_id = (guint) (-1);
	self->priv->on_idle = FALSE;
}


static void opened_documents_finalize (GObject* obj) {
	OpenedDocuments * self;
	self = OPENED_DOCUMENTS (obj);
	{
		guint _tmp8_;
		guint _tmp9_;
		guint _tmp10_;
		guint _tmp11_;
		guint _tmp12_;
#line 262 "opened-documents.vala"
		g_signal_parse_name ("tab-removed", VALIDE_TYPE_DOCUMENT_MANAGER, &_tmp8_, NULL, FALSE);
#line 262 "opened-documents.vala"
		g_signal_handlers_disconnect_matched (self->priv->documents, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _opened_documents_populate_valide_document_manager_tab_removed, self);
#line 263 "opened-documents.vala"
		g_signal_parse_name ("tab-added", VALIDE_TYPE_DOCUMENT_MANAGER, &_tmp9_, NULL, FALSE);
#line 263 "opened-documents.vala"
		g_signal_handlers_disconnect_matched (self->priv->documents, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _opened_documents_populate_valide_document_manager_tab_added, self);
#line 264 "opened-documents.vala"
		g_signal_parse_name ("tab-state-changed", VALIDE_TYPE_DOCUMENT_MANAGER, &_tmp10_, NULL, FALSE);
#line 264 "opened-documents.vala"
		g_signal_handlers_disconnect_matched (self->priv->documents, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _opened_documents_populate_valide_document_manager_tab_state_changed, self);
#line 265 "opened-documents.vala"
		g_signal_parse_name ("tab-changed", VALIDE_TYPE_DOCUMENT_MANAGER, &_tmp11_, NULL, FALSE);
#line 265 "opened-documents.vala"
		g_signal_handlers_disconnect_matched (self->priv->documents, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _opened_documents_populate_valide_document_manager_tab_changed, self);
#line 266 "opened-documents.vala"
		g_signal_parse_name ("page-reordered", GTK_TYPE_NOTEBOOK, &_tmp12_, NULL, FALSE);
#line 266 "opened-documents.vala"
		g_signal_handlers_disconnect_matched ((GtkNotebook*) self->priv->documents, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp12_, 0, NULL, (GCallback) _opened_documents_populate_gtk_notebook_page_reordered, self);
#line 268 "opened-documents.vala"
		if (self->priv->ui_id > 0) {
#line 270 "opened-documents.vala"
			gtk_ui_manager_remove_action_group ((GtkUIManager*) valide_window_get_ui_manager (valide_plugin_get_window ((ValidePlugin*) self)), self->priv->action_group);
#line 700 "opened-documents.c"
		}
#line 272 "opened-documents.vala"
		valide_window_remove_widget (valide_plugin_get_window ((ValidePlugin*) self), (GtkWidget*) self->priv->box);
#line 704 "opened-documents.c"
	}
	_g_object_unref0 (self->priv->box);
	_g_object_unref0 (self->priv->tree_view);
	_g_object_unref0 (self->priv->documents);
	_g_object_unref0 (self->priv->action_group);
	_g_free0 (self->priv->_path);
	_g_object_unref0 (self->priv->_window);
	G_OBJECT_CLASS (opened_documents_parent_class)->finalize (obj);
}


GType opened_documents_get_type (void) {
	static volatile gsize opened_documents_type_id__volatile = 0;
	if (g_once_init_enter (&opened_documents_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (OpenedDocumentsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) opened_documents_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (OpenedDocuments), 0, (GInstanceInitFunc) opened_documents_instance_init, NULL };
		static const GInterfaceInfo valide_plugin_info = { (GInterfaceInitFunc) opened_documents_valide_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType opened_documents_type_id;
		opened_documents_type_id = g_type_register_static (G_TYPE_OBJECT, "OpenedDocuments", &g_define_type_info, 0);
		g_type_add_interface_static (opened_documents_type_id, VALIDE_TYPE_PLUGIN, &valide_plugin_info);
		g_once_init_leave (&opened_documents_type_id__volatile, opened_documents_type_id);
	}
	return opened_documents_type_id__volatile;
}


static void opened_documents_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	OpenedDocuments * self;
	self = OPENED_DOCUMENTS (object);
	switch (property_id) {
		case OPENED_DOCUMENTS_PATH:
		g_value_set_string (value, valide_plugin_get_path ((ValidePlugin*) self));
		break;
		case OPENED_DOCUMENTS_WINDOW:
		g_value_set_object (value, valide_plugin_get_window ((ValidePlugin*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void opened_documents_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	OpenedDocuments * self;
	self = OPENED_DOCUMENTS (object);
	switch (property_id) {
		case OPENED_DOCUMENTS_PATH:
		valide_plugin_set_path ((ValidePlugin*) self, g_value_get_string (value));
		break;
		case OPENED_DOCUMENTS_WINDOW:
		valide_plugin_set_window ((ValidePlugin*) self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


#line 277 "opened-documents.vala"
GType register_plugin (void* user_data, GError** error) {
#line 766 "opened-documents.c"
	GType result = 0UL;
	result = TYPE_OPENED_DOCUMENTS;
#line 279 "opened-documents.vala"
	return result;
#line 771 "opened-documents.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}




