/* start-page.c generated by valac, the Vala compiler
 * generated from start-page.vala, do not modify */

/* start-page.vala
 *
 * Copyright (C) 2008-2010 Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <valide-0.0.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <cairo.h>
#include <config.h>


#define TYPE_ITEM (item_get_type ())
typedef struct _Item Item;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_START_PAGE (start_page_get_type ())
#define START_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_START_PAGE, StartPage))
#define START_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_START_PAGE, StartPageClass))
#define IS_START_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_START_PAGE))
#define IS_START_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_START_PAGE))
#define START_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_START_PAGE, StartPageClass))

typedef struct _StartPage StartPage;
typedef struct _StartPageClass StartPageClass;
typedef struct _StartPagePrivate StartPagePrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __g_list_free_item_free0(var) ((var == NULL) ? NULL : (var = (_g_list_free_item_free (var), NULL)))
#define _gtk_recent_info_unref0(var) ((var == NULL) ? NULL : (var = (gtk_recent_info_unref (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _Item {
	char* uri;
	char* text;
	GdkPixbuf* icon;
	GCallback callback;
};

struct _StartPage {
	GObject parent_instance;
	StartPagePrivate * priv;
};

struct _StartPageClass {
	GObjectClass parent_class;
};

struct _StartPagePrivate {
	GtkTable* table;
	GdkPixbuf* logo;
	GtkEventBox* event_box;
	GtkWidget* file_frame;
	GtkWidget* project_frame;
	guint status_context;
	GtkScrolledWindow* scrolled_window;
	ValideWindow* _window;
	char* _path;
};


static gpointer start_page_parent_class = NULL;
static ValidePluginIface* start_page_valide_plugin_parent_iface = NULL;

GType item_get_type (void);
Item* item_dup (const Item* self);
void item_free (Item* self);
void item_copy (const Item* self, Item* dest);
void item_destroy (Item* self);
GType start_page_get_type (void);
#define START_PAGE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_START_PAGE, StartPagePrivate))
enum  {
	START_PAGE_DUMMY_PROPERTY,
	START_PAGE_WINDOW,
	START_PAGE_PATH
};
static void start_page_create_project (GtkButton* sender, StartPage* self);
static void start_page_open_project (GtkButton* sender, StartPage* self);
static void start_page_create_file (GtkButton* sender, StartPage* self);
static void start_page_open_file (GtkButton* sender, StartPage* self);
static void start_page_open_link (GtkButton* sender, StartPage* self);
static void start_page_send_message (StartPage* self, const char* message);
static gboolean start_page_button_leave_notify_event (StartPage* self, GtkWidget* sender, GdkEventCrossing* event);
static gboolean start_page_button_enter_notify_event (StartPage* self, GtkWidget* sender, GdkEventCrossing* event);
static GtkButton* start_page_create_button (StartPage* self, const char* uri, const char* text, GdkPixbuf* icon);
static gboolean _start_page_button_enter_notify_event_gtk_widget_enter_notify_event (GtkWidget* _sender, GdkEventCrossing* event, gpointer self);
static gboolean _start_page_button_leave_notify_event_gtk_widget_leave_notify_event (GtkWidget* _sender, GdkEventCrossing* event, gpointer self);
static GtkWidget* start_page_create_frame (StartPage* self, const char* title, GList* items);
static void _g_list_free_item_free (GList* self);
static GtkWidget* start_page_populate_frame (StartPage* self, GList* infos, const char* title, GCallback callback);
static void start_page_populate_file_frame (StartPage* self);
static void start_page_populate_project_frame (StartPage* self);
static gboolean start_page_on_expose_event_cb (StartPage* self, GtkWidget* widget, GdkEventExpose* event);
StartPage* start_page_new (void);
StartPage* start_page_construct (GType object_type);
static gboolean _start_page_on_expose_event_cb_gtk_widget_expose_event (GtkWidget* _sender, GdkEventExpose* event, gpointer self);
static void _start_page_populate_project_frame_valide_recent_manager_ui_update_recent_projects (ValideRecentManagerUI* _sender, gpointer self);
static void _start_page_populate_file_frame_valide_recent_manager_ui_update_recent_files (ValideRecentManagerUI* _sender, gpointer self);
static void _lambda0_ (StartPage* self);
static void __lambda0__gtk_widget_show (GtkWidget* _sender, gpointer self);
static GObject * start_page_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void start_page_finalize (GObject* obj);
static void start_page_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void start_page_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType register_plugin (void* user_data, GError** error);
static int _vala_strcmp0 (const char * str1, const char * str2);



static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void item_copy (const Item* self, Item* dest) {
	dest->uri = g_strdup (self->uri);
	dest->text = g_strdup (self->text);
	dest->icon = _g_object_ref0 (self->icon);
	dest->callback = self->callback;
}


void item_destroy (Item* self) {
	_g_free0 (self->uri);
	_g_free0 (self->text);
	_g_object_unref0 (self->icon);
}


Item* item_dup (const Item* self) {
	Item* dup;
	dup = g_new0 (Item, 1);
	item_copy (self, dup);
	return dup;
}


void item_free (Item* self) {
	item_destroy (self);
	g_free (self);
}


GType item_get_type (void) {
	static volatile gsize item_type_id__volatile = 0;
	if (g_once_init_enter (&item_type_id__volatile)) {
		GType item_type_id;
		item_type_id = g_boxed_type_register_static ("Item", (GBoxedCopyFunc) item_dup, (GBoxedFreeFunc) item_free);
		g_once_init_leave (&item_type_id__volatile, item_type_id);
	}
	return item_type_id__volatile;
}


#line 56 "start-page.vala"
static void start_page_create_project (GtkButton* sender, StartPage* self) {
#line 56 "start-page.vala"
	g_return_if_fail (self != NULL);
#line 56 "start-page.vala"
	g_return_if_fail (sender != NULL);
#line 58 "start-page.vala"
	valide_project_manager_create (valide_window_get_projects (valide_plugin_get_window ((ValidePlugin*) self)));
#line 195 "start-page.c"
}


#line 62 "start-page.vala"
static void start_page_open_project (GtkButton* sender, StartPage* self) {
#line 201 "start-page.c"
	GError * _inner_error_;
	char* uri;
	char* _tmp0_;
#line 62 "start-page.vala"
	g_return_if_fail (self != NULL);
#line 62 "start-page.vala"
	g_return_if_fail (sender != NULL);
#line 209 "start-page.c"
	_inner_error_ = NULL;
	uri = NULL;
#line 66 "start-page.vala"
	uri = (_tmp0_ = g_strdup ((const char*) g_object_get_data ((GObject*) sender, "uri")), _g_free0 (uri), _tmp0_);
#line 214 "start-page.c"
	{
#line 69 "start-page.vala"
		valide_project_manager_open (valide_window_get_projects (valide_plugin_get_window ((ValidePlugin*) self)), uri, &_inner_error_);
#line 218 "start-page.c"
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 73 "start-page.vala"
			g_warning ("start-page.vala:73: %s", e->message);
#line 232 "start-page.c"
			_g_error_free0 (e);
		}
	}
	__finally0:
	if (_inner_error_ != NULL) {
		_g_free0 (uri);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_free0 (uri);
}


#line 78 "start-page.vala"
static void start_page_create_file (GtkButton* sender, StartPage* self) {
#line 249 "start-page.c"
	GError * _inner_error_;
#line 78 "start-page.vala"
	g_return_if_fail (self != NULL);
#line 78 "start-page.vala"
	g_return_if_fail (sender != NULL);
#line 255 "start-page.c"
	_inner_error_ = NULL;
	{
		ValideDocument* _tmp0_;
#line 82 "start-page.vala"
		_tmp0_ = valide_document_manager_create (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), NULL, &_inner_error_);
#line 261 "start-page.c"
		_g_object_unref0 (_tmp0_);
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 86 "start-page.vala"
			g_warning ("start-page.vala:86: %s", e->message);
#line 276 "start-page.c"
			_g_error_free0 (e);
		}
	}
	__finally1:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


#line 91 "start-page.vala"
static void start_page_open_file (GtkButton* sender, StartPage* self) {
#line 291 "start-page.c"
	GError * _inner_error_;
	char* uri;
	char* _tmp0_;
#line 91 "start-page.vala"
	g_return_if_fail (self != NULL);
#line 91 "start-page.vala"
	g_return_if_fail (sender != NULL);
#line 299 "start-page.c"
	_inner_error_ = NULL;
	uri = NULL;
#line 95 "start-page.vala"
	uri = (_tmp0_ = g_strdup ((const char*) g_object_get_data ((GObject*) sender, "uri")), _g_free0 (uri), _tmp0_);
#line 304 "start-page.c"
	{
#line 98 "start-page.vala"
		if (uri == NULL) {
#line 100 "start-page.vala"
			valide_document_manager_open (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), &_inner_error_);
#line 310 "start-page.c"
			if (_inner_error_ != NULL) {
				goto __catch2_g_error;
			}
		} else {
			ValideDocument* _tmp1_;
#line 104 "start-page.vala"
			_tmp1_ = valide_document_manager_create (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), uri, &_inner_error_);
#line 318 "start-page.c"
			_g_object_unref0 (_tmp1_);
			if (_inner_error_ != NULL) {
				goto __catch2_g_error;
			}
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 109 "start-page.vala"
			g_warning ("start-page.vala:109: %s", e->message);
#line 334 "start-page.c"
			_g_error_free0 (e);
		}
	}
	__finally2:
	if (_inner_error_ != NULL) {
		_g_free0 (uri);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_free0 (uri);
}


#line 114 "start-page.vala"
static void start_page_open_link (GtkButton* sender, StartPage* self) {
#line 351 "start-page.c"
	GError * _inner_error_;
	char* uri;
	char* _tmp0_;
#line 114 "start-page.vala"
	g_return_if_fail (self != NULL);
#line 114 "start-page.vala"
	g_return_if_fail (sender != NULL);
#line 359 "start-page.c"
	_inner_error_ = NULL;
	uri = NULL;
#line 118 "start-page.vala"
	uri = (_tmp0_ = g_strdup ((const char*) g_object_get_data ((GObject*) sender, "uri")), _g_free0 (uri), _tmp0_);
#line 119 "start-page.vala"
	if (uri != NULL) {
#line 366 "start-page.c"
		{
#line 123 "start-page.vala"
			g_app_info_launch_default_for_uri (uri, NULL, &_inner_error_);
#line 370 "start-page.c"
			if (_inner_error_ != NULL) {
				goto __catch3_g_error;
			}
		}
		goto __finally3;
		__catch3_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
#line 127 "start-page.vala"
				g_warning ("start-page.vala:127: %s", e->message);
#line 384 "start-page.c"
				_g_error_free0 (e);
			}
		}
		__finally3:
		if (_inner_error_ != NULL) {
			_g_free0 (uri);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_free0 (uri);
}


#line 132 "start-page.vala"
static void start_page_send_message (StartPage* self, const char* message) {
#line 132 "start-page.vala"
	g_return_if_fail (self != NULL);
#line 132 "start-page.vala"
	g_return_if_fail (message != NULL);
#line 134 "start-page.vala"
	if (self->priv->status_context == (-1)) {
#line 136 "start-page.vala"
		self->priv->status_context = gtk_statusbar_get_context_id ((GtkStatusbar*) valide_window_get_statusbar (valide_plugin_get_window ((ValidePlugin*) self)), "valide_start_page");
#line 410 "start-page.c"
	}
#line 138 "start-page.vala"
	gtk_statusbar_push ((GtkStatusbar*) valide_window_get_statusbar (valide_plugin_get_window ((ValidePlugin*) self)), self->priv->status_context, message);
#line 414 "start-page.c"
}


#line 141 "start-page.vala"
static gboolean start_page_button_leave_notify_event (StartPage* self, GtkWidget* sender, GdkEventCrossing* event) {
#line 420 "start-page.c"
	gboolean result = FALSE;
#line 141 "start-page.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 141 "start-page.vala"
	g_return_val_if_fail (sender != NULL, FALSE);
#line 144 "start-page.vala"
	start_page_send_message (self, "");
#line 428 "start-page.c"
	result = FALSE;
#line 145 "start-page.vala"
	return result;
#line 432 "start-page.c"
}


#line 148 "start-page.vala"
static gboolean start_page_button_enter_notify_event (StartPage* self, GtkWidget* sender, GdkEventCrossing* event) {
#line 438 "start-page.c"
	gboolean result = FALSE;
	char* uri;
	GtkButton* button;
	char* status_message;
	GtkButton* _tmp1_;
	GtkWidget* _tmp0_;
	char* _tmp2_;
#line 148 "start-page.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 148 "start-page.vala"
	g_return_val_if_fail (sender != NULL, FALSE);
#line 450 "start-page.c"
	uri = NULL;
	button = NULL;
	status_message = NULL;
#line 155 "start-page.vala"
	button = (_tmp1_ = _g_object_ref0 ((_tmp0_ = sender, GTK_IS_BUTTON (_tmp0_) ? ((GtkButton*) _tmp0_) : NULL)), _g_object_unref0 (button), _tmp1_);
#line 156 "start-page.vala"
	uri = (_tmp2_ = g_strdup ((const char*) g_object_get_data ((GObject*) button, "uri")), _g_free0 (uri), _tmp2_);
#line 157 "start-page.vala"
	if (uri != NULL) {
#line 460 "start-page.c"
		char* _tmp3_;
		char* _tmp4_;
#line 159 "start-page.vala"
		uri = (_tmp3_ = valide_utils_replace_home_dir_with_tilde (uri), _g_free0 (uri), _tmp3_);
#line 160 "start-page.vala"
		status_message = (_tmp4_ = g_strdup_printf (_ ("Open %s"), uri), _g_free0 (status_message), _tmp4_);
#line 467 "start-page.c"
	} else {
		char* _tmp5_;
#line 164 "start-page.vala"
		status_message = (_tmp5_ = g_strdup (""), _g_free0 (status_message), _tmp5_);
#line 472 "start-page.c"
	}
#line 166 "start-page.vala"
	start_page_send_message (self, status_message);
#line 476 "start-page.c"
	result = FALSE;
	_g_free0 (uri);
	_g_object_unref0 (button);
	_g_free0 (status_message);
#line 167 "start-page.vala"
	return result;
#line 483 "start-page.c"
}


#line 170 "start-page.vala"
static GtkButton* start_page_create_button (StartPage* self, const char* uri, const char* text, GdkPixbuf* icon) {
#line 489 "start-page.c"
	GtkButton* result = NULL;
	char* markup;
	GtkHBox* hbox;
	GtkLabel* label;
	GtkButton* button;
	GtkButton* _tmp0_;
	GtkHBox* _tmp1_;
	char* _tmp3_;
	GtkLabel* _tmp4_;
#line 170 "start-page.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 170 "start-page.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 503 "start-page.c"
	markup = NULL;
	hbox = NULL;
	label = NULL;
	button = NULL;
#line 177 "start-page.vala"
	button = (_tmp0_ = g_object_ref_sink ((GtkButton*) gtk_button_new ()), _g_object_unref0 (button), _tmp0_);
#line 178 "start-page.vala"
	gtk_button_set_relief (button, GTK_RELIEF_NONE);
#line 179 "start-page.vala"
	gtk_button_set_alignment (button, (float) 0, 0.5f);
#line 181 "start-page.vala"
	hbox = (_tmp1_ = g_object_ref_sink ((GtkHBox*) gtk_hbox_new (FALSE, 5)), _g_object_unref0 (hbox), _tmp1_);
#line 182 "start-page.vala"
	gtk_container_add ((GtkContainer*) button, (GtkWidget*) hbox);
#line 184 "start-page.vala"
	if (icon != NULL) {
#line 520 "start-page.c"
		GtkImage* image;
		GtkImage* _tmp2_;
		image = NULL;
#line 188 "start-page.vala"
		image = (_tmp2_ = g_object_ref_sink ((GtkImage*) gtk_image_new_from_pixbuf (icon)), _g_object_unref0 (image), _tmp2_);
#line 189 "start-page.vala"
		gtk_box_pack_start ((GtkBox*) hbox, (GtkWidget*) image, FALSE, FALSE, (guint) 0);
#line 528 "start-page.c"
		_g_object_unref0 (image);
	}
#line 192 "start-page.vala"
	markup = (_tmp3_ = g_markup_printf_escaped ("<span underline=\"single\" foreground=\"#5a7ac7\">%s</span>", text), _g_free0 (markup), _tmp3_);
#line 193 "start-page.vala"
	label = (_tmp4_ = g_object_ref_sink ((GtkLabel*) gtk_label_new (markup)), _g_object_unref0 (label), _tmp4_);
#line 194 "start-page.vala"
	gtk_label_set_use_markup (label, TRUE);
#line 195 "start-page.vala"
	gtk_box_pack_start ((GtkBox*) hbox, (GtkWidget*) label, FALSE, FALSE, (guint) 0);
#line 197 "start-page.vala"
	g_object_set_data_full ((GObject*) button, "uri", g_strdup (uri), g_free);
#line 541 "start-page.c"
	result = button;
	_g_free0 (markup);
	_g_object_unref0 (hbox);
	_g_object_unref0 (label);
#line 198 "start-page.vala"
	return result;
#line 548 "start-page.c"
}


#line 148 "start-page.vala"
static gboolean _start_page_button_enter_notify_event_gtk_widget_enter_notify_event (GtkWidget* _sender, GdkEventCrossing* event, gpointer self) {
#line 554 "start-page.c"
	return start_page_button_enter_notify_event (self, _sender, event);
}


#line 141 "start-page.vala"
static gboolean _start_page_button_leave_notify_event_gtk_widget_leave_notify_event (GtkWidget* _sender, GdkEventCrossing* event, gpointer self) {
#line 561 "start-page.c"
	return start_page_button_leave_notify_event (self, _sender, event);
}


#line 201 "start-page.vala"
static GtkWidget* start_page_create_frame (StartPage* self, const char* title, GList* items) {
#line 568 "start-page.c"
	GtkWidget* result = NULL;
	ValideFrame* frame;
	GtkVBox* vbox;
	GtkLabel* label;
	ValideFrame* _tmp0_;
	GtkVBox* _tmp1_;
#line 201 "start-page.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 201 "start-page.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 579 "start-page.c"
	frame = NULL;
	vbox = NULL;
	label = NULL;
#line 207 "start-page.vala"
	frame = (_tmp0_ = g_object_ref_sink (valide_frame_new (title)), _g_object_unref0 (frame), _tmp0_);
#line 209 "start-page.vala"
	vbox = (_tmp1_ = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 5)), _g_object_unref0 (vbox), _tmp1_);
#line 210 "start-page.vala"
	gtk_container_set_border_width ((GtkContainer*) vbox, (guint) 5);
#line 211 "start-page.vala"
	gtk_container_add ((GtkContainer*) frame, (GtkWidget*) vbox);
#line 213 "start-page.vala"
	if (items != NULL) {
#line 593 "start-page.c"
		{
			GList* item_collection;
			GList* item_it;
#line 215 "start-page.vala"
			item_collection = items;
#line 599 "start-page.c"
			for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
				Item _tmp3_ = {0};
				Item item;
#line 215 "start-page.vala"
				item = (item_copy ((Item*) item_it->data, &_tmp3_), _tmp3_);
#line 605 "start-page.c"
				{
					GtkButton* button;
					GtkButton* _tmp2_;
					button = NULL;
#line 219 "start-page.vala"
					button = (_tmp2_ = start_page_create_button (self, item.uri, item.text, item.icon), _g_object_unref0 (button), _tmp2_);
#line 220 "start-page.vala"
					g_signal_connect_object ((GtkWidget*) button, "enter-notify-event", (GCallback) _start_page_button_enter_notify_event_gtk_widget_enter_notify_event, self, 0);
#line 221 "start-page.vala"
					g_signal_connect_object ((GtkWidget*) button, "leave-notify-event", (GCallback) _start_page_button_leave_notify_event_gtk_widget_leave_notify_event, self, 0);
#line 223 "start-page.vala"
					g_signal_connect (button, "clicked", item.callback, self);
#line 224 "start-page.vala"
					gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) button, FALSE, FALSE, (guint) 0);
#line 620 "start-page.c"
					item_destroy (&item);
					_g_object_unref0 (button);
				}
			}
		}
	} else {
		GtkLabel* _tmp4_;
#line 229 "start-page.vala"
		label = (_tmp4_ = g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("No item"))), _g_object_unref0 (label), _tmp4_);
#line 230 "start-page.vala"
		gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) label, FALSE, FALSE, (guint) 0);
#line 632 "start-page.c"
	}
	result = (GtkWidget*) frame;
	_g_object_unref0 (vbox);
	_g_object_unref0 (label);
#line 232 "start-page.vala"
	return result;
#line 639 "start-page.c"
}


static void _g_list_free_item_free (GList* self) {
	g_list_foreach (self, (GFunc) item_free, NULL);
	g_list_free (self);
}


static gpointer _item_dup0 (gpointer self) {
	return self ? item_dup (self) : NULL;
}


static gpointer _gtk_recent_info_ref0 (gpointer self) {
	return self ? gtk_recent_info_ref (self) : NULL;
}


#line 235 "start-page.vala"
static GtkWidget* start_page_populate_frame (StartPage* self, GList* infos, const char* title, GCallback callback) {
#line 661 "start-page.c"
	GtkWidget* result = NULL;
	Item item = {0};
	GList* items;
	GList* _tmp0_;
#line 235 "start-page.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 235 "start-page.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 670 "start-page.c"
	items = NULL;
#line 241 "start-page.vala"
	items = (_tmp0_ = NULL, __g_list_free_item_free0 (items), _tmp0_);
#line 674 "start-page.c"
	{
		GList* info_collection;
		GList* info_it;
#line 242 "start-page.vala"
		info_collection = infos;
#line 680 "start-page.c"
		for (info_it = info_collection; info_it != NULL; info_it = info_it->next) {
			GtkRecentInfo* info;
#line 242 "start-page.vala"
			info = _gtk_recent_info_ref0 ((GtkRecentInfo*) info_it->data);
#line 685 "start-page.c"
			{
				Item _tmp2_;
				Item _tmp1_ = {0};
				GdkPixbuf* _tmp3_;
				char* _tmp4_;
				char* _tmp5_;
#line 244 "start-page.vala"
				item = (_tmp2_ = (memset (&_tmp1_, 0, sizeof (Item)), _tmp1_), item_destroy (&item), _tmp2_);
#line 245 "start-page.vala"
				item.icon = (_tmp3_ = NULL, _g_object_unref0 (item.icon), _tmp3_);
#line 246 "start-page.vala"
				item.uri = (_tmp4_ = g_strdup (gtk_recent_info_get_uri (info)), _g_free0 (item.uri), _tmp4_);
#line 247 "start-page.vala"
				item.text = (_tmp5_ = g_path_get_basename (item.uri), _g_free0 (item.text), _tmp5_);
#line 248 "start-page.vala"
				item.callback = callback;
#line 250 "start-page.vala"
				items = g_list_append (items, _item_dup0 (&item));
#line 704 "start-page.c"
				_gtk_recent_info_unref0 (info);
			}
		}
	}
	result = start_page_create_frame (self, title, items);
	item_destroy (&item);
	__g_list_free_item_free0 (items);
#line 252 "start-page.vala"
	return result;
#line 714 "start-page.c"
}


#line 255 "start-page.vala"
static void start_page_populate_file_frame (StartPage* self) {
#line 720 "start-page.c"
	GtkWidget* _tmp0_;
#line 255 "start-page.vala"
	g_return_if_fail (self != NULL);
#line 257 "start-page.vala"
	if (self->priv->file_frame != NULL) {
#line 259 "start-page.vala"
		gtk_object_destroy ((GtkObject*) self->priv->file_frame);
#line 728 "start-page.c"
	}
#line 261 "start-page.vala"
	self->priv->file_frame = (_tmp0_ = start_page_populate_frame (self, valide_recent_manager_ui_get_recent_files (valide_window_get_recent_manager (valide_plugin_get_window ((ValidePlugin*) self))), _ ("Recent files"), (GCallback) start_page_open_file), _g_object_unref0 (self->priv->file_frame), _tmp0_);
#line 264 "start-page.vala"
	gtk_table_attach (self->priv->table, self->priv->file_frame, (guint) 1, (guint) 2, (guint) 1, (guint) 2, GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
#line 266 "start-page.vala"
	gtk_widget_show_all (self->priv->file_frame);
#line 736 "start-page.c"
}


#line 269 "start-page.vala"
static void start_page_populate_project_frame (StartPage* self) {
#line 742 "start-page.c"
	GtkWidget* _tmp0_;
#line 269 "start-page.vala"
	g_return_if_fail (self != NULL);
#line 271 "start-page.vala"
	if (self->priv->project_frame != NULL) {
#line 273 "start-page.vala"
		gtk_object_destroy ((GtkObject*) self->priv->project_frame);
#line 750 "start-page.c"
	}
#line 275 "start-page.vala"
	self->priv->project_frame = (_tmp0_ = start_page_populate_frame (self, valide_recent_manager_ui_get_recent_projects (valide_window_get_recent_manager (valide_plugin_get_window ((ValidePlugin*) self))), _ ("Recent projects"), (GCallback) start_page_open_project), _g_object_unref0 (self->priv->project_frame), _tmp0_);
#line 278 "start-page.vala"
	gtk_table_attach (self->priv->table, self->priv->project_frame, (guint) 0, (guint) 1, (guint) 1, (guint) 2, GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
#line 280 "start-page.vala"
	gtk_widget_show_all (self->priv->project_frame);
#line 758 "start-page.c"
}


#line 283 "start-page.vala"
static gboolean start_page_on_expose_event_cb (StartPage* self, GtkWidget* widget, GdkEventExpose* event) {
#line 764 "start-page.c"
	gboolean result = FALSE;
	cairo_t* cr;
	cairo_pattern_t* pattern;
	cairo_t* _tmp0_;
	cairo_pattern_t* _tmp1_;
	gboolean _tmp2_ = FALSE;
	cairo_t* _tmp3_;
#line 283 "start-page.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 283 "start-page.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 776 "start-page.c"
	cr = NULL;
	pattern = NULL;
#line 288 "start-page.vala"
	cr = (_tmp0_ = gdk_cairo_create ((GdkDrawable*) widget->window), _cairo_destroy0 (cr), _tmp0_);
#line 290 "start-page.vala"
	pattern = (_tmp1_ = cairo_pattern_create_linear ((double) 0, (double) 0, (double) 0, (double) widget->allocation.height), _cairo_pattern_destroy0 (pattern), _tmp1_);
#line 292 "start-page.vala"
	if (gdk_screen_get_rgba_colormap (gtk_widget_get_screen (widget)) != NULL) {
#line 293 "start-page.vala"
		_tmp2_ = gtk_widget_is_composited (widget);
#line 787 "start-page.c"
	} else {
#line 292 "start-page.vala"
		_tmp2_ = FALSE;
#line 791 "start-page.c"
	}
#line 292 "start-page.vala"
	if (_tmp2_) {
#line 295 "start-page.vala"
		cairo_set_source_rgba (cr, 1.0, 1.0, 1.0, 0.0);
#line 797 "start-page.c"
	} else {
#line 299 "start-page.vala"
		cairo_set_source_rgb (cr, 1.0, 1.0, 1.0);
#line 801 "start-page.c"
	}
#line 302 "start-page.vala"
	cairo_set_operator (cr, CAIRO_OPERATOR_SOURCE);
#line 303 "start-page.vala"
	cairo_paint (cr);
#line 305 "start-page.vala"
	cairo_pattern_add_color_stop_rgba (pattern, 0.0, 0.2, 0.6, 0.2, 1.0);
#line 306 "start-page.vala"
	cairo_pattern_add_color_stop_rgba (pattern, 0.18, 1.0, 1.0, 1.0, 1.0);
#line 308 "start-page.vala"
	cairo_set_source (cr, pattern);
#line 310 "start-page.vala"
	cairo_set_operator (cr, CAIRO_OPERATOR_OVER);
#line 312 "start-page.vala"
	cairo_paint (cr);
#line 314 "start-page.vala"
	cr = (_tmp3_ = gdk_cairo_create ((GdkDrawable*) widget->window), _cairo_destroy0 (cr), _tmp3_);
#line 316 "start-page.vala"
	gdk_cairo_set_source_pixbuf (cr, self->priv->logo, (double) 20, (double) 20);
#line 318 "start-page.vala"
	cairo_paint (cr);
#line 320 "start-page.vala"
	if (GTK_IS_CONTAINER (widget)) {
#line 825 "start-page.c"
		GtkContainer* container;
		GtkContainer* _tmp5_;
		GtkWidget* _tmp4_;
		container = NULL;
#line 324 "start-page.vala"
		container = (_tmp5_ = _g_object_ref0 ((_tmp4_ = widget, GTK_IS_CONTAINER (_tmp4_) ? ((GtkContainer*) _tmp4_) : NULL)), _g_object_unref0 (container), _tmp5_);
#line 832 "start-page.c"
		{
			GList* child_collection;
			GList* child_it;
#line 325 "start-page.vala"
			child_collection = gtk_container_get_children (container);
#line 838 "start-page.c"
			for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
				GtkWidget* child;
#line 325 "start-page.vala"
				child = _g_object_ref0 ((GtkWidget*) child_it->data);
#line 843 "start-page.c"
				{
#line 327 "start-page.vala"
					gtk_container_propagate_expose (container, child, event);
#line 847 "start-page.c"
					_g_object_unref0 (child);
				}
			}
#line 325 "start-page.vala"
			_g_list_free0 (child_collection);
#line 853 "start-page.c"
		}
		_g_object_unref0 (container);
	}
	result = TRUE;
	_cairo_destroy0 (cr);
	_cairo_pattern_destroy0 (pattern);
#line 330 "start-page.vala"
	return result;
#line 862 "start-page.c"
}


#line 35 "start-page.vala"
StartPage* start_page_construct (GType object_type) {
#line 868 "start-page.c"
	StartPage * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


#line 35 "start-page.vala"
StartPage* start_page_new (void) {
#line 35 "start-page.vala"
	return start_page_construct (TYPE_START_PAGE);
#line 879 "start-page.c"
}


static ValideWindow* start_page_real_get_window (ValidePlugin* base) {
	ValideWindow* result;
	StartPage* self;
	self = (StartPage*) base;
	result = self->priv->_window;
#line 48 "start-page.vala"
	return result;
#line 890 "start-page.c"
}


static void start_page_real_set_window (ValidePlugin* base, ValideWindow* value) {
	StartPage* self;
	ValideWindow* _tmp0_;
	self = (StartPage*) base;
	self->priv->_window = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_window), _tmp0_);
	g_object_notify ((GObject *) self, "window");
}


static const char* start_page_real_get_path (ValidePlugin* base) {
	const char* result;
	StartPage* self;
	self = (StartPage*) base;
	result = self->priv->_path;
#line 53 "start-page.vala"
	return result;
#line 910 "start-page.c"
}


static void start_page_real_set_path (ValidePlugin* base, const char* value) {
	StartPage* self;
	char* _tmp0_;
	self = (StartPage*) base;
	self->priv->_path = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_path), _tmp0_);
	g_object_notify ((GObject *) self, "path");
}


#line 283 "start-page.vala"
static gboolean _start_page_on_expose_event_cb_gtk_widget_expose_event (GtkWidget* _sender, GdkEventExpose* event, gpointer self) {
#line 925 "start-page.c"
	return start_page_on_expose_event_cb (self, _sender, event);
}


#line 269 "start-page.vala"
static void _start_page_populate_project_frame_valide_recent_manager_ui_update_recent_projects (ValideRecentManagerUI* _sender, gpointer self) {
#line 932 "start-page.c"
	start_page_populate_project_frame (self);
}


#line 255 "start-page.vala"
static void _start_page_populate_file_frame_valide_recent_manager_ui_update_recent_files (ValideRecentManagerUI* _sender, gpointer self) {
#line 939 "start-page.c"
	start_page_populate_file_frame (self);
}


#line 1052 "glib-2.0.vapi"
static char* string_replace (const char* self, const char* old, const char* replacement) {
#line 946 "start-page.c"
	char* result = NULL;
	GError * _inner_error_;
#line 1052 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1052 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1052 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 955 "start-page.c"
	_inner_error_ = NULL;
	{
		char* _tmp0_;
		GRegex* _tmp1_;
		GRegex* regex;
		char* _tmp2_;
#line 1054 "glib-2.0.vapi"
		regex = (_tmp1_ = g_regex_new (_tmp0_ = g_regex_escape_string (old, -1), 0, 0, &_inner_error_), _g_free0 (_tmp0_), _tmp1_);
#line 964 "start-page.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch5_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
#line 1055 "glib-2.0.vapi"
		_tmp2_ = g_regex_replace_literal (regex, self, (gssize) (-1), 0, replacement, 0, &_inner_error_);
#line 975 "start-page.c"
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch5_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		result = _tmp2_;
		_g_regex_unref0 (regex);
#line 1055 "glib-2.0.vapi"
		return result;
#line 990 "start-page.c"
	}
	goto __finally5;
	__catch5_g_regex_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 1057 "glib-2.0.vapi"
			g_assert_not_reached ();
#line 1001 "start-page.c"
			_g_error_free0 (e);
		}
	}
	__finally5:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


#line 463 "start-page.vala"
static void _lambda0_ (StartPage* self) {
#line 1016 "start-page.c"
	gboolean _tmp0_ = FALSE;
#line 464 "start-page.vala"
	if (valide_document_manager_get_current (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self))) == NULL) {
#line 464 "start-page.vala"
		_tmp0_ = TRUE;
#line 1022 "start-page.c"
	} else {
#line 465 "start-page.vala"
		_tmp0_ = _vala_strcmp0 (valide_document_get_path (valide_document_manager_get_current (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)))), _ ("New file")) == 0;
#line 1026 "start-page.c"
	}
#line 464 "start-page.vala"
	if (_tmp0_) {
#line 467 "start-page.vala"
		valide_window_present_widget (valide_plugin_get_window ((ValidePlugin*) self), (GtkWidget*) self->priv->scrolled_window);
#line 1032 "start-page.c"
	}
}


#line 463 "start-page.vala"
static void __lambda0__gtk_widget_show (GtkWidget* _sender, gpointer self) {
#line 1039 "start-page.c"
	_lambda0_ (self);
}


static GObject * start_page_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	StartPage * self;
	GError * _inner_error_;
	parent_class = G_OBJECT_CLASS (start_page_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = START_PAGE (obj);
	_inner_error_ = NULL;
	{
		GtkVBox* vbox;
		GtkLabel* label;
		char* copyright;
		GtkWidget* frame;
		GList* items;
		guint logo_offset;
		GtkAlignment* alignment;
		GtkScrolledWindow* _tmp0_;
		GtkEventBox* _tmp1_;
		GtkAlignment* _tmp6_;
		GtkVBox* _tmp7_;
		GtkTable* _tmp8_;
		GList* _tmp9_;
		Item item = {0};
		GdkPixbuf* _tmp10_;
		char* _tmp11_;
		char* _tmp12_;
		Item _tmp14_;
		Item _tmp13_ = {0};
		GdkPixbuf* _tmp15_;
		char* _tmp16_;
		char* _tmp17_;
		Item _tmp19_;
		Item _tmp18_ = {0};
		GdkPixbuf* _tmp20_;
		char* _tmp21_;
		char* _tmp22_;
		Item _tmp24_;
		Item _tmp23_ = {0};
		GdkPixbuf* _tmp25_;
		char* _tmp26_;
		char* _tmp27_;
		GtkWidget* _tmp28_;
		GList* _tmp29_;
		Item _tmp31_;
		Item _tmp30_ = {0};
		GdkPixbuf* _tmp32_;
		char* _tmp33_;
		char* _tmp34_;
		Item _tmp36_;
		Item _tmp35_ = {0};
		GdkPixbuf* _tmp37_;
		char* _tmp38_;
		char* _tmp39_;
		Item _tmp41_;
		Item _tmp40_ = {0};
		GdkPixbuf* _tmp42_;
		char* _tmp43_;
		char* _tmp44_;
		Item _tmp46_;
		Item _tmp45_ = {0};
		GdkPixbuf* _tmp47_;
		char* _tmp48_;
		char* _tmp49_;
		GtkWidget* _tmp50_;
		char* _tmp51_;
		GtkLabel* _tmp52_;
		GtkHSeparator* _tmp53_;
		vbox = NULL;
		label = NULL;
		copyright = NULL;
		frame = NULL;
		items = NULL;
#line 340 "start-page.vala"
		logo_offset = (guint) 20;
#line 1119 "start-page.c"
		alignment = NULL;
#line 343 "start-page.vala"
		self->priv->scrolled_window = (_tmp0_ = g_object_ref_sink ((GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL)), _g_object_unref0 (self->priv->scrolled_window), _tmp0_);
#line 344 "start-page.vala"
		gtk_scrolled_window_set_policy (self->priv->scrolled_window, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
#line 347 "start-page.vala"
		self->priv->event_box = (_tmp1_ = g_object_ref_sink ((GtkEventBox*) gtk_event_box_new ()), _g_object_unref0 (self->priv->event_box), _tmp1_);
#line 348 "start-page.vala"
		gtk_scrolled_window_add_with_viewport (self->priv->scrolled_window, (GtkWidget*) self->priv->event_box);
#line 1129 "start-page.c"
		{
			char* _tmp2_;
			GdkPixbuf* _tmp3_;
			GdkPixbuf* _tmp4_;
			GdkPixbuf* _tmp5_;
#line 352 "start-page.vala"
			_tmp4_ = (_tmp3_ = gdk_pixbuf_new_from_file (_tmp2_ = g_build_filename (valide_plugin_get_path ((ValidePlugin*) self), "logo.png", NULL), &_inner_error_), _g_free0 (_tmp2_), _tmp3_);
#line 1137 "start-page.c"
			if (_inner_error_ != NULL) {
				goto __catch4_g_error;
			}
#line 352 "start-page.vala"
			self->priv->logo = (_tmp5_ = _tmp4_, _g_object_unref0 (self->priv->logo), _tmp5_);
#line 353 "start-page.vala"
			g_signal_connect_object ((GtkWidget*) self->priv->event_box, "expose-event", (GCallback) _start_page_on_expose_event_cb_gtk_widget_expose_event, self, 0);
#line 1145 "start-page.c"
		}
		goto __finally4;
		__catch4_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
#line 357 "start-page.vala"
				g_warning ("start-page.vala:357: %s", e->message);
#line 1156 "start-page.c"
				_g_error_free0 (e);
			}
		}
		__finally4:
		if (_inner_error_ != NULL) {
			_g_object_unref0 (vbox);
			_g_object_unref0 (label);
			_g_free0 (copyright);
			_g_object_unref0 (frame);
			__g_list_free_item_free0 (items);
			_g_object_unref0 (alignment);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
		}
#line 360 "start-page.vala"
		alignment = (_tmp6_ = g_object_ref_sink ((GtkAlignment*) gtk_alignment_new (0.5f, 0.5f, 1.0f, 1.0f)), _g_object_unref0 (alignment), _tmp6_);
#line 361 "start-page.vala"
		gtk_alignment_set_padding (alignment, (logo_offset + gdk_pixbuf_get_height (self->priv->logo)) + logo_offset, (guint) 0, logo_offset, logo_offset);
#line 363 "start-page.vala"
		gtk_container_add ((GtkContainer*) self->priv->event_box, (GtkWidget*) alignment);
#line 365 "start-page.vala"
		vbox = (_tmp7_ = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 5)), _g_object_unref0 (vbox), _tmp7_);
#line 366 "start-page.vala"
		gtk_container_add ((GtkContainer*) alignment, (GtkWidget*) vbox);
#line 368 "start-page.vala"
		self->priv->table = (_tmp8_ = g_object_ref_sink ((GtkTable*) gtk_table_new ((guint) 2, (guint) 2, TRUE)), _g_object_unref0 (self->priv->table), _tmp8_);
#line 369 "start-page.vala"
		gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) self->priv->table, FALSE, FALSE, (guint) 0);
#line 371 "start-page.vala"
		items = (_tmp9_ = NULL, __g_list_free_item_free0 (items), _tmp9_);
#line 1187 "start-page.c"
		memset (&item, 0, sizeof (Item));
#line 374 "start-page.vala"
		item.icon = (_tmp10_ = valide_utils_get_pixbuf_for_stock (GTK_STOCK_NEW, GTK_ICON_SIZE_BUTTON), _g_object_unref0 (item.icon), _tmp10_);
#line 375 "start-page.vala"
		item.uri = (_tmp11_ = NULL, _g_free0 (item.uri), _tmp11_);
#line 376 "start-page.vala"
		item.text = (_tmp12_ = g_strdup (_ ("New project")), _g_free0 (item.text), _tmp12_);
#line 377 "start-page.vala"
		item.callback = (GCallback) start_page_create_project;
#line 378 "start-page.vala"
		items = g_list_append (items, _item_dup0 (&item));
#line 381 "start-page.vala"
		item = (_tmp14_ = (memset (&_tmp13_, 0, sizeof (Item)), _tmp13_), item_destroy (&item), _tmp14_);
#line 382 "start-page.vala"
		item.icon = (_tmp15_ = valide_utils_get_pixbuf_for_stock (GTK_STOCK_OPEN, GTK_ICON_SIZE_BUTTON), _g_object_unref0 (item.icon), _tmp15_);
#line 383 "start-page.vala"
		item.uri = (_tmp16_ = NULL, _g_free0 (item.uri), _tmp16_);
#line 384 "start-page.vala"
		item.text = (_tmp17_ = g_strdup (_ ("Open project")), _g_free0 (item.text), _tmp17_);
#line 385 "start-page.vala"
		item.callback = (GCallback) start_page_open_project;
#line 386 "start-page.vala"
		items = g_list_append (items, _item_dup0 (&item));
#line 389 "start-page.vala"
		item = (_tmp19_ = (memset (&_tmp18_, 0, sizeof (Item)), _tmp18_), item_destroy (&item), _tmp19_);
#line 390 "start-page.vala"
		item.icon = (_tmp20_ = valide_utils_get_pixbuf_for_stock (GTK_STOCK_NEW, GTK_ICON_SIZE_BUTTON), _g_object_unref0 (item.icon), _tmp20_);
#line 391 "start-page.vala"
		item.uri = (_tmp21_ = NULL, _g_free0 (item.uri), _tmp21_);
#line 392 "start-page.vala"
		item.text = (_tmp22_ = g_strdup (_ ("New file")), _g_free0 (item.text), _tmp22_);
#line 393 "start-page.vala"
		item.callback = (GCallback) start_page_create_file;
#line 394 "start-page.vala"
		items = g_list_append (items, _item_dup0 (&item));
#line 397 "start-page.vala"
		item = (_tmp24_ = (memset (&_tmp23_, 0, sizeof (Item)), _tmp23_), item_destroy (&item), _tmp24_);
#line 398 "start-page.vala"
		item.icon = (_tmp25_ = valide_utils_get_pixbuf_for_stock (GTK_STOCK_OPEN, GTK_ICON_SIZE_BUTTON), _g_object_unref0 (item.icon), _tmp25_);
#line 399 "start-page.vala"
		item.uri = (_tmp26_ = NULL, _g_free0 (item.uri), _tmp26_);
#line 400 "start-page.vala"
		item.text = (_tmp27_ = g_strdup (_ ("Open file")), _g_free0 (item.text), _tmp27_);
#line 401 "start-page.vala"
		item.callback = (GCallback) start_page_open_file;
#line 402 "start-page.vala"
		items = g_list_append (items, _item_dup0 (&item));
#line 404 "start-page.vala"
		frame = (_tmp28_ = start_page_create_frame (self, _ ("Common actions"), items), _g_object_unref0 (frame), _tmp28_);
#line 405 "start-page.vala"
		gtk_table_attach (self->priv->table, frame, (guint) 0, (guint) 1, (guint) 0, (guint) 1, GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
#line 408 "start-page.vala"
		items = (_tmp29_ = NULL, __g_list_free_item_free0 (items), _tmp29_);
#line 410 "start-page.vala"
		item = (_tmp31_ = (memset (&_tmp30_, 0, sizeof (Item)), _tmp30_), item_destroy (&item), _tmp31_);
#line 411 "start-page.vala"
		item.icon = (_tmp32_ = valide_utils_get_pixbuf_for_stock (GTK_STOCK_HOME, GTK_ICON_SIZE_BUTTON), _g_object_unref0 (item.icon), _tmp32_);
#line 412 "start-page.vala"
		item.uri = (_tmp33_ = g_strdup (WEBSITE), _g_free0 (item.uri), _tmp33_);
#line 413 "start-page.vala"
		item.text = (_tmp34_ = g_strdup (_ ("Website")), _g_free0 (item.text), _tmp34_);
#line 414 "start-page.vala"
		item.callback = (GCallback) start_page_open_link;
#line 415 "start-page.vala"
		items = g_list_append (items, _item_dup0 (&item));
#line 418 "start-page.vala"
		item = (_tmp36_ = (memset (&_tmp35_, 0, sizeof (Item)), _tmp35_), item_destroy (&item), _tmp36_);
#line 419 "start-page.vala"
		item.icon = (_tmp37_ = valide_utils_get_pixbuf_for_stock (GTK_STOCK_CANCEL, GTK_ICON_SIZE_BUTTON), _g_object_unref0 (item.icon), _tmp37_);
#line 420 "start-page.vala"
		item.uri = (_tmp38_ = g_strdup ("http://code.google.com/p/valide/issues/entry"), _g_free0 (item.uri), _tmp38_);
#line 421 "start-page.vala"
		item.text = (_tmp39_ = g_strdup (_ ("Report a bug")), _g_free0 (item.text), _tmp39_);
#line 422 "start-page.vala"
		item.callback = (GCallback) start_page_open_link;
#line 423 "start-page.vala"
		items = g_list_append (items, _item_dup0 (&item));
#line 426 "start-page.vala"
		item = (_tmp41_ = (memset (&_tmp40_, 0, sizeof (Item)), _tmp40_), item_destroy (&item), _tmp41_);
#line 427 "start-page.vala"
		item.icon = (_tmp42_ = valide_utils_get_pixbuf_for_stock (GTK_STOCK_HELP, GTK_ICON_SIZE_BUTTON), _g_object_unref0 (item.icon), _tmp42_);
#line 428 "start-page.vala"
		item.uri = (_tmp43_ = g_strdup ("http://groups.google.com/group/valide-users"), _g_free0 (item.uri), _tmp43_);
#line 429 "start-page.vala"
		item.text = (_tmp44_ = g_strdup (_ ("Visit the user group")), _g_free0 (item.text), _tmp44_);
#line 430 "start-page.vala"
		item.callback = (GCallback) start_page_open_link;
#line 431 "start-page.vala"
		items = g_list_append (items, _item_dup0 (&item));
#line 434 "start-page.vala"
		item = (_tmp46_ = (memset (&_tmp45_, 0, sizeof (Item)), _tmp45_), item_destroy (&item), _tmp46_);
#line 435 "start-page.vala"
		item.icon = (_tmp47_ = valide_utils_get_pixbuf_for_stock (GTK_STOCK_INFO, GTK_ICON_SIZE_BUTTON), _g_object_unref0 (item.icon), _tmp47_);
#line 436 "start-page.vala"
		item.uri = (_tmp48_ = g_strdup ("http://www.valadoc.org/"), _g_free0 (item.uri), _tmp48_);
#line 437 "start-page.vala"
		item.text = (_tmp49_ = g_strdup (_ ("Online API documentation")), _g_free0 (item.text), _tmp49_);
#line 438 "start-page.vala"
		item.callback = (GCallback) start_page_open_link;
#line 439 "start-page.vala"
		items = g_list_append (items, _item_dup0 (&item));
#line 441 "start-page.vala"
		frame = (_tmp50_ = start_page_create_frame (self, _ ("Links"), items), _g_object_unref0 (frame), _tmp50_);
#line 442 "start-page.vala"
		gtk_table_attach (self->priv->table, frame, (guint) 1, (guint) 2, (guint) 0, (guint) 1, GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
#line 445 "start-page.vala"
		start_page_populate_project_frame (self);
#line 446 "start-page.vala"
		start_page_populate_file_frame (self);
#line 448 "start-page.vala"
		g_signal_connect_object (valide_window_get_recent_manager (valide_plugin_get_window ((ValidePlugin*) self)), "update-recent-projects", (GCallback) _start_page_populate_project_frame_valide_recent_manager_ui_update_recent_projects, self, 0);
#line 449 "start-page.vala"
		g_signal_connect_object (valide_window_get_recent_manager (valide_plugin_get_window ((ValidePlugin*) self)), "update-recent-files", (GCallback) _start_page_populate_file_frame_valide_recent_manager_ui_update_recent_files, self, 0);
#line 451 "start-page.vala"
		copyright = (_tmp51_ = string_replace (COPYRIGHT, "The Val(a)IDE team", "<a href=\"http://code.google.com/p/valide/people/list\">The Val(a)IDE " \
"team</a>"), _g_free0 (copyright), _tmp51_);
#line 453 "start-page.vala"
		label = (_tmp52_ = g_object_ref_sink ((GtkLabel*) gtk_label_new (copyright)), _g_object_unref0 (label), _tmp52_);
#line 454 "start-page.vala"
		gtk_label_set_use_markup (label, TRUE);
#line 455 "start-page.vala"
		gtk_box_pack_end ((GtkBox*) vbox, (GtkWidget*) label, FALSE, TRUE, (guint) 5);
#line 457 "start-page.vala"
		gtk_box_pack_end ((GtkBox*) vbox, (GtkWidget*) (_tmp53_ = g_object_ref_sink ((GtkHSeparator*) gtk_hseparator_new ())), FALSE, TRUE, (guint) 0);
#line 1311 "start-page.c"
		_g_object_unref0 (_tmp53_);
#line 459 "start-page.vala"
		valide_window_add_widget (valide_plugin_get_window ((ValidePlugin*) self), (GtkWidget*) self->priv->scrolled_window, "start-page-plugin", _ ("Start page"), VALIDE_WINDOW_PLACEMENT_CENTER, GTK_STOCK_INFO);
#line 463 "start-page.vala"
		g_signal_connect_object ((GtkWidget*) valide_plugin_get_window ((ValidePlugin*) self), "show", (GCallback) __lambda0__gtk_widget_show, self, 0);
#line 1317 "start-page.c"
		_g_object_unref0 (vbox);
		_g_object_unref0 (label);
		_g_free0 (copyright);
		_g_object_unref0 (frame);
		__g_list_free_item_free0 (items);
		_g_object_unref0 (alignment);
		item_destroy (&item);
	}
	return obj;
}


static void start_page_class_init (StartPageClass * klass) {
	start_page_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (StartPagePrivate));
	G_OBJECT_CLASS (klass)->get_property = start_page_get_property;
	G_OBJECT_CLASS (klass)->set_property = start_page_set_property;
	G_OBJECT_CLASS (klass)->constructor = start_page_constructor;
	G_OBJECT_CLASS (klass)->finalize = start_page_finalize;
	g_object_class_override_property (G_OBJECT_CLASS (klass), START_PAGE_WINDOW, "window");
	g_object_class_override_property (G_OBJECT_CLASS (klass), START_PAGE_PATH, "path");
}


static void start_page_valide_plugin_interface_init (ValidePluginIface * iface) {
	start_page_valide_plugin_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_window = start_page_real_get_window;
	iface->set_window = start_page_real_set_window;
	iface->get_path = start_page_real_get_path;
	iface->set_path = start_page_real_set_path;
}


static void start_page_instance_init (StartPage * self) {
	self->priv = START_PAGE_GET_PRIVATE (self);
	self->priv->status_context = (guint) (-1);
}


static void start_page_finalize (GObject* obj) {
	StartPage * self;
	self = START_PAGE (obj);
	{
		guint _tmp54_;
		guint _tmp55_;
#line 474 "start-page.vala"
		g_signal_parse_name ("update-recent-projects", VALIDE_TYPE_RECENT_MANAGER_UI, &_tmp54_, NULL, FALSE);
#line 474 "start-page.vala"
		g_signal_handlers_disconnect_matched (valide_window_get_recent_manager (valide_plugin_get_window ((ValidePlugin*) self)), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp54_, 0, NULL, (GCallback) _start_page_populate_project_frame_valide_recent_manager_ui_update_recent_projects, self);
#line 475 "start-page.vala"
		g_signal_parse_name ("update-recent-files", VALIDE_TYPE_RECENT_MANAGER_UI, &_tmp55_, NULL, FALSE);
#line 475 "start-page.vala"
		g_signal_handlers_disconnect_matched (valide_window_get_recent_manager (valide_plugin_get_window ((ValidePlugin*) self)), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp55_, 0, NULL, (GCallback) _start_page_populate_file_frame_valide_recent_manager_ui_update_recent_files, self);
#line 476 "start-page.vala"
		valide_window_remove_widget (valide_plugin_get_window ((ValidePlugin*) self), (GtkWidget*) self->priv->scrolled_window);
#line 1373 "start-page.c"
	}
	_g_object_unref0 (self->priv->table);
	_g_object_unref0 (self->priv->logo);
	_g_object_unref0 (self->priv->event_box);
	_g_object_unref0 (self->priv->file_frame);
	_g_object_unref0 (self->priv->project_frame);
	_g_object_unref0 (self->priv->scrolled_window);
	_g_object_unref0 (self->priv->_window);
	_g_free0 (self->priv->_path);
	G_OBJECT_CLASS (start_page_parent_class)->finalize (obj);
}


GType start_page_get_type (void) {
	static volatile gsize start_page_type_id__volatile = 0;
	if (g_once_init_enter (&start_page_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (StartPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) start_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StartPage), 0, (GInstanceInitFunc) start_page_instance_init, NULL };
		static const GInterfaceInfo valide_plugin_info = { (GInterfaceInitFunc) start_page_valide_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType start_page_type_id;
		start_page_type_id = g_type_register_static (G_TYPE_OBJECT, "StartPage", &g_define_type_info, 0);
		g_type_add_interface_static (start_page_type_id, VALIDE_TYPE_PLUGIN, &valide_plugin_info);
		g_once_init_leave (&start_page_type_id__volatile, start_page_type_id);
	}
	return start_page_type_id__volatile;
}


static void start_page_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	StartPage * self;
	self = START_PAGE (object);
	switch (property_id) {
		case START_PAGE_WINDOW:
		g_value_set_object (value, valide_plugin_get_window ((ValidePlugin*) self));
		break;
		case START_PAGE_PATH:
		g_value_set_string (value, valide_plugin_get_path ((ValidePlugin*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void start_page_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	StartPage * self;
	self = START_PAGE (object);
	switch (property_id) {
		case START_PAGE_WINDOW:
		valide_plugin_set_window ((ValidePlugin*) self, g_value_get_object (value));
		break;
		case START_PAGE_PATH:
		valide_plugin_set_path ((ValidePlugin*) self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


#line 481 "start-page.vala"
GType register_plugin (void* user_data, GError** error) {
#line 1437 "start-page.c"
	GType result = 0UL;
	result = TYPE_START_PAGE;
#line 483 "start-page.vala"
	return result;
#line 1442 "start-page.c"
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




