/* symbol.c generated by valac, the Vala compiler
 * generated from symbol.vala, do not modify */

/* symbol-browser.vala
 *
 * Copyright (C) 2008-2010 Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */
/*
 * This code is re-writing in the vala language of GeditSymbolBrowserPlugin
 *
 * Copyright (C) 2007 - Micah Carrick
 */

#include <glib.h>
#include <glib-object.h>
#include <valide-0.0.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <config.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <glib/gi18n-lib.h>
#include <glib/gstdio.h>
#include <float.h>
#include <math.h>


#define TYPE_SYMBOL (symbol_get_type ())
#define SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SYMBOL, Symbol))
#define SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SYMBOL, SymbolClass))
#define IS_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SYMBOL))
#define IS_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SYMBOL))
#define SYMBOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SYMBOL, SymbolClass))

typedef struct _Symbol Symbol;
typedef struct _SymbolClass SymbolClass;
typedef struct _SymbolPrivate SymbolPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_SYMBOL_BROWSER (symbol_browser_get_type ())
#define SYMBOL_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SYMBOL_BROWSER, SymbolBrowser))
#define SYMBOL_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SYMBOL_BROWSER, SymbolBrowserClass))
#define IS_SYMBOL_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SYMBOL_BROWSER))
#define IS_SYMBOL_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SYMBOL_BROWSER))
#define SYMBOL_BROWSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SYMBOL_BROWSER, SymbolBrowserClass))

typedef struct _SymbolBrowser SymbolBrowser;
typedef struct _SymbolBrowserClass SymbolBrowserClass;
typedef struct _SymbolBrowserPrivate SymbolBrowserPrivate;

#define SYMBOL_BROWSER_TYPE_COL (symbol_browser_col_get_type ())
#define __g_slist_free_g_free0(var) ((var == NULL) ? NULL : (var = (_g_slist_free_g_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gtk_tree_path_free0(var) ((var == NULL) ? NULL : (var = (gtk_tree_path_free (var), NULL)))

struct _Symbol {
	GObject parent_instance;
	SymbolPrivate * priv;
	Symbol* root;
	ValideDocument* document;
};

struct _SymbolClass {
	GObjectClass parent_class;
};

struct _SymbolPrivate {
	char* _name;
	char* _full_name;
	char* _signature;
	char** _inherits;
	gint _inherits_length1;
	gint __inherits_size_;
	char* _typeref;
	char* _access;
	char* _implementation;
	char* _kind;
	char* _file;
	char* _language;
	char* _line;
};

typedef enum  {
	SYMBOL_ERROR_KIND
} SymbolError;
#define SYMBOL_ERROR symbol_error_quark ()
struct _SymbolBrowser {
	GObject parent_instance;
	SymbolBrowserPrivate * priv;
};

struct _SymbolBrowserClass {
	GObjectClass parent_class;
};

struct _SymbolBrowserPrivate {
	gint atom;
	GtkVBox* box;
	GtkLabel* label;
	guint status_context;
	GtkTreeStore* model;
	GtkTreeView* tree_view;
	GSList* expanded_rows;
	GtkTreeViewColumn* language_column;
	GtkTreeViewColumn* source_file_column;
	GtkTreeViewColumn* line_number_column;
	GHashTable* root_nodes;
	char* _path;
	ValideWindow* _window;
};

typedef enum  {
	SYMBOL_BROWSER_COL_ICON,
	SYMBOL_BROWSER_COL_NAME,
	SYMBOL_BROWSER_COL_FILE,
	SYMBOL_BROWSER_COL_LINE,
	SYMBOL_BROWSER_COL_LANGUAGE,
	SYMBOL_BROWSER_COL_NB
} SymbolBrowserCol;


static gpointer symbol_parent_class = NULL;
static gpointer symbol_browser_parent_class = NULL;
static ValidePluginIface* symbol_browser_valide_plugin_parent_iface = NULL;

GType symbol_get_type (void);
#define SYMBOL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SYMBOL, SymbolPrivate))
enum  {
	SYMBOL_DUMMY_PROPERTY,
	SYMBOL_NAME,
	SYMBOL_FULL_NAME,
	SYMBOL_SIGNATURE,
	SYMBOL_INHERITS,
	SYMBOL_TYPEREF,
	SYMBOL_ACCESS,
	SYMBOL_IMPLEMENTATION,
	SYMBOL_KIND,
	SYMBOL_FILE,
	SYMBOL_LANGUAGE,
	SYMBOL_LINE
};
Symbol* symbol_new (void);
Symbol* symbol_construct (GType object_type);
const char* symbol_get_name (Symbol* self);
void symbol_set_name (Symbol* self, const char* value);
const char* symbol_get_full_name (Symbol* self);
void symbol_set_full_name (Symbol* self, const char* value);
const char* symbol_get_signature (Symbol* self);
void symbol_set_signature (Symbol* self, const char* value);
char** symbol_get_inherits (Symbol* self, int* result_length1);
static char** _vala_array_dup1 (char** self, int length);
void symbol_set_inherits (Symbol* self, char** value, int value_length1);
const char* symbol_get_typeref (Symbol* self);
void symbol_set_typeref (Symbol* self, const char* value);
const char* symbol_get_access (Symbol* self);
void symbol_set_access (Symbol* self, const char* value);
const char* symbol_get_implementation (Symbol* self);
void symbol_set_implementation (Symbol* self, const char* value);
const char* symbol_get_kind (Symbol* self);
void symbol_set_kind (Symbol* self, const char* value);
const char* symbol_get_file (Symbol* self);
void symbol_set_file (Symbol* self, const char* value);
const char* symbol_get_language (Symbol* self);
void symbol_set_language (Symbol* self, const char* value);
const char* symbol_get_line (Symbol* self);
void symbol_set_line (Symbol* self, const char* value);
static void symbol_finalize (GObject* obj);
static void symbol_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void symbol_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GQuark symbol_error_quark (void);
GType symbol_browser_get_type (void);
#define SYMBOL_BROWSER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SYMBOL_BROWSER, SymbolBrowserPrivate))
enum  {
	SYMBOL_BROWSER_DUMMY_PROPERTY,
	SYMBOL_BROWSER_PATH,
	SYMBOL_BROWSER_WINDOW
};
static GType symbol_browser_col_get_type (void) G_GNUC_UNUSED;
static void _g_slist_free_g_free (GSList* self);
static void symbol_browser_save_expanded_rows (SymbolBrowser* self);
static gboolean symbol_browser_is_expanded_row (SymbolBrowser* self, const char* name);
static void symbol_browser_add_expanded_row (SymbolBrowser* self, const char* name);
static void symbol_browser_remove_expanded_row (SymbolBrowser* self, const char* name);
static char* symbol_browser_exec_ctags (SymbolBrowser* self, const char* filename, GError** error);
static Symbol* symbol_browser_parse_line (SymbolBrowser* self, const char* line);
static void symbol_browser_clear_data (SymbolBrowser* self);
static gboolean symbol_browser_get_hierarchic_view (SymbolBrowser* self);
static GtkTreeIter* _gtk_tree_iter_dup (GtkTreeIter* self);
static gboolean symbol_browser_add_symbol (SymbolBrowser* self, Symbol* symbol);
static gboolean symbol_browser_populate_symbols_asc (SymbolBrowser* self);
static gboolean _symbol_browser_populate_symbols_asc_gsource_func (gpointer self);
static void symbol_browser_populate_symbols (SymbolBrowser* self);
static void symbol_browser_restore_expanded_rows (SymbolBrowser* self);
static void symbol_browser_on_row_activated (SymbolBrowser* self, GtkTreeView* sender, GtkTreePath* path, GtkTreeViewColumn* column);
static void symbol_browser_on_cursor_changed (SymbolBrowser* self, GtkTreeView* sender);
static void symbol_browser_on_row_expanded (SymbolBrowser* self, GtkTreeView* sender, GtkTreeIter* iter, GtkTreePath* path);
static void symbol_browser_on_row_collapsed (SymbolBrowser* self, GtkTreeView* sender, GtkTreeIter* iter, GtkTreePath* path);
SymbolBrowser* symbol_browser_new (const char* path);
SymbolBrowser* symbol_browser_construct (GType object_type, const char* path);
static gboolean symbol_browser_get_show_language_column (SymbolBrowser* self);
static void symbol_browser_set_show_language_column (SymbolBrowser* self, gboolean value);
static void _lambda0_ (GtkToggleButton* s, SymbolBrowser* self);
static void __lambda0__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static gboolean symbol_browser_get_show_source_file_column (SymbolBrowser* self);
static void symbol_browser_set_show_source_file_column (SymbolBrowser* self, gboolean value);
static void _lambda1_ (GtkToggleButton* s, SymbolBrowser* self);
static void __lambda1__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static gboolean symbol_browser_get_show_line_number_column (SymbolBrowser* self);
static void symbol_browser_set_show_line_number_column (SymbolBrowser* self, gboolean value);
static void _lambda2_ (GtkToggleButton* s, SymbolBrowser* self);
static void __lambda2__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static void symbol_browser_set_hierarchic_view (SymbolBrowser* self, gboolean value);
static void _lambda3_ (GtkToggleButton* s, SymbolBrowser* self);
static void __lambda3__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
GtkWidget* symbol_browser_create_configure_dialog (SymbolBrowser* self);
static void _symbol_browser_on_row_activated_gtk_tree_view_row_activated (GtkTreeView* _sender, GtkTreePath* path, GtkTreeViewColumn* column, gpointer self);
static void _symbol_browser_on_cursor_changed_gtk_tree_view_cursor_changed (GtkTreeView* _sender, gpointer self);
static void _symbol_browser_on_row_expanded_gtk_tree_view_row_expanded (GtkTreeView* _sender, GtkTreeIter* iter, GtkTreePath* path, gpointer self);
static void _symbol_browser_on_row_collapsed_gtk_tree_view_row_collapsed (GtkTreeView* _sender, GtkTreeIter* iter, GtkTreePath* path, gpointer self);
static void _symbol_browser_populate_symbols_valide_document_manager_tab_removed (ValideDocumentManager* _sender, ValideDocument* document, gpointer self);
static void _symbol_browser_populate_symbols_valide_document_manager_tab_changed (ValideDocumentManager* _sender, ValideDocument* document, gpointer self);
static void _symbol_browser_populate_symbols_valide_document_manager_tab_saved (ValideDocumentManager* _sender, ValideDocument* document, gpointer self);
static GObject * symbol_browser_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void symbol_browser_finalize (GObject* obj);
static void symbol_browser_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void symbol_browser_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType register_plugin (void* user_data, GError** error);
GtkWidget* create_configure_dialog (SymbolBrowser* _self_);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);



#line 31 "symbol.vala"
Symbol* symbol_construct (GType object_type) {
#line 258 "symbol.c"
	Symbol * self;
#line 31 "symbol.vala"
	self = (Symbol*) g_object_new (object_type, NULL);
#line 262 "symbol.c"
	return self;
}


#line 31 "symbol.vala"
Symbol* symbol_new (void) {
#line 31 "symbol.vala"
	return symbol_construct (TYPE_SYMBOL);
#line 271 "symbol.c"
}


const char* symbol_get_name (Symbol* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_name;
#line 33 "symbol.vala"
	return result;
#line 281 "symbol.c"
}


void symbol_set_name (Symbol* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_name = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_name), _tmp0_);
	g_object_notify ((GObject *) self, "name");
}


const char* symbol_get_full_name (Symbol* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_full_name;
#line 34 "symbol.vala"
	return result;
#line 299 "symbol.c"
}


void symbol_set_full_name (Symbol* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_full_name = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_full_name), _tmp0_);
	g_object_notify ((GObject *) self, "full-name");
}


const char* symbol_get_signature (Symbol* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_signature;
#line 35 "symbol.vala"
	return result;
#line 317 "symbol.c"
}


void symbol_set_signature (Symbol* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_signature = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_signature), _tmp0_);
	g_object_notify ((GObject *) self, "signature");
}


char** symbol_get_inherits (Symbol* self, int* result_length1) {
	char** result;
	char** _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	result = (_tmp0_ = self->priv->_inherits, *result_length1 = self->priv->_inherits_length1, _tmp0_);
#line 36 "symbol.vala"
	return result;
#line 336 "symbol.c"
}


static char** _vala_array_dup1 (char** self, int length) {
	char** result;
	int i;
	result = g_new0 (char*, length + 1);
	for (i = 0; i < length; i++) {
		result[i] = g_strdup (self[i]);
	}
	return result;
}


void symbol_set_inherits (Symbol* self, char** value, int value_length1) {
	char** _tmp2_;
	char** _tmp1_;
	g_return_if_fail (self != NULL);
	self->priv->_inherits = (_tmp2_ = (_tmp1_ = value, (_tmp1_ == NULL) ? ((gpointer) _tmp1_) : _vala_array_dup1 (_tmp1_, value_length1)), self->priv->_inherits = (_vala_array_free (self->priv->_inherits, self->priv->_inherits_length1, (GDestroyNotify) g_free), NULL), self->priv->_inherits_length1 = value_length1, self->priv->__inherits_size_ = self->priv->_inherits_length1, _tmp2_);
	g_object_notify ((GObject *) self, "inherits");
}


const char* symbol_get_typeref (Symbol* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_typeref;
#line 37 "symbol.vala"
	return result;
#line 366 "symbol.c"
}


void symbol_set_typeref (Symbol* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_typeref = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_typeref), _tmp0_);
	g_object_notify ((GObject *) self, "typeref");
}


const char* symbol_get_access (Symbol* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_access;
#line 38 "symbol.vala"
	return result;
#line 384 "symbol.c"
}


void symbol_set_access (Symbol* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_access = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_access), _tmp0_);
	g_object_notify ((GObject *) self, "access");
}


const char* symbol_get_implementation (Symbol* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_implementation;
#line 39 "symbol.vala"
	return result;
#line 402 "symbol.c"
}


void symbol_set_implementation (Symbol* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_implementation = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_implementation), _tmp0_);
	g_object_notify ((GObject *) self, "implementation");
}


const char* symbol_get_kind (Symbol* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_kind;
#line 40 "symbol.vala"
	return result;
#line 420 "symbol.c"
}


void symbol_set_kind (Symbol* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_kind = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_kind), _tmp0_);
	g_object_notify ((GObject *) self, "kind");
}


const char* symbol_get_file (Symbol* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_file;
#line 41 "symbol.vala"
	return result;
#line 438 "symbol.c"
}


void symbol_set_file (Symbol* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_file = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_file), _tmp0_);
	g_object_notify ((GObject *) self, "file");
}


const char* symbol_get_language (Symbol* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_language;
#line 42 "symbol.vala"
	return result;
#line 456 "symbol.c"
}


void symbol_set_language (Symbol* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_language = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_language), _tmp0_);
	g_object_notify ((GObject *) self, "language");
}


const char* symbol_get_line (Symbol* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_line;
#line 43 "symbol.vala"
	return result;
#line 474 "symbol.c"
}


void symbol_set_line (Symbol* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_line = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_line), _tmp0_);
	g_object_notify ((GObject *) self, "line");
}


static void symbol_class_init (SymbolClass * klass) {
	symbol_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SymbolPrivate));
	G_OBJECT_CLASS (klass)->get_property = symbol_get_property;
	G_OBJECT_CLASS (klass)->set_property = symbol_set_property;
	G_OBJECT_CLASS (klass)->finalize = symbol_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYMBOL_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYMBOL_FULL_NAME, g_param_spec_string ("full-name", "full-name", "full-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYMBOL_SIGNATURE, g_param_spec_string ("signature", "signature", "signature", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYMBOL_INHERITS, g_param_spec_boxed ("inherits", "inherits", "inherits", G_TYPE_STRV, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYMBOL_TYPEREF, g_param_spec_string ("typeref", "typeref", "typeref", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYMBOL_ACCESS, g_param_spec_string ("access", "access", "access", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYMBOL_IMPLEMENTATION, g_param_spec_string ("implementation", "implementation", "implementation", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYMBOL_KIND, g_param_spec_string ("kind", "kind", "kind", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYMBOL_FILE, g_param_spec_string ("file", "file", "file", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYMBOL_LANGUAGE, g_param_spec_string ("language", "language", "language", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYMBOL_LINE, g_param_spec_string ("line", "line", "line", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void symbol_instance_init (Symbol * self) {
	self->priv = SYMBOL_GET_PRIVATE (self);
}


static void symbol_finalize (GObject* obj) {
	Symbol * self;
	self = SYMBOL (obj);
	_g_free0 (self->priv->_name);
	_g_free0 (self->priv->_full_name);
	_g_free0 (self->priv->_signature);
	self->priv->_inherits = (_vala_array_free (self->priv->_inherits, self->priv->_inherits_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (self->priv->_typeref);
	_g_free0 (self->priv->_access);
	_g_free0 (self->priv->_implementation);
	_g_free0 (self->priv->_kind);
	_g_free0 (self->priv->_file);
	_g_free0 (self->priv->_language);
	_g_free0 (self->priv->_line);
	_g_object_unref0 (self->root);
	G_OBJECT_CLASS (symbol_parent_class)->finalize (obj);
}


GType symbol_get_type (void) {
	static volatile gsize symbol_type_id__volatile = 0;
	if (g_once_init_enter (&symbol_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SymbolClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) symbol_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Symbol), 0, (GInstanceInitFunc) symbol_instance_init, NULL };
		GType symbol_type_id;
		symbol_type_id = g_type_register_static (G_TYPE_OBJECT, "Symbol", &g_define_type_info, 0);
		g_once_init_leave (&symbol_type_id__volatile, symbol_type_id);
	}
	return symbol_type_id__volatile;
}


static void symbol_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Symbol * self;
	int length;
	self = SYMBOL (object);
	switch (property_id) {
		case SYMBOL_NAME:
		g_value_set_string (value, symbol_get_name (self));
		break;
		case SYMBOL_FULL_NAME:
		g_value_set_string (value, symbol_get_full_name (self));
		break;
		case SYMBOL_SIGNATURE:
		g_value_set_string (value, symbol_get_signature (self));
		break;
		case SYMBOL_INHERITS:
		g_value_set_boxed (value, symbol_get_inherits (self, &length));
		break;
		case SYMBOL_TYPEREF:
		g_value_set_string (value, symbol_get_typeref (self));
		break;
		case SYMBOL_ACCESS:
		g_value_set_string (value, symbol_get_access (self));
		break;
		case SYMBOL_IMPLEMENTATION:
		g_value_set_string (value, symbol_get_implementation (self));
		break;
		case SYMBOL_KIND:
		g_value_set_string (value, symbol_get_kind (self));
		break;
		case SYMBOL_FILE:
		g_value_set_string (value, symbol_get_file (self));
		break;
		case SYMBOL_LANGUAGE:
		g_value_set_string (value, symbol_get_language (self));
		break;
		case SYMBOL_LINE:
		g_value_set_string (value, symbol_get_line (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void symbol_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Symbol * self;
	gpointer boxed;
	self = SYMBOL (object);
	switch (property_id) {
		case SYMBOL_NAME:
		symbol_set_name (self, g_value_get_string (value));
		break;
		case SYMBOL_FULL_NAME:
		symbol_set_full_name (self, g_value_get_string (value));
		break;
		case SYMBOL_SIGNATURE:
		symbol_set_signature (self, g_value_get_string (value));
		break;
		case SYMBOL_INHERITS:
		boxed = g_value_get_boxed (value);
		symbol_set_inherits (self, boxed, g_strv_length (boxed));
		break;
		case SYMBOL_TYPEREF:
		symbol_set_typeref (self, g_value_get_string (value));
		break;
		case SYMBOL_ACCESS:
		symbol_set_access (self, g_value_get_string (value));
		break;
		case SYMBOL_IMPLEMENTATION:
		symbol_set_implementation (self, g_value_get_string (value));
		break;
		case SYMBOL_KIND:
		symbol_set_kind (self, g_value_get_string (value));
		break;
		case SYMBOL_FILE:
		symbol_set_file (self, g_value_get_string (value));
		break;
		case SYMBOL_LANGUAGE:
		symbol_set_language (self, g_value_get_string (value));
		break;
		case SYMBOL_LINE:
		symbol_set_line (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


GQuark symbol_error_quark (void) {
	return g_quark_from_static_string ("symbol_error-quark");
}


static GType symbol_browser_col_get_type (void) {
	static volatile gsize symbol_browser_col_type_id__volatile = 0;
	if (g_once_init_enter (&symbol_browser_col_type_id__volatile)) {
		static const GEnumValue values[] = {{SYMBOL_BROWSER_COL_ICON, "SYMBOL_BROWSER_COL_ICON", "icon"}, {SYMBOL_BROWSER_COL_NAME, "SYMBOL_BROWSER_COL_NAME", "name"}, {SYMBOL_BROWSER_COL_FILE, "SYMBOL_BROWSER_COL_FILE", "file"}, {SYMBOL_BROWSER_COL_LINE, "SYMBOL_BROWSER_COL_LINE", "line"}, {SYMBOL_BROWSER_COL_LANGUAGE, "SYMBOL_BROWSER_COL_LANGUAGE", "language"}, {SYMBOL_BROWSER_COL_NB, "SYMBOL_BROWSER_COL_NB", "nb"}, {0, NULL, NULL}};
		GType symbol_browser_col_type_id;
		symbol_browser_col_type_id = g_enum_register_static ("SymbolBrowserCol", values);
		g_once_init_leave (&symbol_browser_col_type_id__volatile, symbol_browser_col_type_id);
	}
	return symbol_browser_col_type_id__volatile;
}


static void _g_slist_free_g_free (GSList* self) {
	g_slist_foreach (self, (GFunc) g_free, NULL);
	g_slist_free (self);
}


#line 147 "symbol.vala"
static void symbol_browser_save_expanded_rows (SymbolBrowser* self) {
#line 147 "symbol.vala"
	g_return_if_fail (self != NULL);
#line 660 "symbol.c"
}


#line 172 "symbol.vala"
static gboolean symbol_browser_is_expanded_row (SymbolBrowser* self, const char* name) {
#line 666 "symbol.c"
	gboolean result = FALSE;
	gboolean ret;
#line 172 "symbol.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 172 "symbol.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 174 "symbol.vala"
	ret = FALSE;
#line 675 "symbol.c"
	{
		GSList* i_collection;
		GSList* i_it;
#line 176 "symbol.vala"
		i_collection = self->priv->expanded_rows;
#line 681 "symbol.c"
		for (i_it = i_collection; i_it != NULL; i_it = i_it->next) {
			char* i;
#line 176 "symbol.vala"
			i = g_strdup ((const char*) i_it->data);
#line 686 "symbol.c"
			{
#line 178 "symbol.vala"
				if (_vala_strcmp0 (i, name) == 0) {
#line 180 "symbol.vala"
					ret = TRUE;
#line 692 "symbol.c"
					_g_free0 (i);
#line 181 "symbol.vala"
					break;
#line 696 "symbol.c"
				}
				_g_free0 (i);
			}
		}
	}
	result = ret;
#line 184 "symbol.vala"
	return result;
#line 705 "symbol.c"
}


#line 187 "symbol.vala"
static void symbol_browser_add_expanded_row (SymbolBrowser* self, const char* name) {
#line 187 "symbol.vala"
	g_return_if_fail (self != NULL);
#line 187 "symbol.vala"
	g_return_if_fail (name != NULL);
#line 189 "symbol.vala"
	if (!symbol_browser_is_expanded_row (self, name)) {
#line 191 "symbol.vala"
		self->priv->expanded_rows = g_slist_prepend (self->priv->expanded_rows, g_strdup (name));
#line 192 "symbol.vala"
		symbol_browser_save_expanded_rows (self);
#line 721 "symbol.c"
	}
}


#line 196 "symbol.vala"
static void symbol_browser_remove_expanded_row (SymbolBrowser* self, const char* name) {
#line 728 "symbol.c"
	GSList* l;
#line 196 "symbol.vala"
	g_return_if_fail (self != NULL);
#line 196 "symbol.vala"
	g_return_if_fail (name != NULL);
#line 734 "symbol.c"
	l = NULL;
#line 200 "symbol.vala"
	if (symbol_browser_is_expanded_row (self, name) == TRUE) {
#line 738 "symbol.c"
		{
			gboolean _tmp0_;
#line 202 "symbol.vala"
			l = self->priv->expanded_rows;
#line 202 "symbol.vala"
			_tmp0_ = TRUE;
#line 202 "symbol.vala"
			while (TRUE) {
#line 202 "symbol.vala"
				if (!_tmp0_) {
#line 202 "symbol.vala"
					l = l->next;
#line 751 "symbol.c"
				}
#line 202 "symbol.vala"
				_tmp0_ = FALSE;
#line 202 "symbol.vala"
				if (!(l != NULL)) {
#line 202 "symbol.vala"
					break;
#line 759 "symbol.c"
				}
#line 204 "symbol.vala"
				if (_vala_strcmp0 ((const char*) l->data, name) == 0) {
#line 206 "symbol.vala"
					self->priv->expanded_rows = g_slist_remove_all (self->priv->expanded_rows, (const char*) l->data);
#line 765 "symbol.c"
				}
			}
		}
#line 209 "symbol.vala"
		symbol_browser_save_expanded_rows (self);
#line 771 "symbol.c"
	}
}


#line 216 "symbol.vala"
static char* symbol_browser_exec_ctags (SymbolBrowser* self, const char* filename, GError** error) {
#line 778 "symbol.c"
	char* result = NULL;
	GError * _inner_error_;
	char* output;
	char* command;
	char* _tmp0_;
	char* _tmp2_;
	char* _tmp1_ = NULL;
#line 216 "symbol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 216 "symbol.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 790 "symbol.c"
	_inner_error_ = NULL;
	output = NULL;
	command = NULL;
#line 222 "symbol.vala"
	command = (_tmp0_ = g_strdup_printf ("%s --extra=+q --fields=afmiKlnsStz -f - \"%s\"", VALIDE_CTAGS_EXEC, filename), _g_free0 (command), _tmp0_);
#line 225 "symbol.vala"
	g_spawn_command_line_sync (command, &_tmp1_, NULL, NULL, &_inner_error_);
#line 225 "symbol.vala"
	output = (_tmp2_ = _tmp1_, _g_free0 (output), _tmp2_);
#line 800 "symbol.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (output);
		_g_free0 (command);
		return NULL;
	}
	result = output;
	_g_free0 (command);
#line 227 "symbol.vala"
	return result;
#line 811 "symbol.c"
}


#line 236 "symbol.vala"
static Symbol* symbol_browser_parse_line (SymbolBrowser* self, const char* line) {
#line 817 "symbol.c"
	Symbol* result = NULL;
	gint _fields_size_;
	gint fields_length1;
	char** fields;
	Symbol* symbol;
	char** _tmp1_;
	char** _tmp0_;
#line 236 "symbol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 236 "symbol.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 829 "symbol.c"
	fields = (fields_length1 = 0, NULL);
#line 249 "symbol.vala"
	symbol = NULL;
#line 251 "symbol.vala"
	fields = (_tmp1_ = _tmp0_ = g_strsplit (line, "\t", 0), fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL), fields_length1 = _vala_array_length (_tmp0_), _fields_size_ = fields_length1, _tmp1_);
#line 252 "symbol.vala"
	if (fields[0] != NULL) {
#line 837 "symbol.c"
		Symbol* _tmp2_;
#line 254 "symbol.vala"
		symbol = (_tmp2_ = symbol_new (), _g_object_unref0 (symbol), _tmp2_);
#line 255 "symbol.vala"
		symbol_set_full_name (symbol, fields[0]);
#line 256 "symbol.vala"
		if (g_utf8_strrchr (symbol_get_full_name (symbol), (gssize) (-1), (gunichar) '.') != NULL) {
#line 258 "symbol.vala"
			symbol_set_name (symbol, g_utf8_offset_to_pointer (g_utf8_strrchr (symbol_get_full_name (symbol), (gssize) (-1), (gunichar) '.'), (glong) 1));
#line 847 "symbol.c"
		} else {
#line 262 "symbol.vala"
			symbol_set_name (symbol, symbol_get_full_name (symbol));
#line 851 "symbol.c"
		}
#line 264 "symbol.vala"
		symbol_set_file (symbol, fields[1]);
#line 855 "symbol.c"
		{
			gint i;
#line 266 "symbol.vala"
			i = 3;
#line 860 "symbol.c"
			{
				gboolean _tmp3_;
#line 266 "symbol.vala"
				_tmp3_ = TRUE;
#line 266 "symbol.vala"
				while (TRUE) {
#line 867 "symbol.c"
					gint _splits_size_;
					gint splits_length1;
					char** splits;
					char** _tmp5_;
					char** _tmp4_;
					GQuark _tmp10_;
					const char* _tmp9_;
					static GQuark _tmp10__label0 = 0;
#line 266 "symbol.vala"
					if (!_tmp3_) {
#line 266 "symbol.vala"
						i++;
#line 880 "symbol.c"
					}
#line 266 "symbol.vala"
					_tmp3_ = FALSE;
#line 266 "symbol.vala"
					if (!(i < fields_length1)) {
#line 266 "symbol.vala"
						break;
#line 888 "symbol.c"
					}
					splits = (splits_length1 = 0, NULL);
#line 270 "symbol.vala"
					splits = (_tmp5_ = _tmp4_ = g_strsplit (fields[i], ":", 0), splits = (_vala_array_free (splits, splits_length1, (GDestroyNotify) g_free), NULL), splits_length1 = _vala_array_length (_tmp4_), _splits_size_ = splits_length1, _tmp5_);
#line 893 "symbol.c"
					_tmp9_ = splits[0];
					_tmp10_ = (NULL == _tmp9_) ? 0 : g_quark_from_string (_tmp9_);
					if (_tmp10_ == ((0 != _tmp10__label0) ? _tmp10__label0 : (_tmp10__label0 = g_quark_from_static_string ("inherits"))))
					switch (0) {
						default:
						{
							char** _tmp8_;
							gint _tmp7__length1;
							char** _tmp7_;
							char** _tmp6_;
#line 274 "symbol.vala"
							_tmp8_ = (_tmp7_ = _tmp6_ = g_strsplit (splits[1], ",", 0), _tmp7__length1 = _vala_array_length (_tmp6_), _tmp7_);
#line 274 "symbol.vala"
							symbol_set_inherits (symbol, _tmp8_, _vala_array_length (_tmp6_));
#line 908 "symbol.c"
							_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 275 "symbol.vala"
							break;
#line 912 "symbol.c"
						}
					} else
					switch (0) {
						default:
						{
#line 277 "symbol.vala"
							if (g_object_class_find_property (G_OBJECT_GET_CLASS ((GObject*) symbol), splits[0]) != NULL) {
#line 279 "symbol.vala"
								g_object_set ((GObject*) symbol, splits[0], splits[1], NULL);
#line 922 "symbol.c"
							}
#line 281 "symbol.vala"
							break;
#line 926 "symbol.c"
						}
					}
					splits = (_vala_array_free (splits, splits_length1, (GDestroyNotify) g_free), NULL);
				}
			}
		}
	}
	result = symbol;
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 285 "symbol.vala"
	return result;
#line 938 "symbol.c"
}


#line 288 "symbol.vala"
static void symbol_browser_clear_data (SymbolBrowser* self) {
#line 944 "symbol.c"
	GHashTable* _tmp0_;
#line 288 "symbol.vala"
	g_return_if_fail (self != NULL);
#line 290 "symbol.vala"
	gtk_tree_store_clear (self->priv->model);
#line 291 "symbol.vala"
	self->priv->root_nodes = (_tmp0_ = g_hash_table_new (g_str_hash, g_str_equal), _g_hash_table_unref0 (self->priv->root_nodes), _tmp0_);
#line 292 "symbol.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self->priv->box, FALSE);
#line 293 "symbol.vala"
	gtk_label_set_text (self->priv->label, "");
#line 956 "symbol.c"
}


#line 1052 "glib-2.0.vapi"
static char* string_replace (const char* self, const char* old, const char* replacement) {
#line 962 "symbol.c"
	char* result = NULL;
	GError * _inner_error_;
#line 1052 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1052 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1052 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 971 "symbol.c"
	_inner_error_ = NULL;
	{
		char* _tmp0_;
		GRegex* _tmp1_;
		GRegex* regex;
		char* _tmp2_;
#line 1054 "glib-2.0.vapi"
		regex = (_tmp1_ = g_regex_new (_tmp0_ = g_regex_escape_string (old, -1), 0, 0, &_inner_error_), _g_free0 (_tmp0_), _tmp1_);
#line 980 "symbol.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
#line 1055 "glib-2.0.vapi"
		_tmp2_ = g_regex_replace_literal (regex, self, (gssize) (-1), 0, replacement, 0, &_inner_error_);
#line 991 "symbol.c"
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		result = _tmp2_;
		_g_regex_unref0 (regex);
#line 1055 "glib-2.0.vapi"
		return result;
#line 1006 "symbol.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 1057 "glib-2.0.vapi"
			g_assert_not_reached ();
#line 1017 "symbol.c"
			_g_error_free0 (e);
		}
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static GtkTreeIter* _gtk_tree_iter_dup (GtkTreeIter* self) {
	GtkTreeIter* dup;
	dup = g_new0 (GtkTreeIter, 1);
	memcpy (dup, self, sizeof (GtkTreeIter));
	return dup;
}


static gpointer __gtk_tree_iter_dup0 (gpointer self) {
	return self ? _gtk_tree_iter_dup (self) : NULL;
}


#line 300 "symbol.vala"
static gboolean symbol_browser_add_symbol (SymbolBrowser* self, Symbol* symbol) {
#line 1045 "symbol.c"
	gboolean result = FALSE;
	char* markup;
	GdkPixbuf* pixbuf;
	GtkTreeIter iter = {0};
	GtkTreeIter* parent = NULL;
	char* _tmp0_;
	char* _tmp1_;
	GdkPixbuf* _tmp2_;
#line 300 "symbol.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 300 "symbol.vala"
	g_return_val_if_fail (symbol != NULL, FALSE);
#line 1058 "symbol.c"
	markup = NULL;
	pixbuf = NULL;
#line 307 "symbol.vala"
	valide_utils_process_gtk_events ();
#line 308 "symbol.vala"
	symbol_set_name (symbol, _tmp0_ = string_replace (symbol_get_name (symbol), "<", "&lt;"));
#line 1065 "symbol.c"
	_g_free0 (_tmp0_);
#line 309 "symbol.vala"
	symbol_set_name (symbol, _tmp1_ = string_replace (symbol_get_name (symbol), ">", "&gt;"));
#line 1069 "symbol.c"
	_g_free0 (_tmp1_);
#line 311 "symbol.vala"
	pixbuf = (_tmp2_ = valide_utils_get_symbol_pixbuf (symbol_get_kind (symbol)), _g_object_unref0 (pixbuf), _tmp2_);
#line 313 "symbol.vala"
	if (!symbol_browser_get_hierarchic_view (self)) {
#line 1075 "symbol.c"
		char* _tmp3_;
		GtkTreeIter* _tmp4_;
#line 316 "symbol.vala"
		markup = (_tmp3_ = g_strdup_printf ("<b>%s</b>", symbol_get_name (symbol)), _g_free0 (markup), _tmp3_);
#line 319 "symbol.vala"
		parent = (_tmp4_ = __gtk_tree_iter_dup0 ((GtkTreeIter*) g_hash_table_lookup (self->priv->root_nodes, markup)), _g_free0 (parent), _tmp4_);
#line 321 "symbol.vala"
		if (parent == NULL) {
#line 1084 "symbol.c"
			GtkTreeIter tmp = {0};
			GtkTreeIter* _tmp5_;
#line 325 "symbol.vala"
			gtk_tree_store_append (self->priv->model, &tmp, NULL);
#line 326 "symbol.vala"
			parent = (_tmp5_ = __gtk_tree_iter_dup0 (&tmp), _g_free0 (parent), _tmp5_);
#line 327 "symbol.vala"
			gtk_tree_store_set (self->priv->model, parent, SYMBOL_BROWSER_COL_ICON, pixbuf, SYMBOL_BROWSER_COL_NAME, markup, -1);
#line 328 "symbol.vala"
			g_hash_table_insert (self->priv->root_nodes, g_strdup (markup), __gtk_tree_iter_dup0 (parent));
#line 1095 "symbol.c"
		}
#line 331 "symbol.vala"
		gtk_tree_store_append (self->priv->model, &iter, parent);
#line 333 "symbol.vala"
		gtk_tree_store_set (self->priv->model, &iter, SYMBOL_BROWSER_COL_ICON, pixbuf, SYMBOL_BROWSER_COL_NAME, symbol_get_name (symbol), SYMBOL_BROWSER_COL_FILE, symbol_get_file (symbol), SYMBOL_BROWSER_COL_LINE, atoi (symbol_get_line (symbol)), SYMBOL_BROWSER_COL_LANGUAGE, symbol_get_language (symbol), -1);
#line 1101 "symbol.c"
	} else {
#line 341 "symbol.vala"
		if (symbol->root != NULL) {
#line 1105 "symbol.c"
			GtkTreeIter* _tmp6_;
#line 343 "symbol.vala"
			parent = (_tmp6_ = __gtk_tree_iter_dup0 ((GtkTreeIter*) g_hash_table_lookup (self->priv->root_nodes, symbol_get_full_name (symbol->root))), _g_free0 (parent), _tmp6_);
#line 344 "symbol.vala"
			gtk_tree_store_append (self->priv->model, &iter, parent);
#line 1111 "symbol.c"
		} else {
			GtkTreeIter* _tmp7_;
#line 348 "symbol.vala"
			gtk_tree_store_append (self->priv->model, &iter, NULL);
#line 349 "symbol.vala"
			parent = (_tmp7_ = __gtk_tree_iter_dup0 (&iter), _g_free0 (parent), _tmp7_);
#line 1118 "symbol.c"
		}
#line 351 "symbol.vala"
		gtk_tree_store_set (self->priv->model, &iter, SYMBOL_BROWSER_COL_ICON, pixbuf, SYMBOL_BROWSER_COL_NAME, symbol_get_name (symbol), SYMBOL_BROWSER_COL_FILE, symbol_get_file (symbol), SYMBOL_BROWSER_COL_LINE, atoi (symbol_get_line (symbol)), SYMBOL_BROWSER_COL_LANGUAGE, symbol_get_language (symbol), -1);
#line 356 "symbol.vala"
		g_hash_table_insert (self->priv->root_nodes, g_strdup (symbol_get_full_name (symbol)), __gtk_tree_iter_dup0 (&iter));
#line 1124 "symbol.c"
	}
	result = TRUE;
	_g_free0 (markup);
	_g_object_unref0 (pixbuf);
	_g_free0 (parent);
#line 358 "symbol.vala"
	return result;
#line 1132 "symbol.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 361 "symbol.vala"
static gboolean symbol_browser_populate_symbols_asc (SymbolBrowser* self) {
#line 1143 "symbol.c"
	gboolean result = FALSE;
	GError * _inner_error_;
#line 361 "symbol.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1148 "symbol.c"
	_inner_error_ = NULL;
#line 363 "symbol.vala"
	if (g_atomic_int_compare_and_exchange (&self->priv->atom, 0, 1)) {
#line 1152 "symbol.c"
		ValideDocument* document;
		GtkTreeStore* _tmp1_;
		GtkTreeModel* _tmp0_;
		ValideDocument* _tmp2_;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		document = NULL;
#line 367 "symbol.vala"
		self->priv->model = (_tmp1_ = _g_object_ref0 ((_tmp0_ = gtk_tree_view_get_model (self->priv->tree_view), GTK_IS_TREE_STORE (_tmp0_) ? ((GtkTreeStore*) _tmp0_) : NULL)), _g_object_unref0 (self->priv->model), _tmp1_);
#line 368 "symbol.vala"
		gtk_tree_view_set_model (self->priv->tree_view, NULL);
#line 369 "symbol.vala"
		gtk_widget_freeze_child_notify ((GtkWidget*) self->priv->tree_view);
#line 371 "symbol.vala"
		document = (_tmp2_ = _g_object_ref0 (valide_document_manager_get_current (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)))), _g_object_unref0 (document), _tmp2_);
#line 372 "symbol.vala"
		if (document != NULL) {
#line 373 "symbol.vala"
			_tmp4_ = _vala_strcmp0 (valide_document_get_path (document), _ ("New file")) != 0;
#line 1172 "symbol.c"
		} else {
#line 372 "symbol.vala"
			_tmp4_ = FALSE;
#line 1176 "symbol.c"
		}
#line 372 "symbol.vala"
		if (_tmp4_) {
#line 374 "symbol.vala"
			_tmp3_ = g_file_test (valide_document_get_path (document), G_FILE_TEST_EXISTS);
#line 1182 "symbol.c"
		} else {
#line 372 "symbol.vala"
			_tmp3_ = FALSE;
#line 1186 "symbol.c"
		}
#line 372 "symbol.vala"
		if (_tmp3_) {
#line 376 "symbol.vala"
			symbol_browser_clear_data (self);
#line 1192 "symbol.c"
			{
				char* output;
				gint _lines_size_;
				gint lines_length1;
				char** lines;
				Symbol* root;
				char* _tmp5_;
				char* _tmp6_;
				char** _tmp8_;
				char** _tmp7_;
				output = NULL;
				lines = (lines_length1 = 0, NULL);
#line 382 "symbol.vala"
				root = NULL;
#line 384 "symbol.vala"
				_tmp5_ = symbol_browser_exec_ctags (self, valide_document_get_path (document), &_inner_error_);
#line 1209 "symbol.c"
				if (_inner_error_ != NULL) {
					_g_free0 (output);
					lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
					_g_object_unref0 (root);
					goto __catch1_g_error;
				}
#line 384 "symbol.vala"
				output = (_tmp6_ = _tmp5_, _g_free0 (output), _tmp6_);
#line 385 "symbol.vala"
				lines = (_tmp8_ = _tmp7_ = g_strsplit (output, "\n", 0), lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL), lines_length1 = _vala_array_length (_tmp7_), _lines_size_ = lines_length1, _tmp8_);
#line 1220 "symbol.c"
				{
					gint i;
#line 386 "symbol.vala"
					i = 0;
#line 1225 "symbol.c"
					{
						gboolean _tmp9_;
#line 386 "symbol.vala"
						_tmp9_ = TRUE;
#line 386 "symbol.vala"
						while (TRUE) {
#line 386 "symbol.vala"
							if (!_tmp9_) {
#line 386 "symbol.vala"
								i++;
#line 1236 "symbol.c"
							}
#line 386 "symbol.vala"
							_tmp9_ = FALSE;
#line 386 "symbol.vala"
							if (!(lines[i] != NULL)) {
#line 386 "symbol.vala"
								break;
#line 1244 "symbol.c"
							}
#line 388 "symbol.vala"
							if (_vala_strcmp0 (lines[i], "") != 0) {
#line 1248 "symbol.c"
								Symbol* symbol;
								Symbol* _tmp10_;
								symbol = NULL;
#line 392 "symbol.vala"
								symbol = (_tmp10_ = symbol_browser_parse_line (self, lines[i]), _g_object_unref0 (symbol), _tmp10_);
#line 393 "symbol.vala"
								if (symbol != NULL) {
#line 1256 "symbol.c"
									Symbol* _tmp17_;
									gboolean _tmp18_ = FALSE;
									gboolean _tmp19_ = FALSE;
#line 395 "symbol.vala"
									symbol->document = document;
#line 396 "symbol.vala"
									if (_vala_strcmp0 (symbol_get_kind (symbol), "class") == 0) {
#line 1264 "symbol.c"
										Symbol* _tmp11_;
#line 398 "symbol.vala"
										root = (_tmp11_ = NULL, _g_object_unref0 (root), _tmp11_);
#line 1268 "symbol.c"
									} else {
										gboolean _tmp12_ = FALSE;
#line 400 "symbol.vala"
										if (root != NULL) {
#line 1273 "symbol.c"
											gboolean _tmp13_ = FALSE;
											gboolean _tmp14_ = FALSE;
#line 401 "symbol.vala"
											if (_vala_strcmp0 (symbol_get_kind (root), "enum") == 0) {
#line 401 "symbol.vala"
												_tmp14_ = _vala_strcmp0 (symbol_get_kind (symbol), "enumvalue") != 0;
#line 1280 "symbol.c"
											} else {
#line 401 "symbol.vala"
												_tmp14_ = FALSE;
#line 1284 "symbol.c"
											}
#line 401 "symbol.vala"
											if (_tmp14_) {
#line 401 "symbol.vala"
												_tmp13_ = TRUE;
#line 1290 "symbol.c"
											} else {
												gboolean _tmp15_ = FALSE;
#line 402 "symbol.vala"
												if (_vala_strcmp0 (symbol_get_kind (root), "errordomain") == 0) {
#line 402 "symbol.vala"
													_tmp15_ = _vala_strcmp0 (symbol_get_kind (symbol), "errorcode") != 0;
#line 1297 "symbol.c"
												} else {
#line 402 "symbol.vala"
													_tmp15_ = FALSE;
#line 1301 "symbol.c"
												}
#line 402 "symbol.vala"
												_tmp13_ = _tmp15_;
#line 1305 "symbol.c"
											}
#line 401 "symbol.vala"
											_tmp12_ = _tmp13_;
#line 1309 "symbol.c"
										} else {
#line 400 "symbol.vala"
											_tmp12_ = FALSE;
#line 1313 "symbol.c"
										}
#line 400 "symbol.vala"
										if (_tmp12_) {
#line 1317 "symbol.c"
											Symbol* _tmp16_;
#line 404 "symbol.vala"
											root = (_tmp16_ = _g_object_ref0 (root->root), _g_object_unref0 (root), _tmp16_);
#line 1321 "symbol.c"
										}
									}
#line 406 "symbol.vala"
									symbol->root = (_tmp17_ = _g_object_ref0 (root), _g_object_unref0 (symbol->root), _tmp17_);
#line 407 "symbol.vala"
									symbol_browser_add_symbol (self, symbol);
#line 408 "symbol.vala"
									if (_vala_strcmp0 (symbol_get_kind (symbol), "class") == 0) {
#line 408 "symbol.vala"
										_tmp19_ = TRUE;
#line 1332 "symbol.c"
									} else {
#line 408 "symbol.vala"
										_tmp19_ = _vala_strcmp0 (symbol_get_kind (symbol), "enum") == 0;
#line 1336 "symbol.c"
									}
#line 408 "symbol.vala"
									if (_tmp19_) {
#line 408 "symbol.vala"
										_tmp18_ = TRUE;
#line 1342 "symbol.c"
									} else {
#line 409 "symbol.vala"
										_tmp18_ = _vala_strcmp0 (symbol_get_kind (symbol), "errordomain") == 0;
#line 1346 "symbol.c"
									}
#line 408 "symbol.vala"
									if (_tmp18_) {
#line 1350 "symbol.c"
										Symbol* _tmp20_;
#line 411 "symbol.vala"
										root = (_tmp20_ = _g_object_ref0 (symbol), _g_object_unref0 (root), _tmp20_);
#line 1354 "symbol.c"
									}
								}
								_g_object_unref0 (symbol);
							}
						}
					}
				}
				_g_free0 (output);
				lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
				_g_object_unref0 (root);
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError * e;
				e = _inner_error_;
				_inner_error_ = NULL;
				{
#line 419 "symbol.vala"
					g_debug (_ ("Could not execute ctags: %s\n"), e->message);
#line 1375 "symbol.c"
					_g_error_free0 (e);
				}
			}
			__finally1:
			if (_inner_error_ != NULL) {
				_g_object_unref0 (document);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return FALSE;
			}
#line 422 "symbol.vala"
			if (gtk_tree_model_iter_n_children ((GtkTreeModel*) self->priv->model, NULL) > 0) {
#line 424 "symbol.vala"
				gtk_widget_set_sensitive ((GtkWidget*) self->priv->box, TRUE);
#line 1390 "symbol.c"
			}
		} else {
#line 429 "symbol.vala"
			symbol_browser_clear_data (self);
#line 1395 "symbol.c"
		}
#line 431 "symbol.vala"
		gtk_tree_view_set_model (self->priv->tree_view, (GtkTreeModel*) self->priv->model);
#line 432 "symbol.vala"
		gtk_widget_thaw_child_notify ((GtkWidget*) self->priv->tree_view);
#line 434 "symbol.vala"
		gtk_tree_view_expand_all (self->priv->tree_view);
#line 435 "symbol.vala"
		g_atomic_int_set (&self->priv->atom, 0);
#line 1405 "symbol.c"
		_g_object_unref0 (document);
	}
	result = FALSE;
#line 437 "symbol.vala"
	return result;
#line 1411 "symbol.c"
}


#line 361 "symbol.vala"
static gboolean _symbol_browser_populate_symbols_asc_gsource_func (gpointer self) {
#line 1417 "symbol.c"
	return symbol_browser_populate_symbols_asc (self);
}


#line 443 "symbol.vala"
static void symbol_browser_populate_symbols (SymbolBrowser* self) {
#line 443 "symbol.vala"
	g_return_if_fail (self != NULL);
#line 445 "symbol.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _symbol_browser_populate_symbols_asc_gsource_func, g_object_ref (self), g_object_unref);
#line 1428 "symbol.c"
}


#line 452 "symbol.vala"
static void symbol_browser_restore_expanded_rows (SymbolBrowser* self) {
#line 452 "symbol.vala"
	g_return_if_fail (self != NULL);
#line 455 "symbol.vala"
	if (gtk_widget_get_sensitive ((GtkWidget*) valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self))) == TRUE) {
#line 1438 "symbol.c"
		GtkTreeIter iter = {0};
		GtkTreeModel* model;
		GtkTreeModel* _tmp0_;
		model = NULL;
#line 460 "symbol.vala"
		model = (_tmp0_ = _g_object_ref0 (gtk_tree_view_get_model (self->priv->tree_view)), _g_object_unref0 (model), _tmp0_);
#line 461 "symbol.vala"
		if (gtk_tree_model_get_iter_first (model, &iter) == TRUE) {
#line 1447 "symbol.c"
			{
				gboolean r;
#line 463 "symbol.vala"
				r = gtk_tree_model_get_iter_first (model, &iter);
#line 1452 "symbol.c"
				{
					gboolean _tmp1_;
#line 463 "symbol.vala"
					_tmp1_ = TRUE;
#line 463 "symbol.vala"
					while (TRUE) {
#line 1459 "symbol.c"
						char* name;
#line 463 "symbol.vala"
						if (!_tmp1_) {
#line 465 "symbol.vala"
							r = gtk_tree_model_iter_next (model, &iter);
#line 1465 "symbol.c"
						}
#line 463 "symbol.vala"
						_tmp1_ = FALSE;
#line 464 "symbol.vala"
						if (!(r == TRUE)) {
#line 464 "symbol.vala"
							break;
#line 1473 "symbol.c"
						}
						name = NULL;
#line 469 "symbol.vala"
						gtk_tree_model_get (model, &iter, SYMBOL_BROWSER_COL_NAME, &name, -1, -1);
#line 470 "symbol.vala"
						if (symbol_browser_is_expanded_row (self, name)) {
#line 1480 "symbol.c"
							GtkTreePath* path;
#line 472 "symbol.vala"
							path = gtk_tree_model_get_path (model, &iter);
#line 473 "symbol.vala"
							gtk_tree_view_expand_row (self->priv->tree_view, path, FALSE);
#line 1486 "symbol.c"
							_gtk_tree_path_free0 (path);
						}
						_g_free0 (name);
					}
				}
			}
		}
		_g_object_unref0 (model);
	}
}


#line 480 "symbol.vala"
static void symbol_browser_on_row_activated (SymbolBrowser* self, GtkTreeView* sender, GtkTreePath* path, GtkTreeViewColumn* column) {
#line 1501 "symbol.c"
	GError * _inner_error_;
	GtkTreeIter iter = {0};
	GtkTreeModel* model;
	GtkTreeModel* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 480 "symbol.vala"
	g_return_if_fail (self != NULL);
#line 480 "symbol.vala"
	g_return_if_fail (sender != NULL);
#line 480 "symbol.vala"
	g_return_if_fail (path != NULL);
#line 480 "symbol.vala"
	g_return_if_fail (column != NULL);
#line 1515 "symbol.c"
	_inner_error_ = NULL;
	model = NULL;
#line 486 "symbol.vala"
	model = (_tmp0_ = _g_object_ref0 (gtk_tree_view_get_model (self->priv->tree_view)), _g_object_unref0 (model), _tmp0_);
#line 487 "symbol.vala"
	gtk_tree_model_get_iter (model, &iter, path);
#line 490 "symbol.vala"
	if (!symbol_browser_get_hierarchic_view (self)) {
#line 490 "symbol.vala"
		_tmp1_ = gtk_tree_model_iter_has_child (model, &iter);
#line 1526 "symbol.c"
	} else {
#line 490 "symbol.vala"
		_tmp1_ = FALSE;
#line 1530 "symbol.c"
	}
#line 490 "symbol.vala"
	if (_tmp1_) {
#line 492 "symbol.vala"
		if (gtk_tree_view_row_expanded (self->priv->tree_view, path)) {
#line 494 "symbol.vala"
			gtk_tree_view_collapse_row (self->priv->tree_view, path);
#line 1538 "symbol.c"
		} else {
#line 498 "symbol.vala"
			gtk_tree_view_expand_row (self->priv->tree_view, path, FALSE);
#line 1542 "symbol.c"
		}
	} else {
		gint line = 0;
		char* name;
		char* filename;
		name = NULL;
		filename = NULL;
#line 508 "symbol.vala"
		gtk_tree_model_get (model, &iter, SYMBOL_BROWSER_COL_NAME, &name, SYMBOL_BROWSER_COL_LINE, &line, SYMBOL_BROWSER_COL_FILE, &filename, -1);
#line 1552 "symbol.c"
		{
			ValideDocument* document;
			ValideDocument* _tmp2_;
			ValideDocument* _tmp3_;
			document = NULL;
#line 514 "symbol.vala"
			_tmp2_ = valide_document_manager_create (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), filename, &_inner_error_);
#line 1560 "symbol.c"
			if (_inner_error_ != NULL) {
				_g_object_unref0 (document);
				goto __catch2_g_error;
			}
#line 514 "symbol.vala"
			document = (_tmp3_ = _tmp2_, _g_object_unref0 (document), _tmp3_);
#line 515 "symbol.vala"
			valide_source_view_goto_line (valide_document_get_text_view (document), line - 1);
#line 516 "symbol.vala"
			gtk_widget_grab_focus ((GtkWidget*) document);
#line 1571 "symbol.c"
			_g_object_unref0 (document);
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
#line 520 "symbol.vala"
				g_warning ("symbol.vala:520: %s", e->message);
#line 1583 "symbol.c"
				_g_error_free0 (e);
			}
		}
		__finally2:
		if (_inner_error_ != NULL) {
			_g_free0 (name);
			_g_free0 (filename);
			_g_object_unref0 (model);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_g_free0 (name);
		_g_free0 (filename);
	}
	_g_object_unref0 (model);
}


#line 525 "symbol.vala"
static void symbol_browser_on_cursor_changed (SymbolBrowser* self, GtkTreeView* sender) {
#line 1605 "symbol.c"
	GtkTreeIter iter = {0};
	GtkTreeModel* model;
	GtkTreeSelection* selection;
	GtkTreeModel* _tmp0_;
	GtkTreeSelection* _tmp1_;
#line 525 "symbol.vala"
	g_return_if_fail (self != NULL);
#line 525 "symbol.vala"
	g_return_if_fail (sender != NULL);
#line 1615 "symbol.c"
	model = NULL;
	selection = NULL;
#line 531 "symbol.vala"
	model = (_tmp0_ = _g_object_ref0 (gtk_tree_view_get_model (self->priv->tree_view)), _g_object_unref0 (model), _tmp0_);
#line 532 "symbol.vala"
	selection = (_tmp1_ = _g_object_ref0 (gtk_tree_view_get_selection (self->priv->tree_view)), _g_object_unref0 (selection), _tmp1_);
#line 533 "symbol.vala"
	if (gtk_tree_selection_get_selected (selection, NULL, &iter)) {
#line 1624 "symbol.c"
		gint line = 0;
		char* name;
		char* filename;
		name = NULL;
		filename = NULL;
#line 539 "symbol.vala"
		gtk_tree_model_get (model, &iter, SYMBOL_BROWSER_COL_NAME, &name, SYMBOL_BROWSER_COL_FILE, &filename, SYMBOL_BROWSER_COL_LINE, &line, -1);
#line 542 "symbol.vala"
		if (filename != NULL) {
#line 1634 "symbol.c"
			char* label_text;
			char* status_message;
			char* _tmp3_;
			char* _tmp2_;
			char* _tmp4_;
			label_text = NULL;
			status_message = NULL;
#line 547 "symbol.vala"
			label_text = (_tmp3_ = g_strdup_printf ("%s Line:%d", _tmp2_ = g_path_get_basename (filename), line), _g_free0 (label_text), _tmp3_);
#line 1644 "symbol.c"
			_g_free0 (_tmp2_);
#line 548 "symbol.vala"
			gtk_label_set_text (self->priv->label, label_text);
#line 550 "symbol.vala"
			status_message = (_tmp4_ = g_strdup_printf ("Double-click to jump to '%s'", name), _g_free0 (status_message), _tmp4_);
#line 551 "symbol.vala"
			valide_statusbar_flash_message (valide_window_get_statusbar (valide_plugin_get_window ((ValidePlugin*) self)), self->priv->status_context, status_message);
#line 1652 "symbol.c"
			_g_free0 (label_text);
			_g_free0 (status_message);
		}
		_g_free0 (name);
		_g_free0 (filename);
	}
	_g_object_unref0 (model);
	_g_object_unref0 (selection);
}


#line 556 "symbol.vala"
static void symbol_browser_on_row_expanded (SymbolBrowser* self, GtkTreeView* sender, GtkTreeIter* iter, GtkTreePath* path) {
#line 1666 "symbol.c"
	char* name;
	GtkTreeModel* model;
	GtkTreeModel* _tmp0_;
#line 556 "symbol.vala"
	g_return_if_fail (self != NULL);
#line 556 "symbol.vala"
	g_return_if_fail (sender != NULL);
#line 556 "symbol.vala"
	g_return_if_fail (path != NULL);
#line 1676 "symbol.c"
	name = NULL;
	model = NULL;
#line 562 "symbol.vala"
	model = (_tmp0_ = _g_object_ref0 (gtk_tree_view_get_model (self->priv->tree_view)), _g_object_unref0 (model), _tmp0_);
#line 563 "symbol.vala"
	gtk_tree_model_get (model, iter, SYMBOL_BROWSER_COL_NAME, &name, -1, -1);
#line 564 "symbol.vala"
	g_return_if_fail (name != NULL);
#line 566 "symbol.vala"
	symbol_browser_add_expanded_row (self, name);
#line 1687 "symbol.c"
	_g_free0 (name);
	_g_object_unref0 (model);
}


#line 569 "symbol.vala"
static void symbol_browser_on_row_collapsed (SymbolBrowser* self, GtkTreeView* sender, GtkTreeIter* iter, GtkTreePath* path) {
#line 1695 "symbol.c"
	char* name;
	GtkTreeModel* model;
	GtkTreeModel* _tmp0_;
#line 569 "symbol.vala"
	g_return_if_fail (self != NULL);
#line 569 "symbol.vala"
	g_return_if_fail (sender != NULL);
#line 569 "symbol.vala"
	g_return_if_fail (path != NULL);
#line 1705 "symbol.c"
	name = NULL;
	model = NULL;
#line 575 "symbol.vala"
	model = (_tmp0_ = _g_object_ref0 (gtk_tree_view_get_model (self->priv->tree_view)), _g_object_unref0 (model), _tmp0_);
#line 576 "symbol.vala"
	gtk_tree_model_get (model, iter, SYMBOL_BROWSER_COL_NAME, &name, -1, -1);
#line 577 "symbol.vala"
	g_return_if_fail (name != NULL);
#line 579 "symbol.vala"
	symbol_browser_remove_expanded_row (self, name);
#line 1716 "symbol.c"
	_g_free0 (name);
	_g_object_unref0 (model);
}


#line 690 "symbol.vala"
SymbolBrowser* symbol_browser_construct (GType object_type, const char* path) {
#line 1724 "symbol.c"
	GParameter * __params;
	GParameter * __params_it;
	SymbolBrowser * self;
#line 690 "symbol.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 1730 "symbol.c"
	__params = g_new0 (GParameter, 1);
	__params_it = __params;
#line 692 "symbol.vala"
	__params_it->name = "path";
#line 692 "symbol.vala"
	g_value_init (&__params_it->value, G_TYPE_STRING);
#line 692 "symbol.vala"
	g_value_set_string (&__params_it->value, path);
#line 692 "symbol.vala"
	__params_it++;
#line 1741 "symbol.c"
	self = g_object_newv (object_type, __params_it - __params, __params);
	while (__params_it > __params) {
		--__params_it;
		g_value_unset (&__params_it->value);
	}
	g_free (__params);
	return self;
}


#line 690 "symbol.vala"
SymbolBrowser* symbol_browser_new (const char* path) {
#line 690 "symbol.vala"
	return symbol_browser_construct (TYPE_SYMBOL_BROWSER, path);
#line 1756 "symbol.c"
}


#line 717 "symbol.vala"
static void _lambda0_ (GtkToggleButton* s, SymbolBrowser* self) {
#line 717 "symbol.vala"
	g_return_if_fail (s != NULL);
#line 718 "symbol.vala"
	symbol_browser_set_show_language_column (self, gtk_toggle_button_get_active (s));
#line 1766 "symbol.c"
}


#line 717 "symbol.vala"
static void __lambda0__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
#line 1772 "symbol.c"
	_lambda0_ (_sender, self);
}


#line 724 "symbol.vala"
static void _lambda1_ (GtkToggleButton* s, SymbolBrowser* self) {
#line 724 "symbol.vala"
	g_return_if_fail (s != NULL);
#line 725 "symbol.vala"
	symbol_browser_set_show_source_file_column (self, gtk_toggle_button_get_active (s));
#line 1783 "symbol.c"
}


#line 724 "symbol.vala"
static void __lambda1__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
#line 1789 "symbol.c"
	_lambda1_ (_sender, self);
}


#line 731 "symbol.vala"
static void _lambda2_ (GtkToggleButton* s, SymbolBrowser* self) {
#line 731 "symbol.vala"
	g_return_if_fail (s != NULL);
#line 732 "symbol.vala"
	symbol_browser_set_show_line_number_column (self, gtk_toggle_button_get_active (s));
#line 1800 "symbol.c"
}


#line 731 "symbol.vala"
static void __lambda2__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
#line 1806 "symbol.c"
	_lambda2_ (_sender, self);
}


#line 738 "symbol.vala"
static void _lambda3_ (GtkToggleButton* s, SymbolBrowser* self) {
#line 738 "symbol.vala"
	g_return_if_fail (s != NULL);
#line 739 "symbol.vala"
	symbol_browser_set_hierarchic_view (self, gtk_toggle_button_get_active (s));
#line 1817 "symbol.c"
}


#line 738 "symbol.vala"
static void __lambda3__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
#line 1823 "symbol.c"
	_lambda3_ (_sender, self);
}


#line 704 "symbol.vala"
GtkWidget* symbol_browser_create_configure_dialog (SymbolBrowser* self) {
#line 1830 "symbol.c"
	GtkWidget* result = NULL;
	ValideFrame* frame;
	GtkVBox* vbox;
	GtkCheckButton* check;
	ValideFrame* _tmp0_;
	GtkVBox* _tmp1_;
	GtkCheckButton* _tmp2_;
	GtkCheckButton* _tmp3_;
	GtkCheckButton* _tmp4_;
	GtkCheckButton* _tmp5_;
#line 704 "symbol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1843 "symbol.c"
	frame = NULL;
	vbox = NULL;
	check = NULL;
#line 710 "symbol.vala"
	frame = (_tmp0_ = g_object_ref_sink (valide_frame_new (_ ("Additionnal columns"))), _g_object_unref0 (frame), _tmp0_);
#line 712 "symbol.vala"
	vbox = (_tmp1_ = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (TRUE, 0)), _g_object_unref0 (vbox), _tmp1_);
#line 713 "symbol.vala"
	gtk_container_add ((GtkContainer*) frame, (GtkWidget*) vbox);
#line 715 "symbol.vala"
	check = (_tmp2_ = g_object_ref_sink ((GtkCheckButton*) gtk_check_button_new_with_label (_ ("Programming language"))), _g_object_unref0 (check), _tmp2_);
#line 716 "symbol.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) check, symbol_browser_get_show_language_column (self));
#line 717 "symbol.vala"
	g_signal_connect_object ((GtkToggleButton*) check, "toggled", (GCallback) __lambda0__gtk_toggle_button_toggled, self, 0);
#line 720 "symbol.vala"
	gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) check, TRUE, TRUE, (guint) 0);
#line 722 "symbol.vala"
	check = (_tmp3_ = g_object_ref_sink ((GtkCheckButton*) gtk_check_button_new_with_label (_ ("Source file"))), _g_object_unref0 (check), _tmp3_);
#line 723 "symbol.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) check, symbol_browser_get_show_source_file_column (self));
#line 724 "symbol.vala"
	g_signal_connect_object ((GtkToggleButton*) check, "toggled", (GCallback) __lambda1__gtk_toggle_button_toggled, self, 0);
#line 727 "symbol.vala"
	gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) check, TRUE, TRUE, (guint) 0);
#line 729 "symbol.vala"
	check = (_tmp4_ = g_object_ref_sink ((GtkCheckButton*) gtk_check_button_new_with_label (_ ("Line number"))), _g_object_unref0 (check), _tmp4_);
#line 730 "symbol.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) check, symbol_browser_get_show_line_number_column (self));
#line 731 "symbol.vala"
	g_signal_connect_object ((GtkToggleButton*) check, "toggled", (GCallback) __lambda2__gtk_toggle_button_toggled, self, 0);
#line 734 "symbol.vala"
	gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) check, TRUE, TRUE, (guint) 0);
#line 736 "symbol.vala"
	check = (_tmp5_ = g_object_ref_sink ((GtkCheckButton*) gtk_check_button_new_with_label (_ ("Hierarchic view"))), _g_object_unref0 (check), _tmp5_);
#line 737 "symbol.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) check, symbol_browser_get_hierarchic_view (self));
#line 738 "symbol.vala"
	g_signal_connect_object ((GtkToggleButton*) check, "toggled", (GCallback) __lambda3__gtk_toggle_button_toggled, self, 0);
#line 741 "symbol.vala"
	gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) check, TRUE, TRUE, (guint) 0);
#line 1885 "symbol.c"
	result = (GtkWidget*) frame;
	_g_object_unref0 (vbox);
	_g_object_unref0 (check);
#line 743 "symbol.vala"
	return result;
#line 1891 "symbol.c"
}


static const char* symbol_browser_real_get_path (ValidePlugin* base) {
	const char* result;
	SymbolBrowser* self;
	self = (SymbolBrowser*) base;
	result = self->priv->_path;
#line 81 "symbol.vala"
	return result;
#line 1902 "symbol.c"
}


static void symbol_browser_real_set_path (ValidePlugin* base, const char* value) {
	SymbolBrowser* self;
	char* _tmp0_;
	self = (SymbolBrowser*) base;
	self->priv->_path = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_path), _tmp0_);
	g_object_notify ((GObject *) self, "path");
}


static ValideWindow* symbol_browser_real_get_window (ValidePlugin* base) {
	ValideWindow* result;
	SymbolBrowser* self;
	self = (SymbolBrowser*) base;
	result = self->priv->_window;
#line 85 "symbol.vala"
	return result;
#line 1922 "symbol.c"
}


static void symbol_browser_real_set_window (ValidePlugin* base, ValideWindow* value) {
	SymbolBrowser* self;
	ValideWindow* _tmp0_;
	self = (SymbolBrowser*) base;
	self->priv->_window = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_window), _tmp0_);
	g_object_notify ((GObject *) self, "window");
}


static gboolean symbol_browser_get_show_language_column (SymbolBrowser* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = valide_abstract_config_manager_get_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "show-language");
#line 91 "symbol.vala"
	return result;
#line 1941 "symbol.c"
}


static void symbol_browser_set_show_language_column (SymbolBrowser* self, gboolean value) {
	g_return_if_fail (self != NULL);
#line 96 "symbol.vala"
	valide_abstract_config_manager_set_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "show-language", value);
#line 98 "symbol.vala"
	gtk_tree_view_column_set_visible (self->priv->language_column, value);
#line 1951 "symbol.c"
}


static gboolean symbol_browser_get_show_source_file_column (SymbolBrowser* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = valide_abstract_config_manager_get_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "show-source-file");
#line 106 "symbol.vala"
	return result;
#line 1961 "symbol.c"
}


static void symbol_browser_set_show_source_file_column (SymbolBrowser* self, gboolean value) {
	g_return_if_fail (self != NULL);
#line 111 "symbol.vala"
	valide_abstract_config_manager_set_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "show-source-file", value);
#line 113 "symbol.vala"
	gtk_tree_view_column_set_visible (self->priv->source_file_column, value);
#line 1971 "symbol.c"
}


static gboolean symbol_browser_get_show_line_number_column (SymbolBrowser* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = valide_abstract_config_manager_get_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "show-line-number");
#line 121 "symbol.vala"
	return result;
#line 1981 "symbol.c"
}


static void symbol_browser_set_show_line_number_column (SymbolBrowser* self, gboolean value) {
	g_return_if_fail (self != NULL);
#line 126 "symbol.vala"
	valide_abstract_config_manager_set_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "show-line-number", value);
#line 128 "symbol.vala"
	gtk_tree_view_column_set_visible (self->priv->line_number_column, value);
#line 1991 "symbol.c"
}


static gboolean symbol_browser_get_hierarchic_view (SymbolBrowser* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = valide_abstract_config_manager_get_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "hierarchic-view");
#line 136 "symbol.vala"
	return result;
#line 2001 "symbol.c"
}


static void symbol_browser_set_hierarchic_view (SymbolBrowser* self, gboolean value) {
	g_return_if_fail (self != NULL);
#line 141 "symbol.vala"
	valide_abstract_config_manager_set_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "hierarchic-view", value);
#line 143 "symbol.vala"
	symbol_browser_populate_symbols (self);
#line 2011 "symbol.c"
}


#line 480 "symbol.vala"
static void _symbol_browser_on_row_activated_gtk_tree_view_row_activated (GtkTreeView* _sender, GtkTreePath* path, GtkTreeViewColumn* column, gpointer self) {
#line 2017 "symbol.c"
	symbol_browser_on_row_activated (self, _sender, path, column);
}


#line 525 "symbol.vala"
static void _symbol_browser_on_cursor_changed_gtk_tree_view_cursor_changed (GtkTreeView* _sender, gpointer self) {
#line 2024 "symbol.c"
	symbol_browser_on_cursor_changed (self, _sender);
}


#line 556 "symbol.vala"
static void _symbol_browser_on_row_expanded_gtk_tree_view_row_expanded (GtkTreeView* _sender, GtkTreeIter* iter, GtkTreePath* path, gpointer self) {
#line 2031 "symbol.c"
	symbol_browser_on_row_expanded (self, _sender, iter, path);
}


#line 569 "symbol.vala"
static void _symbol_browser_on_row_collapsed_gtk_tree_view_row_collapsed (GtkTreeView* _sender, GtkTreeIter* iter, GtkTreePath* path, gpointer self) {
#line 2038 "symbol.c"
	symbol_browser_on_row_collapsed (self, _sender, iter, path);
}


#line 443 "symbol.vala"
static void _symbol_browser_populate_symbols_valide_document_manager_tab_removed (ValideDocumentManager* _sender, ValideDocument* document, gpointer self) {
#line 2045 "symbol.c"
	symbol_browser_populate_symbols (self);
}


#line 443 "symbol.vala"
static void _symbol_browser_populate_symbols_valide_document_manager_tab_changed (ValideDocumentManager* _sender, ValideDocument* document, gpointer self) {
#line 2052 "symbol.c"
	symbol_browser_populate_symbols (self);
}


#line 443 "symbol.vala"
static void _symbol_browser_populate_symbols_valide_document_manager_tab_saved (ValideDocumentManager* _sender, ValideDocument* document, gpointer self) {
#line 2059 "symbol.c"
	symbol_browser_populate_symbols (self);
}


static GObject * symbol_browser_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	SymbolBrowser * self;
	GError * _inner_error_;
	parent_class = G_OBJECT_CLASS (symbol_browser_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = SYMBOL_BROWSER (obj);
	_inner_error_ = NULL;
	{
		GtkTreeStore* store;
		GtkTreeViewColumn* col;
		GtkScrolledWindow* scrolled;
		GtkCellRendererText* renderer;
		GtkCellRendererPixbuf* renderer_pixbuf;
		GtkVBox* _tmp0_;
		GtkScrolledWindow* _tmp1_;
		GtkTreeView* _tmp2_;
		GtkLabel* _tmp3_;
		GtkTreeStore* _tmp4_;
		GtkTreeViewColumn* _tmp5_;
		GtkCellRendererPixbuf* _tmp6_;
		GtkCellRendererText* _tmp7_;
		GtkTreeViewColumn* _tmp8_;
		GtkCellRendererText* _tmp9_;
		GtkTreeViewColumn* _tmp10_;
		GtkCellRendererText* _tmp11_;
		GtkTreeViewColumn* _tmp12_;
		GtkCellRendererText* _tmp13_;
		store = NULL;
		col = NULL;
		scrolled = NULL;
		renderer = NULL;
		renderer_pixbuf = NULL;
#line 590 "symbol.vala"
		g_atomic_int_set (&self->priv->atom, 0);
#line 592 "symbol.vala"
		self->priv->box = (_tmp0_ = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 0)), _g_object_unref0 (self->priv->box), _tmp0_);
#line 595 "symbol.vala"
		gtk_box_set_spacing ((GtkBox*) self->priv->box, 2);
#line 596 "symbol.vala"
		gtk_container_set_border_width ((GtkContainer*) self->priv->box, (guint) 2);
#line 599 "symbol.vala"
		scrolled = (_tmp1_ = g_object_ref_sink ((GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL)), _g_object_unref0 (scrolled), _tmp1_);
#line 600 "symbol.vala"
		gtk_scrolled_window_set_policy (scrolled, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
#line 601 "symbol.vala"
		gtk_scrolled_window_set_shadow_type (scrolled, GTK_SHADOW_IN);
#line 602 "symbol.vala"
		gtk_box_pack_start ((GtkBox*) self->priv->box, (GtkWidget*) scrolled, TRUE, TRUE, (guint) 0);
#line 604 "symbol.vala"
		self->priv->tree_view = (_tmp2_ = g_object_ref_sink ((GtkTreeView*) gtk_tree_view_new ()), _g_object_unref0 (self->priv->tree_view), _tmp2_);
#line 605 "symbol.vala"
		gtk_tree_view_set_rules_hint (self->priv->tree_view, FALSE);
#line 606 "symbol.vala"
		gtk_tree_view_set_headers_visible (self->priv->tree_view, TRUE);
#line 607 "symbol.vala"
		gtk_tree_view_set_headers_clickable (self->priv->tree_view, TRUE);
#line 608 "symbol.vala"
		gtk_container_add ((GtkContainer*) scrolled, (GtkWidget*) self->priv->tree_view);
#line 611 "symbol.vala"
		self->priv->label = (_tmp3_ = g_object_ref_sink ((GtkLabel*) gtk_label_new ("")), _g_object_unref0 (self->priv->label), _tmp3_);
#line 612 "symbol.vala"
		gtk_misc_set_alignment ((GtkMisc*) self->priv->label, (float) 0.0, (float) 0.5);
#line 613 "symbol.vala"
		gtk_box_pack_start ((GtkBox*) self->priv->box, (GtkWidget*) self->priv->label, FALSE, TRUE, (guint) 0);
#line 616 "symbol.vala"
		store = (_tmp4_ = gtk_tree_store_new ((gint) SYMBOL_BROWSER_COL_NB, GDK_TYPE_PIXBUF, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_INT, G_TYPE_STRING, G_TYPE_OBJECT, NULL), _g_object_unref0 (store), _tmp4_);
#line 622 "symbol.vala"
		col = (_tmp5_ = g_object_ref_sink (gtk_tree_view_column_new ()), _g_object_unref0 (col), _tmp5_);
#line 623 "symbol.vala"
		gtk_tree_view_column_set_title (col, _ ("Symbol"));
#line 625 "symbol.vala"
		renderer_pixbuf = (_tmp6_ = g_object_ref_sink ((GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ()), _g_object_unref0 (renderer_pixbuf), _tmp6_);
#line 626 "symbol.vala"
		gtk_cell_layout_pack_start ((GtkCellLayout*) col, (GtkCellRenderer*) renderer_pixbuf, FALSE);
#line 627 "symbol.vala"
		gtk_tree_view_column_set_attributes (col, (GtkCellRenderer*) renderer_pixbuf, "pixbuf", SYMBOL_BROWSER_COL_ICON, NULL);
#line 629 "symbol.vala"
		renderer = (_tmp7_ = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ()), _g_object_unref0 (renderer), _tmp7_);
#line 630 "symbol.vala"
		gtk_cell_layout_pack_start ((GtkCellLayout*) col, (GtkCellRenderer*) renderer, FALSE);
#line 631 "symbol.vala"
		gtk_tree_view_column_set_attributes (col, (GtkCellRenderer*) renderer, "markup", SYMBOL_BROWSER_COL_NAME, NULL);
#line 632 "symbol.vala"
		gtk_tree_view_append_column (self->priv->tree_view, col);
#line 636 "symbol.vala"
		self->priv->language_column = (_tmp8_ = g_object_ref_sink (gtk_tree_view_column_new ()), _g_object_unref0 (self->priv->language_column), _tmp8_);
#line 637 "symbol.vala"
		symbol_browser_set_show_language_column (self, valide_abstract_config_manager_get_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "show-language"));
#line 638 "symbol.vala"
		gtk_tree_view_column_set_title (self->priv->language_column, _ ("Language"));
#line 639 "symbol.vala"
		renderer = (_tmp9_ = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ()), _g_object_unref0 (renderer), _tmp9_);
#line 640 "symbol.vala"
		gtk_cell_layout_pack_start ((GtkCellLayout*) self->priv->language_column, (GtkCellRenderer*) renderer, TRUE);
#line 641 "symbol.vala"
		gtk_tree_view_column_set_attributes (self->priv->language_column, (GtkCellRenderer*) renderer, "text", SYMBOL_BROWSER_COL_LANGUAGE, NULL);
#line 642 "symbol.vala"
		gtk_tree_view_append_column (self->priv->tree_view, self->priv->language_column);
#line 644 "symbol.vala"
		self->priv->source_file_column = (_tmp10_ = g_object_ref_sink (gtk_tree_view_column_new ()), _g_object_unref0 (self->priv->source_file_column), _tmp10_);
#line 645 "symbol.vala"
		symbol_browser_set_show_source_file_column (self, valide_abstract_config_manager_get_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "show-source-file"));
#line 646 "symbol.vala"
		gtk_tree_view_column_set_title (self->priv->source_file_column, _ ("File"));
#line 647 "symbol.vala"
		renderer = (_tmp11_ = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ()), _g_object_unref0 (renderer), _tmp11_);
#line 648 "symbol.vala"
		gtk_cell_layout_pack_start ((GtkCellLayout*) self->priv->source_file_column, (GtkCellRenderer*) renderer, TRUE);
#line 649 "symbol.vala"
		gtk_tree_view_column_set_attributes (self->priv->source_file_column, (GtkCellRenderer*) renderer, "text", SYMBOL_BROWSER_COL_FILE, NULL);
#line 650 "symbol.vala"
		gtk_tree_view_append_column (self->priv->tree_view, self->priv->source_file_column);
#line 652 "symbol.vala"
		self->priv->line_number_column = (_tmp12_ = g_object_ref_sink (gtk_tree_view_column_new ()), _g_object_unref0 (self->priv->line_number_column), _tmp12_);
#line 653 "symbol.vala"
		symbol_browser_set_show_line_number_column (self, valide_abstract_config_manager_get_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "SymbolBrowser", "show-line-number"));
#line 654 "symbol.vala"
		gtk_tree_view_column_set_title (self->priv->line_number_column, _ ("Line"));
#line 655 "symbol.vala"
		renderer = (_tmp13_ = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ()), _g_object_unref0 (renderer), _tmp13_);
#line 656 "symbol.vala"
		gtk_cell_layout_pack_start ((GtkCellLayout*) self->priv->line_number_column, (GtkCellRenderer*) renderer, TRUE);
#line 657 "symbol.vala"
		gtk_tree_view_column_set_attributes (self->priv->line_number_column, (GtkCellRenderer*) renderer, "text", SYMBOL_BROWSER_COL_LINE, NULL);
#line 658 "symbol.vala"
		gtk_tree_view_append_column (self->priv->tree_view, self->priv->line_number_column);
#line 660 "symbol.vala"
		gtk_tree_view_set_model (self->priv->tree_view, (GtkTreeModel*) store);
#line 663 "symbol.vala"
		g_signal_connect_object (self->priv->tree_view, "row-activated", (GCallback) _symbol_browser_on_row_activated_gtk_tree_view_row_activated, self, 0);
#line 664 "symbol.vala"
		g_signal_connect_object (self->priv->tree_view, "cursor-changed", (GCallback) _symbol_browser_on_cursor_changed_gtk_tree_view_cursor_changed, self, 0);
#line 665 "symbol.vala"
		g_signal_connect_object (self->priv->tree_view, "row-expanded", (GCallback) _symbol_browser_on_row_expanded_gtk_tree_view_row_expanded, self, 0);
#line 666 "symbol.vala"
		g_signal_connect_object (self->priv->tree_view, "row-collapsed", (GCallback) _symbol_browser_on_row_collapsed_gtk_tree_view_row_collapsed, self, 0);
#line 668 "symbol.vala"
		self->priv->status_context = gtk_statusbar_get_context_id ((GtkStatusbar*) valide_window_get_statusbar (valide_plugin_get_window ((ValidePlugin*) self)), "valide_symbol_browser");
#line 670 "symbol.vala"
		gtk_widget_set_sensitive ((GtkWidget*) self->priv->box, FALSE);
#line 672 "symbol.vala"
		g_signal_connect_object (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), "tab-removed", (GCallback) _symbol_browser_populate_symbols_valide_document_manager_tab_removed, self, 0);
#line 673 "symbol.vala"
		g_signal_connect_object (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), "tab-changed", (GCallback) _symbol_browser_populate_symbols_valide_document_manager_tab_changed, self, 0);
#line 674 "symbol.vala"
		g_signal_connect_object (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), "tab-saved", (GCallback) _symbol_browser_populate_symbols_valide_document_manager_tab_saved, self, 0);
#line 2212 "symbol.c"
		{
			char* _tmp14_;
#line 678 "symbol.vala"
			valide_utils_register_icon (_tmp14_ = g_build_filename (PIXMAPS_DIR, "plugins", "symbol-browser.png", NULL), "symbol-browser-plugin-icon", &_inner_error_);
#line 2217 "symbol.c"
			_g_free0 (_tmp14_);
			if (_inner_error_ != NULL) {
				goto __catch3_g_error;
			}
		}
		goto __finally3;
		__catch3_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
#line 684 "symbol.vala"
				g_debug ("symbol.vala:684: %s", e->message);
#line 2232 "symbol.c"
				_g_error_free0 (e);
			}
		}
		__finally3:
		if (_inner_error_ != NULL) {
			_g_object_unref0 (store);
			_g_object_unref0 (col);
			_g_object_unref0 (scrolled);
			_g_object_unref0 (renderer);
			_g_object_unref0 (renderer_pixbuf);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
		}
#line 686 "symbol.vala"
		valide_window_add_widget (valide_plugin_get_window ((ValidePlugin*) self), (GtkWidget*) self->priv->box, "symbol-browser-plugin", _ ("Symbols"), VALIDE_WINDOW_PLACEMENT_LEFT, "symbol-browser-plugin-icon");
#line 2248 "symbol.c"
		_g_object_unref0 (store);
		_g_object_unref0 (col);
		_g_object_unref0 (scrolled);
		_g_object_unref0 (renderer);
		_g_object_unref0 (renderer_pixbuf);
	}
	return obj;
}


static void symbol_browser_class_init (SymbolBrowserClass * klass) {
	symbol_browser_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SymbolBrowserPrivate));
	G_OBJECT_CLASS (klass)->get_property = symbol_browser_get_property;
	G_OBJECT_CLASS (klass)->set_property = symbol_browser_set_property;
	G_OBJECT_CLASS (klass)->constructor = symbol_browser_constructor;
	G_OBJECT_CLASS (klass)->finalize = symbol_browser_finalize;
	g_object_class_override_property (G_OBJECT_CLASS (klass), SYMBOL_BROWSER_PATH, "path");
	g_object_class_override_property (G_OBJECT_CLASS (klass), SYMBOL_BROWSER_WINDOW, "window");
}


static void symbol_browser_valide_plugin_interface_init (ValidePluginIface * iface) {
	symbol_browser_valide_plugin_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_path = symbol_browser_real_get_path;
	iface->set_path = symbol_browser_real_set_path;
	iface->get_window = symbol_browser_real_get_window;
	iface->set_window = symbol_browser_real_set_window;
}


static void symbol_browser_instance_init (SymbolBrowser * self) {
	self->priv = SYMBOL_BROWSER_GET_PRIVATE (self);
}


static void symbol_browser_finalize (GObject* obj) {
	SymbolBrowser * self;
	self = SYMBOL_BROWSER (obj);
	{
		guint _tmp15_;
		guint _tmp16_;
		guint _tmp17_;
#line 697 "symbol.vala"
		g_signal_parse_name ("tab-removed", VALIDE_TYPE_DOCUMENT_MANAGER, &_tmp15_, NULL, FALSE);
#line 697 "symbol.vala"
		g_signal_handlers_disconnect_matched (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp15_, 0, NULL, (GCallback) _symbol_browser_populate_symbols_valide_document_manager_tab_removed, self);
#line 698 "symbol.vala"
		g_signal_parse_name ("tab-changed", VALIDE_TYPE_DOCUMENT_MANAGER, &_tmp16_, NULL, FALSE);
#line 698 "symbol.vala"
		g_signal_handlers_disconnect_matched (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp16_, 0, NULL, (GCallback) _symbol_browser_populate_symbols_valide_document_manager_tab_changed, self);
#line 699 "symbol.vala"
		g_signal_parse_name ("tab-saved", VALIDE_TYPE_DOCUMENT_MANAGER, &_tmp17_, NULL, FALSE);
#line 699 "symbol.vala"
		g_signal_handlers_disconnect_matched (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _symbol_browser_populate_symbols_valide_document_manager_tab_saved, self);
#line 701 "symbol.vala"
		valide_window_remove_widget (valide_plugin_get_window ((ValidePlugin*) self), (GtkWidget*) self->priv->box);
#line 2306 "symbol.c"
	}
	_g_object_unref0 (self->priv->box);
	_g_object_unref0 (self->priv->label);
	_g_object_unref0 (self->priv->model);
	_g_object_unref0 (self->priv->tree_view);
	__g_slist_free_g_free0 (self->priv->expanded_rows);
	_g_object_unref0 (self->priv->language_column);
	_g_object_unref0 (self->priv->source_file_column);
	_g_object_unref0 (self->priv->line_number_column);
	_g_hash_table_unref0 (self->priv->root_nodes);
	_g_free0 (self->priv->_path);
	_g_object_unref0 (self->priv->_window);
	G_OBJECT_CLASS (symbol_browser_parent_class)->finalize (obj);
}


GType symbol_browser_get_type (void) {
	static volatile gsize symbol_browser_type_id__volatile = 0;
	if (g_once_init_enter (&symbol_browser_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SymbolBrowserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) symbol_browser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SymbolBrowser), 0, (GInstanceInitFunc) symbol_browser_instance_init, NULL };
		static const GInterfaceInfo valide_plugin_info = { (GInterfaceInitFunc) symbol_browser_valide_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType symbol_browser_type_id;
		symbol_browser_type_id = g_type_register_static (G_TYPE_OBJECT, "SymbolBrowser", &g_define_type_info, 0);
		g_type_add_interface_static (symbol_browser_type_id, VALIDE_TYPE_PLUGIN, &valide_plugin_info);
		g_once_init_leave (&symbol_browser_type_id__volatile, symbol_browser_type_id);
	}
	return symbol_browser_type_id__volatile;
}


static void symbol_browser_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SymbolBrowser * self;
	self = SYMBOL_BROWSER (object);
	switch (property_id) {
		case SYMBOL_BROWSER_PATH:
		g_value_set_string (value, valide_plugin_get_path ((ValidePlugin*) self));
		break;
		case SYMBOL_BROWSER_WINDOW:
		g_value_set_object (value, valide_plugin_get_window ((ValidePlugin*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void symbol_browser_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SymbolBrowser * self;
	self = SYMBOL_BROWSER (object);
	switch (property_id) {
		case SYMBOL_BROWSER_PATH:
		valide_plugin_set_path ((ValidePlugin*) self, g_value_get_string (value));
		break;
		case SYMBOL_BROWSER_WINDOW:
		valide_plugin_set_window ((ValidePlugin*) self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


#line 748 "symbol.vala"
GType register_plugin (void* user_data, GError** error) {
#line 2373 "symbol.c"
	GType result = 0UL;
	result = TYPE_SYMBOL_BROWSER;
#line 750 "symbol.vala"
	return result;
#line 2378 "symbol.c"
}


#line 753 "symbol.vala"
GtkWidget* create_configure_dialog (SymbolBrowser* _self_) {
#line 2384 "symbol.c"
	GtkWidget* result = NULL;
#line 753 "symbol.vala"
	g_return_val_if_fail (_self_ != NULL, NULL);
#line 2388 "symbol.c"
	result = symbol_browser_create_configure_dialog (_self_);
#line 755 "symbol.vala"
	return result;
#line 2392 "symbol.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




