/* todo.c generated by valac, the Vala compiler
 * generated from todo.vala, do not modify */

/* todo-manager.vala
 *
 * Copyright (C) 2008-2010 Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <valide-0.0.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <config.h>
#include <gobject/gvaluecollector.h>


#define TYPE_TODO_ITEM (todo_item_get_type ())
#define TODO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TODO_ITEM, TodoItem))
#define TODO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TODO_ITEM, TodoItemClass))
#define IS_TODO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TODO_ITEM))
#define IS_TODO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TODO_ITEM))
#define TODO_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TODO_ITEM, TodoItemClass))

typedef struct _TodoItem TodoItem;
typedef struct _TodoItemClass TodoItemClass;
typedef struct _TodoItemPrivate TodoItemPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecTodoItem ParamSpecTodoItem;

#define TYPE_TODO (todo_get_type ())
#define TODO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TODO, Todo))
#define TODO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TODO, TodoClass))
#define IS_TODO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TODO))
#define IS_TODO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TODO))
#define TODO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TODO, TodoClass))

typedef struct _Todo Todo;
typedef struct _TodoClass TodoClass;
typedef struct _TodoPrivate TodoPrivate;

#define TODO_TYPE_COL (todo_col_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __g_list_free_g_object_unref0(var) ((var == NULL) ? NULL : (var = (_g_list_free_g_object_unref (var), NULL)))
#define __g_list_free_todo_item_unref0(var) ((var == NULL) ? NULL : (var = (_g_list_free_todo_item_unref (var), NULL)))
#define _todo_item_unref0(var) ((var == NULL) ? NULL : (var = (todo_item_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_match_info_free0(var) ((var == NULL) ? NULL : (var = (g_match_info_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _TodoItem {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TodoItemPrivate * priv;
	char* type;
	char* author;
	char* priority;
	char* text;
	char* file;
	gint line;
	ValideDocument* document;
};

struct _TodoItemClass {
	GTypeClass parent_class;
	void (*finalize) (TodoItem *self);
};

struct _ParamSpecTodoItem {
	GParamSpec parent_instance;
};

struct _Todo {
	GObject parent_instance;
	TodoPrivate * priv;
};

struct _TodoClass {
	GObjectClass parent_class;
};

struct _TodoPrivate {
	GtkTreeView* tree_view;
	ValideDocumentManager* documents;
	GtkScrolledWindow* scrolled_window;
	char* _path;
	ValideWindow* _window;
};

typedef enum  {
	TODO_COL_TYPE,
	TODO_COL_TEXT,
	TODO_COL_AUTHOR,
	TODO_COL_PRIORITY,
	TODO_COL_LINE,
	TODO_COL_FILE,
	TODO_COL_DOCUMENT,
	TODO_COL_NB
} TodoCol;


static gpointer todo_item_parent_class = NULL;
static gpointer todo_parent_class = NULL;
static ValidePluginIface* todo_valide_plugin_parent_iface = NULL;

gpointer todo_item_ref (gpointer instance);
void todo_item_unref (gpointer instance);
GParamSpec* param_spec_todo_item (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_todo_item (GValue* value, gpointer v_object);
void value_take_todo_item (GValue* value, gpointer v_object);
gpointer value_get_todo_item (const GValue* value);
GType todo_item_get_type (void);
enum  {
	TODO_ITEM_DUMMY_PROPERTY
};
TodoItem* todo_item_new (void);
TodoItem* todo_item_construct (GType object_type);
static void todo_item_finalize (TodoItem* obj);
GType todo_get_type (void);
#define TODO_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TODO, TodoPrivate))
enum  {
	TODO_DUMMY_PROPERTY,
	TODO_PATH,
	TODO_WINDOW
};
static GType todo_col_get_type (void) G_GNUC_UNUSED;
#define TODO_help_text _ ("Mark todo with `@(TODO|FIXME|CHANGED|NOTE|OPTIMIZE|IMPROVE|BUG) (autho" \
"r#priority#): to do'")
static void todo_on_row_activated (Todo* self, GtkTreeView* sender, GtkTreePath* path, GtkTreeViewColumn* column);
static gboolean todo_get_only_load_active_tab (Todo* self);
static void _g_list_free_g_object_unref (GList* self);
static GList* todo_parse (Todo* self, ValideDocument* d);
static void _g_list_free_todo_item_unref (GList* self);
static void todo_add_line (Todo* self, TodoItem* item);
static void todo_populate_list (Todo* self);
static void todo_on_tab_changed (Todo* self);
static void todo_set_only_load_active_tab (Todo* self, gboolean value);
static void _lambda0_ (GtkToggleButton* s, Todo* self);
static void __lambda0__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
GtkWidget* todo_create_configure_dialog (Todo* self);
Todo* todo_new (void);
Todo* todo_construct (GType object_type);
static void _todo_on_row_activated_gtk_tree_view_row_activated (GtkTreeView* _sender, GtkTreePath* path, GtkTreeViewColumn* column, gpointer self);
static void _todo_populate_list_valide_document_manager_tab_removed (ValideDocumentManager* _sender, ValideDocument* document, gpointer self);
static void _todo_on_tab_changed_valide_document_manager_tab_changed (ValideDocumentManager* _sender, ValideDocument* document, gpointer self);
static void _todo_populate_list_valide_document_manager_tab_saved (ValideDocumentManager* _sender, ValideDocument* document, gpointer self);
static GObject * todo_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void todo_finalize (GObject* obj);
static void todo_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void todo_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType register_plugin (void* user_data, GError** error);
GtkWidget* create_configure_dialog (Todo* _self_);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);



#line 24 "todo.vala"
TodoItem* todo_item_construct (GType object_type) {
#line 179 "todo.c"
	TodoItem* self;
	self = (TodoItem*) g_type_create_instance (object_type);
	return self;
}


#line 24 "todo.vala"
TodoItem* todo_item_new (void) {
#line 24 "todo.vala"
	return todo_item_construct (TYPE_TODO_ITEM);
#line 190 "todo.c"
}


static void value_todo_item_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_todo_item_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		todo_item_unref (value->data[0].v_pointer);
	}
}


static void value_todo_item_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = todo_item_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_todo_item_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_todo_item_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		TodoItem* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = todo_item_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_todo_item_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	TodoItem** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = todo_item_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_todo_item (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecTodoItem* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TODO_ITEM), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_todo_item (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TODO_ITEM), NULL);
	return value->data[0].v_pointer;
}


void value_set_todo_item (GValue* value, gpointer v_object) {
	TodoItem* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TODO_ITEM));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TODO_ITEM));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		todo_item_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		todo_item_unref (old);
	}
}


void value_take_todo_item (GValue* value, gpointer v_object) {
	TodoItem* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TODO_ITEM));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TODO_ITEM));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		todo_item_unref (old);
	}
}


static void todo_item_class_init (TodoItemClass * klass) {
	todo_item_parent_class = g_type_class_peek_parent (klass);
	TODO_ITEM_CLASS (klass)->finalize = todo_item_finalize;
}


static void todo_item_instance_init (TodoItem * self) {
	self->ref_count = 1;
}


static void todo_item_finalize (TodoItem* obj) {
	TodoItem * self;
	self = TODO_ITEM (obj);
	_g_free0 (self->type);
	_g_free0 (self->author);
	_g_free0 (self->priority);
	_g_free0 (self->text);
	_g_free0 (self->file);
}


GType todo_item_get_type (void) {
	static volatile gsize todo_item_type_id__volatile = 0;
	if (g_once_init_enter (&todo_item_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_todo_item_init, value_todo_item_free_value, value_todo_item_copy_value, value_todo_item_peek_pointer, "p", value_todo_item_collect_value, "p", value_todo_item_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (TodoItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) todo_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TodoItem), 0, (GInstanceInitFunc) todo_item_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType todo_item_type_id;
		todo_item_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TodoItem", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&todo_item_type_id__volatile, todo_item_type_id);
	}
	return todo_item_type_id__volatile;
}


gpointer todo_item_ref (gpointer instance) {
	TodoItem* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void todo_item_unref (gpointer instance) {
	TodoItem* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		TODO_ITEM_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static GType todo_col_get_type (void) {
	static volatile gsize todo_col_type_id__volatile = 0;
	if (g_once_init_enter (&todo_col_type_id__volatile)) {
		static const GEnumValue values[] = {{TODO_COL_TYPE, "TODO_COL_TYPE", "type"}, {TODO_COL_TEXT, "TODO_COL_TEXT", "text"}, {TODO_COL_AUTHOR, "TODO_COL_AUTHOR", "author"}, {TODO_COL_PRIORITY, "TODO_COL_PRIORITY", "priority"}, {TODO_COL_LINE, "TODO_COL_LINE", "line"}, {TODO_COL_FILE, "TODO_COL_FILE", "file"}, {TODO_COL_DOCUMENT, "TODO_COL_DOCUMENT", "document"}, {TODO_COL_NB, "TODO_COL_NB", "nb"}, {0, NULL, NULL}};
		GType todo_col_type_id;
		todo_col_type_id = g_enum_register_static ("TodoCol", values);
		g_once_init_leave (&todo_col_type_id__volatile, todo_col_type_id);
	}
	return todo_col_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 76 "todo.vala"
static void todo_on_row_activated (Todo* self, GtkTreeView* sender, GtkTreePath* path, GtkTreeViewColumn* column) {
#line 377 "todo.c"
	gint line = 0;
	ValideDocument* document;
	GtkTreeIter iter = {0};
	GtkTreeModel* model;
	GtkTreeModel* _tmp0_;
#line 76 "todo.vala"
	g_return_if_fail (self != NULL);
#line 76 "todo.vala"
	g_return_if_fail (sender != NULL);
#line 76 "todo.vala"
	g_return_if_fail (path != NULL);
#line 76 "todo.vala"
	g_return_if_fail (column != NULL);
#line 391 "todo.c"
	document = NULL;
	model = NULL;
#line 84 "todo.vala"
	model = (_tmp0_ = _g_object_ref0 (gtk_tree_view_get_model (self->priv->tree_view)), _g_object_unref0 (model), _tmp0_);
#line 85 "todo.vala"
	gtk_tree_model_get_iter (model, &iter, path);
#line 86 "todo.vala"
	gtk_tree_model_get (model, &iter, TODO_COL_LINE, &line, TODO_COL_DOCUMENT, &document, -1, -1);
#line 88 "todo.vala"
	valide_document_manager_set_current (self->priv->documents, document);
#line 89 "todo.vala"
	valide_source_view_goto_line (valide_document_get_text_view (document), line - 1);
#line 90 "todo.vala"
	gtk_widget_grab_focus ((GtkWidget*) document);
#line 406 "todo.c"
	_g_object_unref0 (document);
	_g_object_unref0 (model);
}


static void _g_list_free_g_object_unref (GList* self) {
	g_list_foreach (self, (GFunc) g_object_unref, NULL);
	g_list_free (self);
}


static void _g_list_free_todo_item_unref (GList* self) {
	g_list_foreach (self, (GFunc) todo_item_unref, NULL);
	g_list_free (self);
}


static gpointer _todo_item_ref0 (gpointer self) {
	return self ? todo_item_ref (self) : NULL;
}


#line 93 "todo.vala"
static void todo_populate_list (Todo* self) {
#line 431 "todo.c"
	GtkListStore* model;
	GtkListStore* _tmp1_;
	GtkTreeModel* _tmp0_;
#line 93 "todo.vala"
	g_return_if_fail (self != NULL);
#line 437 "todo.c"
	model = NULL;
#line 97 "todo.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self->priv->tree_view, FALSE);
#line 100 "todo.vala"
	model = (_tmp1_ = _g_object_ref0 ((_tmp0_ = gtk_tree_view_get_model (self->priv->tree_view), GTK_IS_LIST_STORE (_tmp0_) ? ((GtkListStore*) _tmp0_) : NULL)), _g_object_unref0 (model), _tmp1_);
#line 101 "todo.vala"
	gtk_list_store_clear (model);
#line 103 "todo.vala"
	if (valide_document_manager_get_current (self->priv->documents) != NULL) {
#line 447 "todo.c"
		gint nb_doc;
		gint nb_task;
		GList* _doc;
		GList* doc;
#line 105 "todo.vala"
		nb_doc = 0;
#line 106 "todo.vala"
		nb_task = 0;
#line 107 "todo.vala"
		_doc = NULL;
#line 108 "todo.vala"
		doc = NULL;
#line 111 "todo.vala"
		if (todo_get_only_load_active_tab (self)) {
#line 462 "todo.c"
			GList* _tmp2_;
#line 113 "todo.vala"
			_doc = (_tmp2_ = NULL, __g_list_free_g_object_unref0 (_doc), _tmp2_);
#line 114 "todo.vala"
			_doc = g_list_prepend (_doc, _g_object_ref0 (valide_document_manager_get_current (self->priv->documents)));
#line 115 "todo.vala"
			doc = _doc;
#line 470 "todo.c"
		} else {
#line 119 "todo.vala"
			doc = valide_document_manager_get_documents (self->priv->documents);
#line 474 "todo.c"
		}
		{
			GList* document_collection;
			GList* document_it;
#line 122 "todo.vala"
			document_collection = doc;
#line 481 "todo.c"
			for (document_it = document_collection; document_it != NULL; document_it = document_it->next) {
				ValideDocument* document;
#line 122 "todo.vala"
				document = _g_object_ref0 ((ValideDocument*) document_it->data);
#line 486 "todo.c"
				{
					GList* items;
					GList* _tmp3_;
					items = NULL;
#line 126 "todo.vala"
					nb_doc++;
#line 127 "todo.vala"
					items = (_tmp3_ = todo_parse (self, document), __g_list_free_todo_item_unref0 (items), _tmp3_);
#line 128 "todo.vala"
					if (items != NULL) {
#line 497 "todo.c"
						{
							GList* item_collection;
							GList* item_it;
#line 130 "todo.vala"
							item_collection = items;
#line 503 "todo.c"
							for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
								TodoItem* item;
#line 130 "todo.vala"
								item = _todo_item_ref0 ((TodoItem*) item_it->data);
#line 508 "todo.c"
								{
#line 132 "todo.vala"
									todo_add_line (self, item);
#line 133 "todo.vala"
									nb_task++;
#line 514 "todo.c"
									_todo_item_unref0 (item);
								}
							}
						}
					}
					_g_object_unref0 (document);
					__g_list_free_todo_item_unref0 (items);
				}
			}
		}
#line 137 "todo.vala"
		if (nb_doc > 0) {
#line 139 "todo.vala"
			gtk_widget_set_sensitive ((GtkWidget*) self->priv->tree_view, TRUE);
#line 140 "todo.vala"
			if (nb_task > 0) {
#line 142 "todo.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) self->priv->tree_view, NULL);
#line 533 "todo.c"
			} else {
#line 146 "todo.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) self->priv->tree_view, TODO_help_text);
#line 537 "todo.c"
			}
		} else {
#line 151 "todo.vala"
			gtk_widget_set_sensitive ((GtkWidget*) self->priv->tree_view, FALSE);
#line 542 "todo.c"
		}
		__g_list_free_g_object_unref0 (_doc);
	}
	_g_object_unref0 (model);
}


#line 156 "todo.vala"
static void todo_on_tab_changed (Todo* self) {
#line 156 "todo.vala"
	g_return_if_fail (self != NULL);
#line 158 "todo.vala"
	todo_populate_list (self);
#line 556 "todo.c"
}


#line 161 "todo.vala"
static void todo_add_line (Todo* self, TodoItem* item) {
#line 562 "todo.c"
	GtkTreeIter iter = {0};
	GtkListStore* list_store;
	GtkListStore* _tmp1_;
	GtkTreeModel* _tmp0_;
#line 161 "todo.vala"
	g_return_if_fail (self != NULL);
#line 161 "todo.vala"
	g_return_if_fail (item != NULL);
#line 571 "todo.c"
	list_store = NULL;
#line 166 "todo.vala"
	list_store = (_tmp1_ = _g_object_ref0 ((_tmp0_ = gtk_tree_view_get_model (self->priv->tree_view), GTK_IS_LIST_STORE (_tmp0_) ? ((GtkListStore*) _tmp0_) : NULL)), _g_object_unref0 (list_store), _tmp1_);
#line 167 "todo.vala"
	gtk_list_store_append (list_store, &iter);
#line 168 "todo.vala"
	gtk_list_store_set (list_store, &iter, TODO_COL_TYPE, item->type, TODO_COL_AUTHOR, item->author, TODO_COL_PRIORITY, item->priority, TODO_COL_TEXT, item->text, TODO_COL_LINE, item->line, TODO_COL_FILE, item->file, TODO_COL_DOCUMENT, item->document, -1);
#line 579 "todo.c"
	_g_object_unref0 (list_store);
}


#line 981 "glib-2.0.vapi"
static char* string_substring (const char* self, glong offset, glong len) {
#line 586 "todo.c"
	char* result = NULL;
	glong string_length;
	const char* start;
#line 981 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 982 "glib-2.0.vapi"
	string_length = g_utf8_strlen (self, -1);
#line 983 "glib-2.0.vapi"
	if (offset < 0) {
#line 984 "glib-2.0.vapi"
		offset = string_length + offset;
#line 985 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= 0, NULL);
#line 600 "todo.c"
	} else {
#line 987 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 604 "todo.c"
	}
#line 989 "glib-2.0.vapi"
	if (len < 0) {
#line 990 "glib-2.0.vapi"
		len = string_length - offset;
#line 610 "todo.c"
	}
#line 992 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 993 "glib-2.0.vapi"
	start = g_utf8_offset_to_pointer (self, offset);
#line 616 "todo.c"
	result = g_strndup (start, ((gchar*) g_utf8_offset_to_pointer (start, len)) - ((gchar*) start));
#line 994 "glib-2.0.vapi"
	return result;
#line 620 "todo.c"
}


#line 174 "todo.vala"
static GList* todo_parse (Todo* self, ValideDocument* d) {
#line 626 "todo.c"
	GList* result = NULL;
	GError * _inner_error_;
	char* text;
	gint _lines_size_;
	gint lines_length1;
	char** lines;
	GtkTextBuffer* buffer;
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	GList* items;
	GtkTextBuffer* _tmp0_;
	char* _tmp1_;
	char** _tmp3_;
	char** _tmp2_;
#line 174 "todo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 174 "todo.vala"
	g_return_val_if_fail (d != NULL, NULL);
#line 645 "todo.c"
	_inner_error_ = NULL;
	text = NULL;
	lines = (lines_length1 = 0, NULL);
	buffer = NULL;
#line 180 "todo.vala"
	items = NULL;
#line 182 "todo.vala"
	buffer = (_tmp0_ = _g_object_ref0 ((GtkTextBuffer*) valide_document_get_buffer (d)), _g_object_unref0 (buffer), _tmp0_);
#line 183 "todo.vala"
	gtk_text_buffer_get_start_iter (buffer, &start);
#line 184 "todo.vala"
	gtk_text_buffer_get_end_iter (buffer, &end);
#line 185 "todo.vala"
	text = (_tmp1_ = g_strdup (gtk_text_buffer_get_text (buffer, &start, &end, FALSE)), _g_free0 (text), _tmp1_);
#line 186 "todo.vala"
	lines = (_tmp3_ = _tmp2_ = g_strsplit (text, "\n", 0), lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL), lines_length1 = _vala_array_length (_tmp2_), _lines_size_ = lines_length1, _tmp3_);
#line 662 "todo.c"
	{
		GRegex* regex;
		GRegex* _tmp4_;
		GRegex* _tmp5_;
		regex = NULL;
#line 192 "todo.vala"
		_tmp4_ = g_regex_new ("@(TODO|FIXME|CHANGED|NOTE|OPTIMIZE|IMPROVE|BUG)\\s*(\\(([^#]*?)?(#(.*)" \
"#)?\\))?[:]?\\s*(.*)", G_REGEX_CASELESS, 0, &_inner_error_);
#line 670 "todo.c"
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (regex);
			goto __catch0_g_error;
		}
#line 192 "todo.vala"
		regex = (_tmp5_ = _tmp4_, _g_regex_unref0 (regex), _tmp5_);
#line 677 "todo.c"
		{
			gint i;
#line 194 "todo.vala"
			i = 0;
#line 682 "todo.c"
			{
				gboolean _tmp6_;
#line 194 "todo.vala"
				_tmp6_ = TRUE;
#line 194 "todo.vala"
				while (TRUE) {
#line 194 "todo.vala"
					if (!_tmp6_) {
#line 194 "todo.vala"
						i++;
#line 693 "todo.c"
					}
#line 194 "todo.vala"
					_tmp6_ = FALSE;
#line 194 "todo.vala"
					if (!(lines[i] != NULL)) {
#line 194 "todo.vala"
						break;
#line 701 "todo.c"
					}
					{
						GMatchInfo* match_info;
						GMatchInfo* _tmp9_;
						gboolean _tmp8_;
						GMatchInfo* _tmp7_ = NULL;
						gboolean _tmp10_;
						match_info = NULL;
#line 200 "todo.vala"
						_tmp10_ = (_tmp8_ = g_regex_match_full (regex, lines[i], (gssize) (-1), 0, 0, &_tmp7_, &_inner_error_), match_info = (_tmp9_ = _tmp7_, _g_match_info_free0 (match_info), _tmp9_), _tmp8_);
#line 712 "todo.c"
						if (_inner_error_ != NULL) {
							_g_match_info_free0 (match_info);
							goto __catch1_g_error;
						}
#line 200 "todo.vala"
						if (_tmp10_) {
#line 202 "todo.vala"
							while (TRUE) {
#line 721 "todo.c"
								TodoItem* item;
								TodoItem* _tmp11_;
								char* _tmp13_;
								char* _tmp12_;
								char* _tmp14_;
								char* _tmp15_;
								char* _tmp16_;
								char* _tmp18_;
								TodoItem* _tmp19_;
#line 202 "todo.vala"
								if (!g_match_info_matches (match_info)) {
#line 202 "todo.vala"
									break;
#line 735 "todo.c"
								}
								item = NULL;
#line 206 "todo.vala"
								item = (_tmp11_ = todo_item_new (), _todo_item_unref0 (item), _tmp11_);
#line 207 "todo.vala"
								item->type = (_tmp13_ = g_utf8_strup (_tmp12_ = g_match_info_fetch (match_info, 1), -1), _g_free0 (item->type), _tmp13_);
#line 742 "todo.c"
								_g_free0 (_tmp12_);
#line 208 "todo.vala"
								item->author = (_tmp14_ = g_match_info_fetch (match_info, 3), _g_free0 (item->author), _tmp14_);
#line 209 "todo.vala"
								item->priority = (_tmp15_ = g_match_info_fetch (match_info, 5), _g_free0 (item->priority), _tmp15_);
#line 210 "todo.vala"
								item->text = (_tmp16_ = g_match_info_fetch (match_info, 6), _g_free0 (item->text), _tmp16_);
#line 211 "todo.vala"
								if (g_str_has_suffix (item->text, "*/")) {
#line 752 "todo.c"
									char* _tmp17_;
#line 213 "todo.vala"
									item->text = (_tmp17_ = string_substring (item->text, (glong) 0, g_utf8_strlen (item->text, -1) - 2), _g_free0 (item->text), _tmp17_);
#line 756 "todo.c"
								}
#line 215 "todo.vala"
								item->document = d;
#line 216 "todo.vala"
								item->file = (_tmp18_ = g_strdup (valide_document_get_filename (d)), _g_free0 (item->file), _tmp18_);
#line 217 "todo.vala"
								item->line = i + 1;
#line 218 "todo.vala"
								items = g_list_append (items, (_tmp19_ = item, item = NULL, _tmp19_));
#line 219 "todo.vala"
								g_match_info_next (match_info, &_inner_error_);
#line 768 "todo.c"
								if (_inner_error_ != NULL) {
									_todo_item_unref0 (item);
									_g_match_info_free0 (match_info);
									goto __catch1_g_error;
								}
								_todo_item_unref0 (item);
							}
						}
						_g_match_info_free0 (match_info);
					}
					goto __finally1;
					__catch1_g_error:
					{
						GError * e;
						e = _inner_error_;
						_inner_error_ = NULL;
						{
#line 225 "todo.vala"
							g_warning ("todo.vala:225: %s", e->message);
#line 788 "todo.c"
							_g_error_free0 (e);
						}
					}
					__finally1:
					if (_inner_error_ != NULL) {
						_g_regex_unref0 (regex);
						goto __catch0_g_error;
					}
				}
			}
		}
		_g_regex_unref0 (regex);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 231 "todo.vala"
			g_debug ("todo.vala:231: %s", e->message);
#line 811 "todo.c"
			_g_error_free0 (e);
		}
	}
	__finally0:
	if (_inner_error_ != NULL) {
		_g_free0 (text);
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
		_g_object_unref0 (buffer);
		__g_list_free_todo_item_unref0 (items);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = items;
	_g_free0 (text);
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
	_g_object_unref0 (buffer);
#line 233 "todo.vala"
	return result;
#line 831 "todo.c"
}


#line 322 "todo.vala"
static void _lambda0_ (GtkToggleButton* s, Todo* self) {
#line 322 "todo.vala"
	g_return_if_fail (s != NULL);
#line 323 "todo.vala"
	todo_set_only_load_active_tab (self, gtk_toggle_button_get_active (s));
#line 841 "todo.c"
}


#line 322 "todo.vala"
static void __lambda0__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
#line 847 "todo.c"
	_lambda0_ (_sender, self);
}


#line 313 "todo.vala"
GtkWidget* todo_create_configure_dialog (Todo* self) {
#line 854 "todo.c"
	GtkWidget* result = NULL;
	GtkVBox* vbox;
	GtkCheckButton* check;
	GtkVBox* _tmp0_;
	GtkCheckButton* _tmp1_;
#line 313 "todo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 862 "todo.c"
	vbox = NULL;
	check = NULL;
#line 318 "todo.vala"
	vbox = (_tmp0_ = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (TRUE, 0)), _g_object_unref0 (vbox), _tmp0_);
#line 320 "todo.vala"
	check = (_tmp1_ = g_object_ref_sink ((GtkCheckButton*) gtk_check_button_new_with_label (_ ("Only load symbols for active tab"))), _g_object_unref0 (check), _tmp1_);
#line 321 "todo.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) check, todo_get_only_load_active_tab (self));
#line 322 "todo.vala"
	g_signal_connect_object ((GtkToggleButton*) check, "toggled", (GCallback) __lambda0__gtk_toggle_button_toggled, self, 0);
#line 325 "todo.vala"
	gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) check, TRUE, TRUE, (guint) 0);
#line 875 "todo.c"
	result = (GtkWidget*) vbox;
	_g_object_unref0 (check);
#line 327 "todo.vala"
	return result;
#line 880 "todo.c"
}


#line 35 "todo.vala"
Todo* todo_construct (GType object_type) {
#line 886 "todo.c"
	Todo * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


#line 35 "todo.vala"
Todo* todo_new (void) {
#line 35 "todo.vala"
	return todo_construct (TYPE_TODO);
#line 897 "todo.c"
}


static const char* todo_real_get_path (ValidePlugin* base) {
	const char* result;
	Todo* self;
	self = (Todo*) base;
	result = self->priv->_path;
#line 57 "todo.vala"
	return result;
#line 908 "todo.c"
}


static void todo_real_set_path (ValidePlugin* base, const char* value) {
	Todo* self;
	char* _tmp0_;
	self = (Todo*) base;
	self->priv->_path = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_path), _tmp0_);
	g_object_notify ((GObject *) self, "path");
}


static ValideWindow* todo_real_get_window (ValidePlugin* base) {
	ValideWindow* result;
	Todo* self;
	self = (Todo*) base;
	result = self->priv->_window;
#line 61 "todo.vala"
	return result;
#line 928 "todo.c"
}


static void todo_real_set_window (ValidePlugin* base, ValideWindow* value) {
	Todo* self;
	ValideWindow* _tmp0_;
	self = (Todo*) base;
	self->priv->_window = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_window), _tmp0_);
	g_object_notify ((GObject *) self, "window");
}


static gboolean todo_get_only_load_active_tab (Todo* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = valide_abstract_config_manager_get_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "Todo", "only-load-active-tab");
#line 67 "todo.vala"
	return result;
#line 947 "todo.c"
}


static void todo_set_only_load_active_tab (Todo* self, gboolean value) {
	g_return_if_fail (self != NULL);
#line 71 "todo.vala"
	valide_abstract_config_manager_set_boolean ((ValideAbstractConfigManager*) valide_window_get_config_manager (valide_plugin_get_window ((ValidePlugin*) self)), "Todo", "only-load-active-tab", value);
#line 72 "todo.vala"
	todo_populate_list (self);
#line 957 "todo.c"
}


#line 76 "todo.vala"
static void _todo_on_row_activated_gtk_tree_view_row_activated (GtkTreeView* _sender, GtkTreePath* path, GtkTreeViewColumn* column, gpointer self) {
#line 963 "todo.c"
	todo_on_row_activated (self, _sender, path, column);
}


#line 93 "todo.vala"
static void _todo_populate_list_valide_document_manager_tab_removed (ValideDocumentManager* _sender, ValideDocument* document, gpointer self) {
#line 970 "todo.c"
	todo_populate_list (self);
}


#line 156 "todo.vala"
static void _todo_on_tab_changed_valide_document_manager_tab_changed (ValideDocumentManager* _sender, ValideDocument* document, gpointer self) {
#line 977 "todo.c"
	todo_on_tab_changed (self);
}


#line 93 "todo.vala"
static void _todo_populate_list_valide_document_manager_tab_saved (ValideDocumentManager* _sender, ValideDocument* document, gpointer self) {
#line 984 "todo.c"
	todo_populate_list (self);
}


static GObject * todo_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	Todo * self;
	GError * _inner_error_;
	parent_class = G_OBJECT_CLASS (todo_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = TODO (obj);
	_inner_error_ = NULL;
	{
		GtkListStore* list_store;
		GtkTreeViewColumn* column;
		GtkCellRendererText* render;
		GtkScrolledWindow* _tmp0_;
		GtkListStore* _tmp1_;
		GtkTreeView* _tmp2_;
		GtkCellRendererText* _tmp3_;
		GtkTreeViewColumn* _tmp4_;
		GtkCellRendererText* _tmp5_;
		GtkTreeViewColumn* _tmp6_;
		GtkCellRendererText* _tmp7_;
		GtkTreeViewColumn* _tmp8_;
		GtkCellRendererText* _tmp9_;
		GtkTreeViewColumn* _tmp10_;
		GtkCellRendererText* _tmp11_;
		GtkTreeViewColumn* _tmp12_;
		GtkCellRendererText* _tmp13_;
		GtkTreeViewColumn* _tmp14_;
		ValideDocumentManager* _tmp15_;
		list_store = NULL;
		column = NULL;
		render = NULL;
#line 242 "todo.vala"
		self->priv->scrolled_window = (_tmp0_ = g_object_ref_sink ((GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL)), _g_object_unref0 (self->priv->scrolled_window), _tmp0_);
#line 244 "todo.vala"
		gtk_scrolled_window_set_policy (self->priv->scrolled_window, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
#line 247 "todo.vala"
		list_store = (_tmp1_ = gtk_list_store_new ((gint) TODO_COL_NB, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_INT, G_TYPE_STRING, G_TYPE_OBJECT, NULL), _g_object_unref0 (list_store), _tmp1_);
#line 252 "todo.vala"
		self->priv->tree_view = (_tmp2_ = g_object_ref_sink ((GtkTreeView*) gtk_tree_view_new_with_model ((GtkTreeModel*) list_store)), _g_object_unref0 (self->priv->tree_view), _tmp2_);
#line 253 "todo.vala"
		g_signal_connect_object (self->priv->tree_view, "row-activated", (GCallback) _todo_on_row_activated_gtk_tree_view_row_activated, self, 0);
#line 254 "todo.vala"
		gtk_container_add ((GtkContainer*) self->priv->scrolled_window, (GtkWidget*) self->priv->tree_view);
#line 257 "todo.vala"
		render = (_tmp3_ = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ()), _g_object_unref0 (render), _tmp3_);
#line 258 "todo.vala"
		column = (_tmp4_ = g_object_ref_sink (gtk_tree_view_column_new_with_attributes (_ ("Type"), (GtkCellRenderer*) render, "text", TODO_COL_TYPE, NULL, NULL)), _g_object_unref0 (column), _tmp4_);
#line 259 "todo.vala"
		gtk_tree_view_append_column (self->priv->tree_view, column);
#line 261 "todo.vala"
		render = (_tmp5_ = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ()), _g_object_unref0 (render), _tmp5_);
#line 262 "todo.vala"
		column = (_tmp6_ = g_object_ref_sink (gtk_tree_view_column_new_with_attributes (_ ("Author"), (GtkCellRenderer*) render, "text", TODO_COL_AUTHOR, NULL, NULL)), _g_object_unref0 (column), _tmp6_);
#line 263 "todo.vala"
		gtk_tree_view_append_column (self->priv->tree_view, column);
#line 265 "todo.vala"
		render = (_tmp7_ = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ()), _g_object_unref0 (render), _tmp7_);
#line 266 "todo.vala"
		column = (_tmp8_ = g_object_ref_sink (gtk_tree_view_column_new_with_attributes (_ ("Priority"), (GtkCellRenderer*) render, "text", TODO_COL_PRIORITY, NULL, NULL)), _g_object_unref0 (column), _tmp8_);
#line 267 "todo.vala"
		gtk_tree_view_append_column (self->priv->tree_view, column);
#line 269 "todo.vala"
		render = (_tmp9_ = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ()), _g_object_unref0 (render), _tmp9_);
#line 270 "todo.vala"
		column = (_tmp10_ = g_object_ref_sink (gtk_tree_view_column_new_with_attributes (_ ("Text"), (GtkCellRenderer*) render, "text", TODO_COL_TEXT, NULL, NULL)), _g_object_unref0 (column), _tmp10_);
#line 271 "todo.vala"
		gtk_tree_view_append_column (self->priv->tree_view, column);
#line 273 "todo.vala"
		render = (_tmp11_ = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ()), _g_object_unref0 (render), _tmp11_);
#line 274 "todo.vala"
		column = (_tmp12_ = g_object_ref_sink (gtk_tree_view_column_new_with_attributes (_ ("Line"), (GtkCellRenderer*) render, "text", TODO_COL_LINE, NULL, NULL)), _g_object_unref0 (column), _tmp12_);
#line 275 "todo.vala"
		gtk_tree_view_append_column (self->priv->tree_view, column);
#line 277 "todo.vala"
		render = (_tmp13_ = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ()), _g_object_unref0 (render), _tmp13_);
#line 278 "todo.vala"
		column = (_tmp14_ = g_object_ref_sink (gtk_tree_view_column_new_with_attributes (_ ("File"), (GtkCellRenderer*) render, "text", TODO_COL_FILE, NULL, NULL)), _g_object_unref0 (column), _tmp14_);
#line 279 "todo.vala"
		gtk_tree_view_append_column (self->priv->tree_view, column);
#line 281 "todo.vala"
		self->priv->documents = (_tmp15_ = _g_object_ref0 (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self))), _g_object_unref0 (self->priv->documents), _tmp15_);
#line 283 "todo.vala"
		g_signal_connect_object (self->priv->documents, "tab-removed", (GCallback) _todo_populate_list_valide_document_manager_tab_removed, self, 0);
#line 284 "todo.vala"
		g_signal_connect_object (self->priv->documents, "tab-changed", (GCallback) _todo_on_tab_changed_valide_document_manager_tab_changed, self, 0);
#line 285 "todo.vala"
		g_signal_connect_object (self->priv->documents, "tab-saved", (GCallback) _todo_populate_list_valide_document_manager_tab_saved, self, 0);
#line 287 "todo.vala"
		gtk_widget_set_sensitive ((GtkWidget*) self->priv->tree_view, FALSE);
#line 1079 "todo.c"
		{
			char* _tmp16_;
#line 291 "todo.vala"
			valide_utils_register_icon (_tmp16_ = g_build_filename (PIXMAPS_DIR, "plugins", "todo.png", NULL), "todo-plugin-icon", &_inner_error_);
#line 1084 "todo.c"
			_g_free0 (_tmp16_);
			if (_inner_error_ != NULL) {
				goto __catch2_g_error;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
#line 297 "todo.vala"
				g_debug ("todo.vala:297: %s", e->message);
#line 1099 "todo.c"
				_g_error_free0 (e);
			}
		}
		__finally2:
		if (_inner_error_ != NULL) {
			_g_object_unref0 (list_store);
			_g_object_unref0 (column);
			_g_object_unref0 (render);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
		}
#line 299 "todo.vala"
		valide_window_add_widget (valide_plugin_get_window ((ValidePlugin*) self), (GtkWidget*) self->priv->scrolled_window, "todo-plugin", _ ("Todo"), VALIDE_WINDOW_PLACEMENT_BOTTOM, "todo-plugin-icon");
#line 1113 "todo.c"
		_g_object_unref0 (list_store);
		_g_object_unref0 (column);
		_g_object_unref0 (render);
	}
	return obj;
}


static void todo_class_init (TodoClass * klass) {
	todo_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (TodoPrivate));
	G_OBJECT_CLASS (klass)->get_property = todo_get_property;
	G_OBJECT_CLASS (klass)->set_property = todo_set_property;
	G_OBJECT_CLASS (klass)->constructor = todo_constructor;
	G_OBJECT_CLASS (klass)->finalize = todo_finalize;
	g_object_class_override_property (G_OBJECT_CLASS (klass), TODO_PATH, "path");
	g_object_class_override_property (G_OBJECT_CLASS (klass), TODO_WINDOW, "window");
}


static void todo_valide_plugin_interface_init (ValidePluginIface * iface) {
	todo_valide_plugin_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_path = todo_real_get_path;
	iface->set_path = todo_real_set_path;
	iface->get_window = todo_real_get_window;
	iface->set_window = todo_real_set_window;
}


static void todo_instance_init (Todo * self) {
	self->priv = TODO_GET_PRIVATE (self);
}


static void todo_finalize (GObject* obj) {
	Todo * self;
	self = TODO (obj);
	{
		guint _tmp17_;
		guint _tmp18_;
		guint _tmp19_;
		guint _tmp20_;
#line 305 "todo.vala"
		g_signal_parse_name ("tab-removed", VALIDE_TYPE_DOCUMENT_MANAGER, &_tmp17_, NULL, FALSE);
#line 305 "todo.vala"
		g_signal_handlers_disconnect_matched (self->priv->documents, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _todo_populate_list_valide_document_manager_tab_removed, self);
#line 306 "todo.vala"
		g_signal_parse_name ("tab-changed", VALIDE_TYPE_DOCUMENT_MANAGER, &_tmp18_, NULL, FALSE);
#line 306 "todo.vala"
		g_signal_handlers_disconnect_matched (self->priv->documents, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp18_, 0, NULL, (GCallback) _todo_on_tab_changed_valide_document_manager_tab_changed, self);
#line 307 "todo.vala"
		g_signal_parse_name ("tab-saved", VALIDE_TYPE_DOCUMENT_MANAGER, &_tmp19_, NULL, FALSE);
#line 307 "todo.vala"
		g_signal_handlers_disconnect_matched (self->priv->documents, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp19_, 0, NULL, (GCallback) _todo_populate_list_valide_document_manager_tab_saved, self);
#line 308 "todo.vala"
		g_signal_parse_name ("row-activated", GTK_TYPE_TREE_VIEW, &_tmp20_, NULL, FALSE);
#line 308 "todo.vala"
		g_signal_handlers_disconnect_matched (self->priv->tree_view, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp20_, 0, NULL, (GCallback) _todo_on_row_activated_gtk_tree_view_row_activated, self);
#line 310 "todo.vala"
		valide_window_remove_widget (valide_plugin_get_window ((ValidePlugin*) self), (GtkWidget*) self->priv->scrolled_window);
#line 1174 "todo.c"
	}
	_g_object_unref0 (self->priv->tree_view);
	_g_object_unref0 (self->priv->documents);
	_g_object_unref0 (self->priv->scrolled_window);
	_g_free0 (self->priv->_path);
	_g_object_unref0 (self->priv->_window);
	G_OBJECT_CLASS (todo_parent_class)->finalize (obj);
}


GType todo_get_type (void) {
	static volatile gsize todo_type_id__volatile = 0;
	if (g_once_init_enter (&todo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TodoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) todo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Todo), 0, (GInstanceInitFunc) todo_instance_init, NULL };
		static const GInterfaceInfo valide_plugin_info = { (GInterfaceInitFunc) todo_valide_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType todo_type_id;
		todo_type_id = g_type_register_static (G_TYPE_OBJECT, "Todo", &g_define_type_info, 0);
		g_type_add_interface_static (todo_type_id, VALIDE_TYPE_PLUGIN, &valide_plugin_info);
		g_once_init_leave (&todo_type_id__volatile, todo_type_id);
	}
	return todo_type_id__volatile;
}


static void todo_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Todo * self;
	self = TODO (object);
	switch (property_id) {
		case TODO_PATH:
		g_value_set_string (value, valide_plugin_get_path ((ValidePlugin*) self));
		break;
		case TODO_WINDOW:
		g_value_set_object (value, valide_plugin_get_window ((ValidePlugin*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void todo_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Todo * self;
	self = TODO (object);
	switch (property_id) {
		case TODO_PATH:
		valide_plugin_set_path ((ValidePlugin*) self, g_value_get_string (value));
		break;
		case TODO_WINDOW:
		valide_plugin_set_window ((ValidePlugin*) self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


#line 332 "todo.vala"
GType register_plugin (void* user_data, GError** error) {
#line 1235 "todo.c"
	GType result = 0UL;
	result = TYPE_TODO;
#line 334 "todo.vala"
	return result;
#line 1240 "todo.c"
}


#line 337 "todo.vala"
GtkWidget* create_configure_dialog (Todo* _self_) {
#line 1246 "todo.c"
	GtkWidget* result = NULL;
#line 337 "todo.vala"
	g_return_val_if_fail (_self_ != NULL, NULL);
#line 1250 "todo.c"
	result = todo_create_configure_dialog (_self_);
#line 339 "todo.vala"
	return result;
#line 1254 "todo.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}




